App.Events.attackReport = function() {
	V.nextButton = "Continue";
	V.nextLink = "Scheduled Event";
	V.encyclopedia = "Battles";
	const node = new DocumentFragment();
	let r = [];
	const {
		HisA,
		himA,
	} = getPronouns(V.assistant.personality > 0 ? assistant.pronouns().main : {pronoun: App.Data.Pronouns.Kind.ai}).appendSuffix("A");
	const {hisP} = getPronouns(V.PC).appendSuffix("P");

	/* init*/
	const oldRep = V.rep;
	const oldAuth = V.SecExp.core.authority;
	V.SecExp.war.attacker.losses = Math.trunc(V.SecExp.war.attacker.losses);
	if (V.SecExp.war.attacker.losses > V.SecExp.war.attacker.troops) {
		V.SecExp.war.attacker.losses = V.SecExp.war.attacker.troops;
	}
	V.SecExp.core.totalKills += V.SecExp.war.attacker.losses;
	V.SecExp.war.losses = Math.trunc(V.SecExp.war.losses);
	let loot = 0;
	let lostSlaves;
	let captives;
	const lossesList = [];

	/* result */
	const majorBattleMod = (V.majorBattle === 0) ? 1 : 2;
	if (V.majorBattle !== 0) {
		V.SecExp.battles.major++;
	}
	if (V.SecExp.war.result === 3) {
		App.UI.DOM.makeElement("h1", `Victory!`, "strong");
		V.SecExp.battles.lossStreak = 0;
		V.SecExp.battles.victoryStreak += 1;
		V.SecExp.battles.victories++;
	} else if (V.SecExp.war.result === -3) {
		App.UI.DOM.makeElement("h1", `Defeat!`, "strong");
		V.SecExp.battles.lossStreak += 1;
		V.SecExp.battles.victoryStreak = 0;
		V.SecExp.battles.losses++;
	} else if (V.SecExp.war.result === 2) {
		App.UI.DOM.makeElement("h1", `Partial victory!`, "strong");
		V.SecExp.battles.victories++;
	} else if (V.SecExp.war.result === -2) {
		App.UI.DOM.makeElement("h1", `Partial defeat!`, "strong");
		V.SecExp.battles.losses++;
	} else if (V.SecExp.war.result === -1) {
		App.UI.DOM.makeElement("h1", `We surrendered`, "strong");
		V.SecExp.battles.losses++;
	} else if (V.SecExp.war.result === 0) {
		App.UI.DOM.makeElement("h1", `Failed bribery!`, "strong");
		V.SecExp.battles.losses++;
	} else if (V.SecExp.war.result === 1) {
		App.UI.DOM.makeElement("h1", `Successful bribery!`, "strong");
		V.SecExp.battles.victories++;
	}
	let end = (V.SecExp.battles.victoryStreak >= 2 || V.SecExp.battles.lossStreak >= 2) ? `,` : `.`;
	if (V.SecExp.war.attacker.type === "raiders") {
		r.push(`Today, ${asDateString(V.week, random(0, 7))}, our arcology was attacked by a band of wild raiders, ${num(Math.trunc(V.SecExp.war.attacker.troops))} men strong.`);
		if (V.SecExp.war.result !== 1 && V.SecExp.war.result !== 0 && V.SecExp.war.result !== -1) {
			r.push(`Our defense forces, ${num(Math.trunc(App.SecExp.battle.troopCount()))} strong, clashed with them`);
			if (V.SecExp.war.terrain === "urban") {
				r.push(`in the streets of`);
				if (V.SecExp.war.terrain === "urban") {
					r.push(`the old world city surrounding the arcology,`);
				} else {
					r.push(`of the free city,`);
				}
			} else if (V.SecExp.war.terrain === "rural") {
				r.push(`in the rural land surrounding the free city,`);
			} else if (V.SecExp.war.terrain === "hills") {
				r.push(`on the hills around the free city,`);
			} else if (V.SecExp.war.terrain === "coast") {
				r.push(`along the coast just outside the free city,`);
			} else if (V.SecExp.war.terrain === "outskirts") {
				r.push(`just against the walls of the arcology,`);
			} else if (V.SecExp.war.terrain === "mountains") {
				r.push(`in the mountains overlooking the arcology,`);
			} else if (V.SecExp.war.terrain === "wasteland") {
				r.push(`in the wastelands outside the free city territory,`);
			}
			if (V.SecExp.war.attacker.losses !== V.SecExp.war.attacker.troops) {
				r.push(`inflicting`);
				num(Math.trunc(V.SecExp.war.attacker.losses));
				r.push(`casualties, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty`);
				} else {
					r.push(`zero`);
				}
				r.push(`themselves.`);
			} else {
				r.push(`completely annihilating their troops, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties.`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty.`);
				} else {
					r.push(`zero casualties.`);
				}
			}
		}
		if (V.SecExp.war.result === 3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men easily stopped the disorganized horde's futile attempt at raiding your arcology${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard, but in the end our men stopped the disorganized horde attempt at raiding your arcology${end}`);
			} else {
				r.push(`The fight was long and hard, but our men managed to stop the horde raiding party${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`adding another victory to the growing list of our military's successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`finally putting an end to a series of unfortunate defeats.`);
			}
		} else if (V.SecExp.war.result === -3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men were easily crushed by the barbaric horde of raiders${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard and in the end the bandits proved too much to handle for our men${end}`);
			} else {
				r.push(`The fight was long and hard, but despite their bravery the horde proved too much for our men${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`so interrupting a long series of military successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`confirming the long list of recent failures our armed forces collected.`);
			}
		} else if (V.SecExp.war.result === 2) {
			r.push(`The fight was long and hard, but in the end our men managed to repel the raiders, though not without difficulty.`);
		} else if (V.SecExp.war.result === -2) {
			r.push(`The fight was long and hard. Our men in the end had to yield to the horde raiders, which was fortunately unable to capitalized on their victory.`);
		} else if (V.SecExp.war.result === -1) {
			r.push(`You gave your troops the order to surrender, obediently they stand down.`);
		} else if (V.SecExp.war.result === 0) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		} else if (V.SecExp.war.result === 1) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		}
	} else if (V.SecExp.war.attacker.type === "free city") {
		r.push(`Today, ${asDateString(V.week, random(0, 7))}, our arcology was attacked by a contingent of mercenaries hired by a competing free city, ${num(Math.trunc(V.SecExp.war.attacker.troops))} men strong.`);
		if (V.SecExp.war.result !== 1 && V.SecExp.war.result !== 0 && V.SecExp.war.result !== -1) {
			r.push(`Our defense forces, ${num(Math.trunc(App.SecExp.battle.troopCount()))} strong, clashed with them`);
			if (V.SecExp.war.terrain === "urban") {
				r.push(`in the streets of`);
				if (V.SecExp.war.terrain === "urban") {
					r.push(`the old world city surrounding the arcology,`);
				} else {
					r.push(`of the free city,`);
				}
			} else if (V.SecExp.war.terrain === "rural") {
				r.push(`in the rural land surrounding the free city,`);
			} else if (V.SecExp.war.terrain === "hills") {
				r.push(`on the hills around the free city,`);
			} else if (V.SecExp.war.terrain === "coast") {
				r.push(`along the coast just outside the free city,`);
			} else if (V.SecExp.war.terrain === "outskirts") {
				r.push(`just against the walls of the arcology,`);
			} else if (V.SecExp.war.terrain === "mountains") {
				r.push(`in the mountains overlooking the arcology,`);
			} else if (V.SecExp.war.terrain === "wasteland") {
				r.push(`in the wastelands outside the free city territory,`);
			}
			if (V.SecExp.war.attacker.losses !== V.SecExp.war.attacker.troops) {
				r.push(`inflicting ${V.SecExp.war.attacker.losses} casualties, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty`);
				} else {
					r.push(`zero`);
				}
				r.push(`themselves.`);
			} else {
				r.push(`completely annihilating their troops, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties.`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty.`);
				} else {
					r.push(`zero casualties.`);
				}
			}
		}
		if (V.SecExp.war.result === 3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men easily stopped the mercenaries dead in their tracks${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard, but in the end our men stopped the slavers attempt at weakening your arcology${end}`);
			} else {
				r.push(`The fight was long and hard, but our men managed to stop the free city mercenaries${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`adding another victory to the growing list of our military's successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`finally putting an end to a series of unfortunate defeats.`);
			}
		} else if (V.SecExp.war.result === -3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men were easily crushed by the consumed mercenary veterans sent against us${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard and in the end the slavers proved too much to handle for our men${end}`);
			} else {
				r.push(`The fight was long and hard, but despite their bravery the mercenary slavers proved too much for our men${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`so interrupting a long series of military successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`confirming the long list of recent failures our armed forces collected.`);
			}
		} else if (V.SecExp.war.result === 2) {
			r.push(`The fight was long and hard, but in the end our men managed to repel the mercenaries, though not without difficulty.`);
		} else if (V.SecExp.war.result === -2) {
			r.push(`The fight was long and hard. Our men in the end had to yield to the slavers, which were fortunately unable to capitalized on their victory.`);
		} else if (V.SecExp.war.result === -1) {
			r.push(`You gave your troops the order to surrender, obediently they stand down.`);
		} else if (V.SecExp.war.result === 0) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		} else if (V.SecExp.war.result === 1) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		}
	} else if (V.SecExp.war.attacker.type === "freedom fighters") {
		r.push(`Today, ${asDateString(V.week, random(0, 7))}, our arcology was attacked by a group of freedom fighters bent on the destruction of the institution of slavery, ${num(Math.trunc(V.SecExp.war.attacker.troops))} men strong.`);
		if (V.SecExp.war.result !== 1 && V.SecExp.war.result !== 0 && V.SecExp.war.result !== -1) {
			r.push(`Our defense forces, ${num(Math.trunc(App.SecExp.battle.troopCount()))} strong, clashed with them`);
			if (V.SecExp.war.terrain === "urban") {
				r.push(`in the streets of`);
				if (V.SecExp.war.terrain === "urban") {
					r.push(`the old world city surrounding the arcology,`);
				} else {
					r.push(`of the free city,`);
				}
			} else if (V.SecExp.war.terrain === "rural") {
				r.push(`in the rural land surrounding the free city,`);
			} else if (V.SecExp.war.terrain === "hills") {
				r.push(`on the hills around the free city,`);
			} else if (V.SecExp.war.terrain === "coast") {
				r.push(`along the coast just outside the free city,`);
			} else if (V.SecExp.war.terrain === "outskirts") {
				r.push(`just against the walls of the arcology,`);
			} else if (V.SecExp.war.terrain === "mountains") {
				r.push(`in the mountains overlooking the arcology,`);
			} else if (V.SecExp.war.terrain === "wasteland") {
				r.push(`in the wastelands outside the free city territory,`);
			}
			if (V.SecExp.war.attacker.losses !== V.SecExp.war.attacker.troops) {
				r.push(`inflicting ${V.SecExp.war.attacker.losses} casualties, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty`);
				} else {
					r.push(`zero`);
				}
				r.push(`themselves.`);
			} else {
				r.push(`completely annihilating their troops, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties.`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty.`);
				} else {
					r.push(`zero casualties.`);
				}
			}
		}
		if (V.SecExp.war.result === 3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men easily stopped the freedom fighters dead in their tracks${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard, but in the end our men stopped the fighters attack${end}`);
			} else {
				r.push(`The fight was long and hard, but our men managed to stop the freedom fighters${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`adding another victory to the growing list of our military's successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`finally putting an end to a series of unfortunate defeats.`);
			}
		} else if (V.SecExp.war.result === -3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men were easily crushed by the fanatical fury of the freedom fighters${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard and in the end the freedom fighters proved too much to handle for our men${end}`);
			} else {
				r.push(`The fight was long and hard, but despite their bravery the freedom fighters fury proved too much for our men${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`so interrupting a long series of military successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`confirming the long list of recent failures our armed forces collected.`);
			}
		} else if (V.SecExp.war.result === 2) {
			r.push(`The fight was long and hard, but in the end our men managed to repel the freedom fighters, though not without difficulty.`);
		} else if (V.SecExp.war.result === -2) {
			r.push(`The fight was long and hard. Our men in the end had to yield to the freedom fighters, which were fortunately unable to capitalized on their victory.`);
		} else if (V.SecExp.war.result === -1) {
			r.push(`You gave your troops the order to surrender, obediently they stand down.`);
		} else if (V.SecExp.war.result === 0) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		} else if (V.SecExp.war.result === 1) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		}
	} else if (V.SecExp.war.attacker.type === "old world") {
		r.push(`Today, ${asDateString(V.week, random(0, 7))}, our arcology was attacked by an old world nation boasting a misplaced sense of superiority, ${num(Math.trunc(V.SecExp.war.attacker.troops))} men strong.`);
		if (V.SecExp.war.result !== 1 && V.SecExp.war.result !== 0 && V.SecExp.war.result !== -1) {
			r.push(`Our defense forces, ${num(Math.trunc(App.SecExp.battle.troopCount()))} strong, clashed with them`);
			if (V.SecExp.war.terrain === "urban") {
				r.push(`in the streets of`);
				if (V.SecExp.war.terrain === "urban") {
					r.push(`the old world city surrounding the arcology,`);
				} else {
					r.push(`of the free city,`);
				}
			} else if (V.SecExp.war.terrain === "rural") {
				r.push(`in the rural land surrounding the free city,`);
			} else if (V.SecExp.war.terrain === "hills") {
				r.push(`on the hills around the free city,`);
			} else if (V.SecExp.war.terrain === "coast") {
				r.push(`along the coast just outside the free city,`);
			} else if (V.SecExp.war.terrain === "outskirts") {
				r.push(`just against the walls of the arcology,`);
			} else if (V.SecExp.war.terrain === "mountains") {
				r.push(`in the mountains overlooking the arcology,`);
			} else if (V.SecExp.war.terrain === "wasteland") {
				r.push(`in the wastelands outside the free city territory,`);
			}
			if (V.SecExp.war.attacker.losses !== V.SecExp.war.attacker.troops) {
				r.push(`inflicting ${V.SecExp.war.attacker.losses} casualties, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty`);
				} else {
					r.push(`zero`);
				}
				r.push(`themselves.`);
			} else {
				r.push(`completely annihilating their troops, while sustaining`);
				if (V.SecExp.war.losses > 1) {
					r.push(`${num(Math.trunc(V.SecExp.war.losses))} casualties.`);
				} else if (V.SecExp.war.losses > 0) {
					r.push(`a casualty.`);
				} else {
					r.push(`zero casualties.`);
				}
			}
		}
		if (V.SecExp.war.result === 3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men easily stopped the old world soldiers dead in their tracks${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard, but in the end our men stopped the soldiers of the old world${end}`);
			} else {
				r.push(`The fight was long and hard, but our men managed to stop the old world soldiers${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`adding another victory to the growing list of our military's successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`finally putting an end to a series of unfortunate defeats.`);
			}
		} else if (V.SecExp.war.result === -3) {
			if (V.SecExp.war.turns <= 5) {
				r.push(`The fight was quick and one sided, our men were easily crushed by the discipline of the old world armies${end}`);
			} else if (V.SecExp.war.turns <= 7) {
				r.push(`The fight was hard and in the end the old world proved too much to handle for our men${end}`);
			} else {
				r.push(`The fight was long and hard, but despite their bravery the determination of the old world troops proved too much for our men${end}`);
			}
			if (V.SecExp.battles.victoryStreak >= 2) {
				r.push(`so interrupting a long series of military successes.`);
			} else if (V.SecExp.battles.lossStreak >= 2) {
				r.push(`confirming the long list of recent failures our armed forces collected.`);
			}
		} else if (V.SecExp.war.result === 2) {
			r.push(`The fight was long and hard, but in the end our men managed to repel the old world soldiers, though not without difficulty.`);
		} else if (V.SecExp.war.result === -2) {
			r.push(`The fight was long and hard. Our men in the end had to yield to the old world soldiers, which were fortunately unable to capitalized on their victory.`);
		} else if (V.SecExp.war.result === -1) {
			r.push(`You gave your troops the order to surrender, obediently they stand down.`);
		} else if (V.SecExp.war.result === 0) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		} else if (V.SecExp.war.result === 1) {
			r.push(`You decided in favor of a financial approach rather than open hostilities. Your troops remain inside the arcology's walls.`);
		}
	}
	App.Events.addParagraph(node, r);
	r = [];
	/* calculates effects on the city */
	if (V.SecExp.war.result === 3) {
		r.push(`Thanks to your victory, your <span class="green">reputation</span> and <span class="darkviolet">authority</span> increased. You were also able to capture`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(4000 * majorBattleMod, "war");
			V.SecExp.core.authority += 800 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(6000 * majorBattleMod, "war");
			V.SecExp.core.authority += 1200 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(7500 * majorBattleMod, "war");
			V.SecExp.core.authority += 1500 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(6000 * majorBattleMod, "war");
			V.SecExp.core.authority += 1200 * majorBattleMod;
		}
		if (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses <= 50) {
			r.push(`a small amount of attackers,`);
			captives = (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses) * 0.1 * random(1, 3);
		} else if (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses <= 100) {
			r.push(`an healthy group of attackers,`);
			captives = (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses) * 0.1 * random(1, 3);
		} else if (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses <= 150) {
			r.push(`a big group of attackers,`);
			captives = (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses) * 0.1 * random(1, 3);
		} else if (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses <= 200) {
			r.push(`a huge group of attackers,`);
			captives = (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses) * 0.1 * random(1, 3);
		} else if (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses > 200) {
			r.push(`a great amount of attackers,`);
			captives = (V.SecExp.war.attacker.troops - V.SecExp.war.attacker.losses) * 0.1 * random(1, 3);
		}
		r.push(`and some of their equipment, which once sold produced`);
		if (V.SecExp.war.attacker.equip === 0) {
			r.push(`<span class="yellowgreen">a small amount of cash.</span>`);
			loot += 1000 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 1) {
			r.push(`<span class="yellowgreen">a moderate amount of cash.</span>`);
			loot += 5000 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 2) {
			r.push(`<span class="yellowgreen">a good amount of cash.</span>`);
			loot += 10000 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 3) {
			r.push(`<span class="yellowgreen">a great amount of cash.</span>`);
			loot += 15000 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 4) {
			r.push(`<span class="yellowgreen">wealth worthy of the mightiest warlord.</span>`);
			loot += 20000 * majorBattleMod;
		}
		if (V.SecExp.edicts.defense.privilege.mercSoldier === 1 && App.SecExp.battle.deployedUnits('mercs') >= 1) {
			r.push(`Part of the loot is distributed to your mercenaries.`);
			captives = Math.trunc(captives * 0.6);
			loot = Math.trunc(loot * 0.6);
		}
		cashX(loot, "war");
		App.Events.addParagraph(node, r);
		r = [];
		r.push(`Damage to the infrastructure was <span class="yellow">virtually non-existent,</span> costing only pocket cash to bring the structure back to normal. The inhabitants as well reported little to no injuries, because of this the prosperity of the arcology did not suffer.`);
		r.push(`${IncreasePCSkills('engineering', 0.1)}`);
		cashX(forceNeg(1000 * majorBattleMod), "war");
		if (V.SecExp.battles.victoryStreak >= 3) {
			r.push(`It seems your victories over the constant threats directed your way is having <span class="green">a positive effect on the prosperity of the arcology,</span> due to the security your leadership affords.`);
			V.arcologies[0].prosperity += 5 * majorBattleMod;
		}
	} else if (V.SecExp.war.result === -3) {
		r.push(`Due to your defeat, your <span class="red">reputation</span> and <span class="red">authority</span> decreased. Obviously your troops were not able to capture anyone or anything.`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(forceNeg(400 * majorBattleMod), "war");
			V.SecExp.core.authority -= 400 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(forceNeg(600 * majorBattleMod), "war");
			V.SecExp.core.authority -= 600 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(forceNeg(750 * majorBattleMod), "war");
			V.SecExp.core.authority -= 750 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(forceNeg(600 * majorBattleMod), "war");
			V.SecExp.core.authority -= 600 * majorBattleMod;
		}
		App.Events.addParagraph(node, r);
		r = [];
		r.push(`In the raiding following the battle <span class="red">the arcology sustained heavy damage,</span> which will cost quite the amount of cash to fix. Reports of <span class="red">citizens or slaves killed or missing</span> flood your office for a few days following the defeat.`);
		r.push(`${IncreasePCSkills('engineering', 0.1)}`);
		cashX(forceNeg(5000 * majorBattleMod), "war");
		if (V.week <= 30) {
			V.lowerClass -= random(100) * majorBattleMod;
			lostSlaves = random(150) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(5) * majorBattleMod;
		} else if (V.week <= 60) {
			V.lowerClass -= random(120) * majorBattleMod;
			lostSlaves = random(170) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(10) * majorBattleMod;
		} else if (V.week <= 90) {
			V.lowerClass -= random(140) * majorBattleMod;
			lostSlaves = random(190) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(15) * majorBattleMod;
		} else if (V.week <= 120) {
			V.lowerClass -= random(160) * majorBattleMod;
			lostSlaves = random(210) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(20) * majorBattleMod;
		} else {
			V.lowerClass -= random(180) * majorBattleMod;
			lostSlaves = random(230) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(25) * majorBattleMod;
		}
		if (V.SecExp.battles.lossStreak >= 3) {
			r.push(`This only confirms the fears of many, <span class="red">your arcology is not safe</span> and it is clear their business will be better somewhere else.`);
			V.arcologies[0].prosperity -= 5 * majorBattleMod;
		}
	} else if (V.SecExp.war.result === 2) {
		r.push(`Thanks to your victory, your <span class="green">reputation</span> and <span class="darkviolet">authority</span> slightly increased. Our men were not able to capture any combatants, however some equipment was seized during the enemy's hasty retreat,`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(1000 * majorBattleMod, "war");
			V.SecExp.core.authority += 200 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(1500 * majorBattleMod, "war");
			V.SecExp.core.authority += 300 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(2000 * majorBattleMod, "war");
			V.SecExp.core.authority += 450 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(1500 * majorBattleMod, "war");
			V.SecExp.core.authority += 300 * majorBattleMod;
		}
		r.push(`which once sold produced`);
		if (V.SecExp.war.attacker.equip === 0) {
			r.push(`<span class="yellowgreen">a bit of cash.</span>`);
			loot += 500 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 1) {
			r.push(`<span class="yellowgreen">a small amount of cash.</span>`);
			loot += 2500 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 2) {
			r.push(`<span class="yellowgreen">a moderate amount of cash.</span>`);
			loot += 5000 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 3) {
			r.push(`<span class="yellowgreen">a good amount of cash.</span>`);
			loot += 7500 * majorBattleMod;
		} else if (V.SecExp.war.attacker.equip === 4) {
			r.push(`<span class="yellowgreen">a great amount of cash.</span>`);
			loot += 10000 * majorBattleMod;
		}
		if (V.SecExp.edicts.defense.privilege.mercSoldier === 1 && App.SecExp.battle.deployedUnits('mercs') >= 1) {
			r.push(`Part of the loot is distributed to your mercenaries.`);
			loot = Math.trunc(loot * 0.6);
		}
		cashX(loot, "war");
		App.Events.addParagraph(node, r);
		r = [];
		r.push(`Damage to the city was <span class="red">limited,</span> it won't take much to rebuild. Very few citizens or slaves were involved in the fight and even fewer met their end, safeguarding the prosperity of the arcology.`);
		r.push(`${IncreasePCSkills('engineering', 0.1)}`);
		cashX(forceNeg(2000 * majorBattleMod), "war");
		V.lowerClass -= random(10) * majorBattleMod;
		lostSlaves = random(20) * majorBattleMod;
		V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
		V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
		V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
		V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
	} else if (V.SecExp.war.result === -2) {
		r.push(`It was a close defeat, but nonetheless your <span class="red">reputation</span> and <span class="red">authority</span> slightly decreased. Your troops were not able to capture anyone or anything.`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(forceNeg(40 * majorBattleMod), "war");
			V.SecExp.core.authority -= 40 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(forceNeg(60 * majorBattleMod), "war");
			V.SecExp.core.authority -= 60 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(forceNeg(75 * majorBattleMod), "war");
			V.SecExp.core.authority -= 75 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(forceNeg(60 * majorBattleMod), "war");
			V.SecExp.core.authority -= 60 * majorBattleMod;
		}
		App.Events.addParagraph(node, r);
		r = [];
		r.push(`The enemy did not have the strength to raid the arcology for long, still <span class="red">the arcology sustained some damage,</span> which will cost a moderate amount of cash to fix. Some citizens and slaves found themselves on the wrong end of a gun and met their demise.`);
		r.push(`Some business sustained heavy damage, slightly impacting the arcology's prosperity.`);
		r.push(`${IncreasePCSkills('engineering', 0.1)}`);
		cashX(forceNeg(3000 * majorBattleMod), "war");
		if (V.week <= 30) {
			V.lowerClass -= random(50) * majorBattleMod;
			lostSlaves = random(75) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(2) * majorBattleMod;
		} else if (V.week <= 60) {
			V.lowerClass -= random(60) * majorBattleMod;
			lostSlaves = random(85) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(5) * majorBattleMod;
		} else if (V.week <= 90) {
			V.lowerClass -= random(70) * majorBattleMod;
			lostSlaves = random(95) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(7) * majorBattleMod;
		} else if (V.week <= 120) {
			V.lowerClass -= random(80) * majorBattleMod;
			lostSlaves = random(105) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(10) * majorBattleMod;
		} else {
			V.lowerClass -= random(90) * majorBattleMod;
			lostSlaves = random(115) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(12) * majorBattleMod;
		}
	} else if (V.SecExp.war.result === -1) {
		r.push(`Rather than waste the lives of your men you decided to surrender, hoping your enemy will cause less damage if you indulge them, this is however a big hit to your status. Your <span class="red">reputation</span> and <span class="red">authority</span> are significantly impacted.`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(forceNeg(600 * majorBattleMod), "war");
			V.SecExp.core.authority -= 600 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(forceNeg(800 * majorBattleMod), "war");
			V.SecExp.core.authority -= 800 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(forceNeg(1000 * majorBattleMod), "war");
			V.SecExp.core.authority -= 1000 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(forceNeg(800 * majorBattleMod), "war");
			V.SecExp.core.authority -= 800 * majorBattleMod;
		}
		App.Events.addParagraph(node, r);
		r = [];
		r.push(`The surrender allows the arcology to survive <span class="red">mostly intact,</span> however reports of <span class="red">mass looting and killing of citizens</span> flood your office for a few days.`);
		r.push(`${IncreasePCSkills('engineering', 0.1)}`);
		cashX(forceNeg(1000 * majorBattleMod), "war");
		if (V.week <= 30) {
			V.lowerClass -= random(80) * majorBattleMod;
			lostSlaves = random(120) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(5) * majorBattleMod;
		} else if (V.week <= 60) {
			V.lowerClass -= random(100) * majorBattleMod;
			lostSlaves = random(140) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(10) * majorBattleMod;
		} else if (V.week <= 90) {
			V.lowerClass -= random(120) * majorBattleMod;
			lostSlaves = random(160) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(15) * majorBattleMod;
		} else if (V.week <= 120) {
			V.lowerClass -= random(140) * majorBattleMod;
			lostSlaves = random(180) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(20) * majorBattleMod;
		} else {
			V.lowerClass -= random(160) * majorBattleMod;
			lostSlaves = random(200) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(25) * majorBattleMod;
		}
	} else if (V.SecExp.war.result === 0) {
		r.push(`Unfortunately your adversary did not accept your money.`);
		if (V.SecExp.war.attacker.type === "freedom fighters") {
			r.push(`Their ideological crusade would not allow such thing.`);
		} else {
			r.push(`They saw your attempt as nothing more than admission of weakness.`);
		}
		r.push(`There was no time to organize a defense and so the enemy walked into the arcology as it was his. Your reputation and authority suffer a hit.`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(forceNeg(400 * majorBattleMod), "war");
			V.SecExp.core.authority -= 400 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(forceNeg(600 * majorBattleMod), "war");
			V.SecExp.core.authority -= 600 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(forceNeg(750 * majorBattleMod), "war");
			V.SecExp.core.authority -= 750 * majorBattleMod;
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(forceNeg(600 * majorBattleMod), "war");
			V.SecExp.core.authority -= 600 * majorBattleMod;
		}
		App.Events.addParagraph(node, r);
		r = [];
		r.push(`Fortunately the arcology survives <span class="yellow">mostly intact,</span> however reports of <span class="red">mass looting and killing of citizens</span> flood your office for a few days.`);
		r.push(`${IncreasePCSkills('engineering', 0.1)}`);
		cashX(-1000, "war");
		if (V.week <= 30) {
			V.lowerClass -= random(80) * majorBattleMod;
			lostSlaves = random(120) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(5) * majorBattleMod;
		} else if (V.week <= 60) {
			V.lowerClass -= random(100) * majorBattleMod;
			lostSlaves = random(140) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(10) * majorBattleMod;
		} else if (V.week <= 90) {
			V.lowerClass -= random(120) * majorBattleMod;
			lostSlaves = random(160) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(15) * majorBattleMod;
		} else if (V.week <= 120) {
			V.lowerClass -= random(140) * majorBattleMod;
			lostSlaves = random(180) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(20) * majorBattleMod;
		} else {
			V.lowerClass -= random(160) * majorBattleMod;
			lostSlaves = random(200) * majorBattleMod;
			V.NPCSlaves -= Math.trunc((V.NPCSlaves / V.ASlaves) * lostSlaves);
			V.menials -= Math.trunc((V.menials / V.ASlaves) * lostSlaves);
			V.fuckdolls -= Math.trunc((V.fuckdolls / V.ASlaves) * lostSlaves);
			V.menialBioreactors -= Math.trunc((V.menialBioreactors / V.ASlaves) * lostSlaves);
			V.arcologies[0].prosperity -= random(25) * majorBattleMod;
		}
		App.Events.addParagraph(node, r);
		r = [];
	} else if (V.SecExp.war.result === 1) {
		r.push(`The attackers wisely take the money offered them to leave your territory without further issues. The strength of the Free Cities was never in their guns but in their dollars, and today's events are the perfect demonstration of such strength.`);
		r.push(`Your <span class="green">reputation slightly increases.</span>`);
		if (V.SecExp.war.attacker.type === "raiders") {
			repX(500 * majorBattleMod, "war");
		} else if (V.SecExp.war.attacker.type === "free city") {
			repX(750 * majorBattleMod, "war");
		} else if (V.SecExp.war.attacker.type === "freedom fighters") {
			repX(1000 * majorBattleMod, "war");
		} else if (V.SecExp.war.attacker.type === "old world") {
			repX(750 * majorBattleMod, "war");
		}
		cashX(forceNeg(App.SecExp.battle.bribeCost()), "war");
	}
	if (!Number.isInteger(V.lowerClass)) {
		if (isNaN(V.lowerClass)) {
			r.push(App.UI.DOM.makeElement("div", `Error: lowerClass is NaN, please report this issue`, "red"));
		} else if (V.lowerClass > 0) {
			V.lowerClass = Math.trunc(V.lowerClass);
		} else {
			V.lowerClass = 0;
		}
	}
	if (!Number.isInteger(V.NPCSlaves)) {
		if (isNaN(V.NPCSlaves)) {
			r.push(App.UI.DOM.makeElement("div", `Error: NPCSlaves is NaN, please report this issue`, "red"));
		} else if (V.NPCSlaves > 0) {
			V.NPCSlaves = Math.trunc(V.NPCSlaves);
		} else {
			V.NPCSlaves = 0;
		}
	}

	App.Events.addParagraph(node, r);
	r = [];
	if (V.SecExp.war.result !== 1 && V.SecExp.war.result !== 0 && V.SecExp.war.result !== -1) {
		/* leaders */
		if (V.SecExp.war.commander === "PC") {
			r.push(`You decided to personally lead the defense of your arcology.`);
			if (App.SecExp.battle.deployedUnits('militia') >= 1) {
				if (oldRep <= 2500) {
					if (oldRep > 1000) {
						r.push(`You're not particularly popular between the inhabitants of your arcology, so your presence does little to reassure the volunteers.`);
					} else {
						r.push(`As your low reputation proves, your volunteers do not particularly enjoy your company. As far as they are concerned your presence is more of a hindrance than an advantage.`);
					}
					if (V.PC.career === "celebrity") {
						r.push(`Still, your past celebrity does carry some weight, and many look forward to fight alongside a famous name.`);
					} else if (V.PC.career === "capitalist") {
						r.push(`Still, your past life as a famous venture capitalist does carry some weight, and many trust in your cunning to save them in the incoming battle.`);
					} else if (V.PC.career === "gang") {
						r.push(`The situation is not made easier by your past. Many still remember you as the gang leader who used to be on the other side of their guns.`);
					} else if (V.PC.career === "escort") {
						r.push(`The situation is not made easier by your past. Many still remember your past career as an escort and doubt you'll be of any use during the fighting.`);
					} else if (V.PC.career === "mercenary") {
						r.push(`Still, your past mercenary work does carry some weight, and many look forward to fight alongside a battle hardened name.`);
					}
				} else if (oldRep >= 5000) {
					if (oldRep < 15000) {
						r.push(`Your citizens are honored that their arcology owner is willing to put ${hisP} life in danger.`);
					} else {
						r.push(`Many among the volunteers are awed by your presence; never would they have thought they would fight shoulder to shoulder with their famous arcology owner.`);
					}
					if (V.PC.career === "celebrity") {
						r.push(`They consider it a priceless opportunity to fight together with someone with such a renowned past as yours. Your celebrity past still carries weight.`);
					} else if (V.PC.career === "capitalist") {
						r.push(`They consider it a priceless opportunity to fight together with one of the great capitalist sharks of their time. Such a fine mind on their side can only bring victory!`);
					} else if (V.PC.career === "gang") {
						r.push(`Your past, however, does not help you. Many still remember you as the gang leader who used to be on the other side of their guns.`);
					} else if (V.PC.career === "escort") {
						r.push(`Your past, however, does not help you. Many still remember your past career as an escort and doubt you'll be of any use during the fighting.`);
					} else if (V.PC.career === "mercenary") {
						r.push(`Your past mercenary work does carries some weight, and many look forward to fight alongside a battle hardened name.`);
					}
				}
			}
			if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
				if (oldAuth <= 2500) {
					if (oldAuth > 1000) {
						r.push(`Your slave soldiers do not feel bound to you as much as they should, as your authority is far from absolute.`);
					} else {
						r.push(`Your slave soldiers are often openly rebellious. Only the threat of execution holds them in line.`);
					}
					if (V.PC.career === "escort") {
						r.push(`Fortunately many feel some level of kinship with you, thanks to your past as an escort.`);
					} else if (V.PC.career === "servant") {
						r.push(`Fortunately many feel some level of kinship with you, thanks to your past as a servant.`);
					} else if (V.PC.career === "slaver") {
						r.push(`Things are made worse by your past as a notorious slaver.`);
					} else if (V.PC.career === "mercenary") {
						r.push(`Your past mercenary work carries some weight, and many look forward to fighting alongside a battle hardened name.`);
					}
				} else if (oldAuth >= 5000) {
					if (oldAuth < 15000) {
						r.push(`Your slave soldiers show a surprising amount of discipline, thanks to your high authority.`);
					} else {
						r.push(`Your slave soldiers show almost a fanatical level of martial discipline. Your absolute authority has a great effect on them.`);
					}
					if (V.PC.career === "escort") {
						r.push(`Many have an instinctual feeling of kinship towards you because of your past as an escort.`);
					} else if (V.PC.career === "servant") {
						r.push(`Many have an instinctual feeling of kinship towards you because of your past as a servant.`);
					} else if (V.PC.career === "slaver") {
						r.push(`Still, some rebellious looks can be spotted once in a while. In their eyes your slaver past will always paint you in a dark light.`);
					} else if (V.PC.career === "mercenary") {
						r.push(`Your past mercenary work carries some weight, and many look forward to fighting alongside a battle hardened name.`);
					}
				}
			}
			if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
				const mercLoyalty = App.SecExp.mercenaryAvgLoyalty();
				if (mercLoyalty <= 25) {
					if (mercLoyalty <= 10) {
						r.push(`Your mercenaries barely bother to pretend being loyal; their battle performance is obviously barely passable.`);
					} else {
						r.push(`Your presence does little to spur your mercenaries into action; their loyalty is straining and their performance suffers.`);
					}
					if (V.PC.career === "mercenary") {
						r.push(`Thankfully they hold in high regard someone who made their fortune as a mercenary themselves.`);
					} else if (V.PC.career === "wealth") {
						r.push(`They do little to hide the contempt they have for someone who was born into wealth, rather than gaining it through blood, sweat, and tears.`);
					} else if (V.PC.career === "servant") {
						r.push(`They do little to hide their disgust at being ordered around by an ex-servant.`);
					} else if (V.PC.career === "BlackHat") {
						r.push(`They do little to hide their disgust at being ordered around by some unscrupulous code monkey.`);
					}
				} else if (mercLoyalty >= 50) {
					if (mercLoyalty < 75) {
						r.push(`Your mercenaries are ready to fight their hardest for you, their loyalty a testament to your capability as a leader.`);
					} else {
						r.push(`Your mercenaries fight with a martial fury worthy of religious fanatics. Their loyalty to you is absolute.`);
					}
					if (V.PC.career === "mercenary") {
						r.push(`They're more than willing to follow someone who walked their same steps once as a gun for hire.`);
					} else if (V.PC.career === "wealth") {
						r.push(`Unfortunately many still resent you being born into your wealth and power, rather than having earned it through blood, sweat, and tears.`);
					} else if (V.PC.career === "servant") {
						r.push(`Unfortunately some still resent the fact they are ordered around by an ex-servant.`);
					} else if (V.PC.career === "BlackHat") {
						r.push(`Unfortunately some still resent the fact they are ordered around by an unscrupulous hacker.`);
					}
				}
				if (oldRep >= 15000) {
					r.push(`Your reputation is so high your name carries power by itself. Having you on the battlefield puts fear even in the hardiest of warriors.`);
				}
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				if (V.PC.career === "mercenary" || V.PC.career === "slaver" || V.PC.career === "capitalist" || V.PC.career === "gang" || V.PC.skill.warfare > 75) {
					r.push(`The soldiers of ${V.SF.Lower} are ready and willing to follow you into battle, confident in your past experience.`);
				} else if (V.PC.career === "wealth" || V.PC.career === "medicine" || V.PC.career === "engineer") {
					r.push(`The soldiers of ${V.SF.Lower}, as loyal as they are, are not enthusiastic to follow the orders of someone who has no experience leading men.`);
				} else if (V.PC.career === "servant") {
					r.push(`The soldiers of ${V.SF.Lower}, as loyal as they are, are not enthusiastic to follow the orders of an ex-servant.`);
				} else if (V.PC.career === "escort") {
					r.push(`The soldiers of ${V.SF.Lower}, as loyal as they are, are not enthusiastic to follow the orders of an ex-escort.`);
				} else if (V.PC.career === "BlackHat") {
					r.push(`The soldiers of ${V.SF.Lower}, as loyal as they are, are not enthusiastic to follow the orders of a dubious incursion specialist.`);
				}
			}
			if (V.PC.skill.warfare <= 25 && V.PC.skill.warfare > 10) {
				r.push(`Your inexperience in military matters has a negative impact on your troops performance and the effectiveness of your battle plan.`);
			} else if (V.PC.skill.warfare <= 10) {
				r.push(`Your ignorance in military matters has a severe negative impact on your troops performance and the effectiveness of your battle plan.`);
			} else if (V.PC.skill.warfare >= 50) {
				r.push(`Your experience in military matters has a positive impact on your troops performance and the effectiveness of your battle plan.`);
			} else if (V.PC.skill.warfare >= 75) {
				r.push(`Your great experience in military matters has a major positive impact on your troops performance and the effectiveness of your battle plan.`);
			}
			if (V.SecExp.war.gainedWarfare) {
				r.push(`Battlefield experience increased your understanding of warfare, making you a better commander.`);
			}
			if (V.PC.health.shortDamage >= 60) {
				r.push(`During the fighting <span class="red">you were wounded.</span> Your medics assure you it's nothing life threatening, but you'll be weakened for a few weeks.`);
			}
		} else if (V.SecExp.war.commander === "assistant") {
			if (V.auto === 1) {
				r.push(`${V.assistant.name}`);
			} else {
				r.push(`You`);
			}
			r.push(`let your personal assistant lead the troops.`);
			if (App.SecExp.battle.deployedUnits('mercs') >= 1 || App.SecExp.battle.deployedUnits('militia') >= 1 || App.SecExp.battle.deployedUnits('slaves') >= 1) {
				r.push(`No soldier trusts a computer to be their commander,`);
				if (oldRep < 10000 && oldAuth < 10000) {
					r.push(`no algorithm can substitute experience,`);
					if (V.assistant.power === 0) {
						r.push(`and as expected,`);
					} else {
						r.push(`however,`);
					}
				} else {
					r.push(`but they trust you enough to not question your decision,`);
					if (V.assistant.power === 0) {
						r.push(`however`);
					} else {
						r.push(`and`);
					}
				}
			} else {
				r.push(`You find`);
			}
			if (V.assistant.power === 0) {
				r.push(`your assistant gives a rather poor field performance, due to the limited computing power available to ${himA}.`);
			} else if (V.assistant.power === 1) {
				r.push(`your assistant performs decently. While nothing to write home about your men are pleasantly surprised.`);
			} else if (V.assistant.power === 2) {
				r.push(`your assistant performs admirably. ${HisA} upgraded computing power allows ${himA} to monitor the battlefield closely, enhancing the efficiency of your troops and the effectiveness of your battle plan.`);
			} else if (V.assistant.power >= 3) {
				r.push(`your assistant performs admirably. ${HisA} vast computing power allows ${himA} to be everywhere on the battlefield, greatly enhancing the efficiency of your troops and the effectiveness of your battle plan.`);
			}
		} else if (V.SecExp.war.commander === "bodyguard") {
			const {
				His, He,
				his, he, him
			} = getPronouns(S.Bodyguard);
			if (V.auto === 1) {
				r.push(`${V.assistant.name}`);
			} else {
				r.push(`You`);
			}
			r.push(`decided it will be your bodyguard that leads the troops.`);
			if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
				if (S.Bodyguard.devotion < -20) {
					r.push(`${His} low devotion has a negative impact on the morale of your slave soldiers.`);
				} else if (S.Bodyguard.devotion > 51) {
					r.push(`${His} devotion to you has a positive impact on the morale of your slave soldiers, proud to be led by one of their own.`);
				}
			}
			if (oldRep < 10000 && oldAuth < 10000 || S.Bodyguard.prestige < 1) {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a`);
					if (V.SF.Toggle && V.SF.Active >= 1 && App.SecExp.battle.deployedUnits('mercs') === 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your mercenaries or your soldiers.`);
					} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
						r.push(`commander, and neither are your mercenaries.`);
					} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your soldiers.`);
					} else {
						r.push(`commander.`);
					}
				} else if (V.SF.Toggle && V.SF.Active >= 1 && App.SecExp.battle.deployedUnits('mercs') === 1 && V.SecExp.war.deploySF) {
					r.push(`Your mercenaries and soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander.`);
				} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
					r.push(`Your mercenaries`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander.`);
				} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander.`);
				}
			} else if (S.Bodyguard.prestige >= 2) {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your`);
					if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`volunteers, your mercenaries and your soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
						r.push(`volunteers and your mercenaries are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`volunteers and your soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					} else {
						r.push(`volunteers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					}
				} else if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your mercenaries and soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
				} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
					r.push(`Your mercenaries are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
				} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
				}
			} else {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a`);
					if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your mercenaries and soldiers, but they trust you enough not to question your decision.`);
					} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
						r.push(`commander, and neither are your mercenaries, but they trust you enough not to question your decision.`);
					} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your soldiers, but they trust you enough not to question your decision.`);
					} else {
						r.push(`commander, but they trust you enough not to question your decision.`);
					}
				} else if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your mercenaries and soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however,`);
					}
					r.push(`are not enthusiastic to have a slave as a commander, but they trust you enough not to question your decision.`);
				} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
					r.push(`Your mercenaries`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however,`);
					}
					r.push(`are not enthusiastic to have a slave as a commander, but they trust you enough not to question your decision.`);
				} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however,`);
					}
					r.push(`are not enthusiastic to have a slave as a commander, but they trust you enough not to question your decision.`);
				}
			}
			const BGCareerGivesBonus = App.Data.Careers.Leader.bodyguard.includes(S.Bodyguard.career) || App.Data.Careers.Leader.HG.includes(S.Bodyguard.career) || App.Data.misc.secExCombatPrestige.includes(S.Bodyguard.prestigeDesc);
			const BGTotalIntelligence = S.Bodyguard.intelligence + S.Bodyguard.intelligenceImplant;
			if (BGCareerGivesBonus && BGTotalIntelligence > 95) {
				r.push(`With ${his} experience and ${his} great intellect, ${he} is able to exploit the smallest of tactical advantages, making your troops very effective.`);
			} else if (BGTotalIntelligence > 95) {
				r.push(`While ${he} lacks experience, ${his} great intellect allows ${him} to seize and exploit any tactical advantage the battlefield offers ${him}.`);
			} else if (BGCareerGivesBonus && BGTotalIntelligence > 50) {
				r.push(`Having both the experience and the intelligence, ${he} performs admirably as your commander. ${His} competence greatly increases the efficiency of your troops.`);
			} else if (BGTotalIntelligence > 50) {
				r.push(`Despite not having a lot of experience as a leader, ${his} intelligence makes ${him} a good commander, increasing the efficiency of your troops.`);
			} else if (BGCareerGivesBonus && BGTotalIntelligence > 15) {
				r.push(`Thanks to ${his} experience, ${he} is a decent commander, competently guiding your troops through the battle.`);
			} else if (BGTotalIntelligence > 15) {
				r.push(`Lacking experience, ${his} performance as a commander is rather forgettable.`);
			} else if (BGCareerGivesBonus && BGTotalIntelligence < -50) {
				r.push(`Despite the experience ${he} accumulated during ${his} past career, ${his} very low intelligence is a great disadvantage for your troops.`);
			} else if (BGTotalIntelligence < -50) {
				r.push(`Without experience and low intelligence, ${he} performs horribly as a commander, greatly affecting your troops.`);
			} else if (BGCareerGivesBonus && BGTotalIntelligence < -15) {
				r.push(`Despite the experience ${he} accumulated during ${his} past career, ${he} lacks the intelligence to apply it quickly and effectively, making for a rather poor performance in the field.`);
			} else if (BGTotalIntelligence < -15) {
				r.push(`${He} lacks the experience and the intelligence to be an effective commander, the performance of your troops suffers because of ${his} poor leadership.`);
			}
			if (V.SecExp.war.gainedCombat) {
				r.push(`During the battle, ${he} had to fight for ${his} life, giving ${him} experience in modern combat. ${He} is now proficient with modern firearms and hand to hand combat.`);
			}
			if (V.SecExp.war.leaderWounded) {
				r.push(`Unfortunately, <span class="red">${he} sustained major injuries.</span>`);
				const woundType = App.SecExp.inflictBattleWound(S.Bodyguard);
				if (woundType === "voice") {
					r.push(`A stray bullet hit ${his} neck. While ${he} fortunately avoided fatal hemorrhaging, ${his} vocal cords were irreparably damaged.`);
				} else if (woundType === "eyes") {
					r.push(`Some shrapnel found ${his} eyes as their final target, blinding ${him} permanently.`);
				} else if (woundType === "legs") {
					r.push(`A grenade landed close to ${him}, and ${his} badly mangled legs had to be amputated.`);
				} else if (woundType === "arm") {
					r.push(`A shrapnel blast mangled one of ${his} arms, which had to be amputated.`);
				} else if (woundType === "flesh") {
					r.push(`While gravely wounded, it seems ${he} will be able to fully recover, given enough time.`);
				}
				r.push(`Your troops were greatly affected by the loss of their leader.`);
			}
			if (V.SecExp.war.result === 3 && V.SecExp.settings.battle.allowSlavePrestige === 1) {
				let found = 0;
				for (const victory of V.SecExp.battles.slaveVictories) {
					if (victory.ID === V.BodyguardID) {
						victory.victories++;
						found = 1;
						if (victory.victories >= 10) {
							if (S.Bodyguard.prestige < 3) {
								S.Bodyguard.prestige++;
								if (S.Bodyguard.prestige === 1) {
									S.Bodyguard.prestigeDesc = "$He is well known for being a great commander.";
								} else if (S.Bodyguard.prestige === 2) {
									S.Bodyguard.prestigeDesc = "$He is famous for being an incredible commander.";
								} else if (S.Bodyguard.prestige === 3) {
									S.Bodyguard.prestigeDesc = "$He is known as a legendary commander all over the world.";
								}
								victory.victories = 0;
								r.push(`${He} brought your army to victory so many times that ${his} <span class="green">prestige has increased.</span>`);
							}
						}
						break;
					}
				}
				if (found === 0) {
					const newSlave = {ID: V.BodyguardID, victories: 0};
					V.SecExp.battles.slaveVictories.push(newSlave);
				}
			}
		} else if (V.SecExp.war.commander === "headGirl") {
			const {
				His, He,
				his, he, him
			} = getPronouns(S.HeadGirl);
			if (V.auto === 1) {
				r.push(`${V.assistant.name}`);
			} else {
				r.push(`You`);
			}
			r.push(`decided it will be your Head Girl that leads the troops.`);
			if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
				if (S.HeadGirl.devotion < -20) {
					r.push(`${His} low devotion has a negative impact on the morale of your slave soldiers.`);
				} else if (S.HeadGirl.devotion > 51) {
					r.push(`${His} devotion to you has a positive impact on the morale of your slave soldiers, proud to be led by one of their own.`);
				}
			}
			if (oldRep < 10000 && oldAuth < 10000 || S.HeadGirl.prestige < 1) {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a`);
					if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your mercenaries or your soldiers.`);
					} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
						r.push(`commander, and neither are your mercenaries.`);
					} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your soldiers.`);
					} else {
						r.push(`commander.`);
					}
				} else if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your mercenaries and soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander.`);
				} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
					r.push(`Your mercenaries`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander.`);
				} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander.`);
				}
			} else if (S.HeadGirl.prestige >= 2) {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your`);
					if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`volunteers, your mercenaries and your soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
						r.push(`volunteers and your mercenaries are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`volunteers and your soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					} else {
						r.push(`volunteers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
					}
				} else if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your mercenaries and soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
				} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
					r.push(`Your mercenaries are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
				} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your soldiers are delighted to have such a prestigious individual as their commander, almost forgetting ${he} is a slave.`);
				}
			} else {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a`);
					if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your mercenaries and soldiers, but they trust you enough not to question your decision.`);
					} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
						r.push(`commander, and neither are your mercenaries, but they trust you enough not to question your decision.`);
					} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
						r.push(`commander, and neither are your soldiers, but they trust you enough not to question your decision.`);
					} else {
						r.push(`commander, but they trust you enough not to question your decision.`);
					}
				} else if (App.SecExp.battle.deployedUnits('mercs') === 1 && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your mercenaries and soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander, but they trust you enough not to question your decision.`);
				} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
					r.push(`Your mercenaries`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander, but they trust you enough not to question your decision.`);
				} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
					r.push(`Your soldiers`);
					if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
						r.push(`however`);
					}
					r.push(`are not enthusiastic to have a slave as a commander, but they trust you enough not to question your decision.`);
				}
			}
			if ((App.Data.Careers.Leader.bodyguard.includes(S.HeadGirl.career) || App.Data.Careers.Leader.HG.includes(S.HeadGirl.career) || App.Data.misc.secExCombatPrestige.includes(S.HeadGirl.prestigeDesc)) && S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant > 95) {
				r.push(`With ${his} experience and ${his} great intellect, ${he} is able to exploits the smallest of tactical advantages, making your troops greatly effective.`);
			} else if (S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant > 95) {
				r.push(`While ${he} lacks experience, ${his} great intellect allows ${him} to seize and exploit any tactical advantage the battlefield offers ${him}.`);
			} else if ((App.Data.Careers.Leader.bodyguard.includes(S.HeadGirl.career) || App.Data.Careers.Leader.HG.includes(S.HeadGirl.career) || App.Data.misc.secExCombatPrestige.includes(S.HeadGirl.prestigeDesc)) && S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant > 50) {
				r.push(`Having both the experience and the intelligence, ${he} performs admirably as your commander. ${His} competence greatly increases the efficiency of your troops.`);
			} else if (S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant > 50) {
				r.push(`Despite not having a lot of experience as a leader, ${his} intelligence makes ${him} a good commander, increasing the efficiency of your troops.`);
			} else if ((App.Data.Careers.Leader.bodyguard.includes(S.HeadGirl.career) || App.Data.Careers.Leader.HG.includes(S.HeadGirl.career) || App.Data.misc.secExCombatPrestige.includes(S.HeadGirl.prestigeDesc)) && S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant > 15) {
				r.push(`Thanks to ${his} experience, ${he} is a decent commander, competently guiding your troops through the battle.`);
			} else if (S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant > 15) {
				r.push(`Lacking experience ${his} performance as a commander is rather forgettable.`);
			} else if ((App.Data.Careers.Leader.bodyguard.includes(S.HeadGirl.career) || App.Data.Careers.Leader.HG.includes(S.HeadGirl.career) || App.Data.misc.secExCombatPrestige.includes(S.HeadGirl.prestigeDesc)) && S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant < -50) {
				r.push(`Despite the experience ${he} accumulated during ${his} past career, ${his} very low intelligence is a great disadvantage for your troops.`);
			} else if (S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant < -50) {
				r.push(`Without experience and low intelligence, ${he} performs horribly as a commander, greatly affecting your troops.`);
			} else if ((App.Data.Careers.Leader.bodyguard.includes(S.HeadGirl.career) || App.Data.Careers.Leader.HG.includes(S.HeadGirl.career) || App.Data.misc.secExCombatPrestige.includes(S.HeadGirl.prestigeDesc)) && S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant < -15) {
				r.push(`Despite the experience ${he} accumulated during ${his} past career, ${he} lacks the intelligence to apply it quickly and effectively, making for a rather poor performance in the field.`);
			} else if (S.HeadGirl.intelligence + S.HeadGirl.intelligenceImplant < -15) {
				r.push(`${He} lacks the experience and the intelligence to be an effective commander, the performance of your troops suffers because of ${his} poor leadership.`);
			}
			if (V.SecExp.war.gainedCombat) {
				r.push(`During the battle, ${he} had to fight for ${his} life, giving ${him} experience in modern combat. ${He} is now proficient with modern firearms and hand to hand combat.`);
			}
			if (V.SecExp.war.leaderWounded) {
				r.push(`Unfortunately, <span class="red">${he} sustained major injuries.</span>`);
				const woundType = App.SecExp.inflictBattleWound(S.Bodyguard);
				if (woundType === "voice") {
					r.push(`A stray bullet hit ${his} neck. While ${he} fortunately avoided fatal hemorrhaging, ${his} vocal cords were irreparably damaged.`);
				} else if (woundType === "eyes") {
					r.push(`Some shrapnel found ${his} eyes as their final target, blinding ${him} permanently.`);
				} else if (woundType === "legs") {
					r.push(`A grenade landed close to ${him}, and ${his} badly mangled legs had to be amputated.`);
				} else if (woundType === "arm") {
					r.push(`A shrapnel blast mangled one of ${his} arms, which had to be amputated.`);
				} else if (woundType === "flesh") {
					r.push(`While gravely wounded, it seems ${he} will be able to fully recover, given enough time.`);
				}
				r.push(`Your troops were greatly affected by the loss of their leader.`);
			}
			if (V.SecExp.war.result === 3 && V.SecExp.settings.battle.allowSlavePrestige === 1) {
				let found = 0;
				for (const victory of V.SecExp.battles.slaveVictories) {
					if (victory.ID === V.HeadGirlID) {
						victory.victories++;
						found = 1;
						if (victory.victories >= 10) {
							if (S.HeadGirl.prestige < 3) {
								S.HeadGirl.prestige++;
								if (S.HeadGirl.prestige === 1) {
									S.HeadGirl.prestigeDesc = "$He is well known for being a great commander.";
								} else if (S.HeadGirl.prestige === 2) {
									S.HeadGirl.prestigeDesc = "$He is famous for being an incredible commander.";
								} else if (S.HeadGirl.prestige === 3) {
									S.HeadGirl.prestigeDesc = "$He is known as a legendary commander all over the world.";
								}
								victory.victories = 0;
								r.push(`${He} brought your army to victory so many times that ${his} <span class="green">prestige has increased.</span>`);
							}
						}
						break;
					}
				}
				if (found === 0) {
					const newSlave = {ID: V.HeadGirlID, victories: 0};
					V.SecExp.battles.slaveVictories.push(newSlave);
				}
			}
		} else if (V.SecExp.war.commander === "citizen") {
			if (V.auto === 1) {
				r.push(`${V.assistant.name}`);
			} else {
				r.push(`You`);
			}
			r.push(`decided to appoint one of your volunteers as the commander.`);
			if (V.arcologies[0].FSDegradationist === "unset" && V.arcologies[0].FSPaternalist === "unset") {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers are honored and pleased that one of their own is leading the defense force of the city.`);
				}
				if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
					r.push(`Your slaves${(App.SecExp.battle.deployedUnits('militia') >= 1) ? `, however,` : ``}are not thrilled by the news.`);
				}
			} else if (V.arcologies[0].FSPaternalist !== "unset") {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers are honored and pleased that one of their own is leading the defense force of the city.`);
				}
				if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
					r.push(`Thanks to your paternalistic society, your slave soldiers trust your chosen citizen to treat them as more than cannon fodder.`);
				}
			} else if (V.arcologies[0].FSDegradationist !== "unset") {
				if (App.SecExp.battle.deployedUnits('militia') >= 1) {
					r.push(`Your volunteers are honored and pleased that one of their own is leading the defense force of the city.`);
				}
				if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
					r.push(`Because of your degradationist society,`);
					if (App.SecExp.battle.deployedUnits('militia') >= 1) {
						r.push(`however,`);
					}
					r.push(`your slave soldiers are deeply distrustful of the new leader.`);
				}
			}
			if (V.arcologies[0].FSRomanRevivalist !== "unset" && App.SecExp.battle.deployedUnits('mercs') >= 1) {
				r.push(`Since you decided to revive old Rome, many of your citizens took on themselves to educate themselves in martial matters, because of this your mercenaries feel safe enough in the hands of one of your volunteers.`);
			} else if (V.arcologies[0].FSNeoImperialist !== "unset" && App.SecExp.battle.deployedUnits('mercs') >= 1) {
				r.push(`Since having instituted an Imperial society, your citizens have become adept at modern warfare and your hardened mercenaries feel far more comfortable with one of your Imperial Knights in command.`);
			} else if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
				r.push(`Your mercenaries are not thrilled to be lead by a civilian without any formal martial training or education.`);
			}
			if (V.arcologies[0].FSRomanRevivalist !== "unset" && V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				r.push(`Since you decided to revive old Rome, many of your citizens took on themselves to educate themselves in martial matters, because of this your soldiers feel safe enough in the hands of one of your volunteers.`);
			} else if (V.arcologies[0].FSNeoImperialist !== "unset" && App.SecExp.battle.deployedUnits('mercs') >= 1) {
				r.push(`Since having instituted an Imperial society, your citizens have become adept at modern warfare and the line soldiers feel much more comfortable being commanded by one of your Imperial Knights.`);
			} else if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				r.push(`You soldiers are not thrilled to be lead by a civilian without any formal martial training or education.`);
			}
			if (V.SecExp.war.leaderWounded) {
				r.push(`During the battle a stray bullet managed to reach the leader. Your troops were greatly affected by the loss.`);
			}
		} else if (V.SecExp.war.commander === "mercenary") {
			if (V.auto === 1) {
				r.push(`${V.assistant.name}`);
			} else {
				r.push(`You`);
			}
			r.push(`decided to appoint one of your mercenary officers as the commander.`);
			if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
				r.push(`Your mercenaries of course approve of your decision.`);
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				r.push(`Your soldiers feel more confident going into battle with an experienced commander.`);
			}
			if (V.arcologies[0].FSRomanRevivalist !== "unset" && App.SecExp.battle.deployedUnits('militia') >= 1) {
				r.push(`Since you decided to revive old Rome, your volunteers are more willing to trust one of your mercenaries as their leader.`);
			} else if (App.SecExp.battle.deployedUnits('militia') >= 1) {
				r.push(`Your volunteers are not enthusiastic at the prospect of being commanded around by a gun for hire.`);
			}
			if (V.arcologies[0].FSDegradationist !== "unset" && App.SecExp.battle.deployedUnits('slaves') >= 1) {
				r.push(`Because of your degradationist society, your slave soldiers are highly distrustful of the gun for hire you forced them to accept as leader.`);
			}
			if (V.SecExp.war.leaderWounded) {
				r.push(`During the battle a stray bullet managed to reach the mercenary. Your troops were greatly affected by the loss of their leader.`);
			}
		} else if (V.SecExp.war.commander === "colonel") {
			if (V.auto === 1) {
				r.push(`${V.assistant.name}`);
			} else {
				r.push(`You`);
			}
			r.push(`decided to appoint The Colonel as the commander.`);
			if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
				r.push(`Your mercenaries approve of such decisions, as they feel more confident by having a good, experienced commander.`);
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				r.push(`The soldiers of ${V.SF.Lower} obviously approved of your decision.`);
			}
			if (V.arcologies[0].FSRomanRevivalist !== "unset" && App.SecExp.battle.deployedUnits('militia') >= 1) {
				r.push(`Since you decided to revive old Rome, your volunteers are more willing to trust one of your soldiers as their leader.`);
			} else if (V.arcologies[0].FSNeoImperialist !== "unset" && App.SecExp.battle.deployedUnits('militia') >= 1) {
				r.push(`Under the strict hierarchy of your Imperial society, the militia is more willing to follow the Colonel's commands.`);
			} else if (App.SecExp.battle.deployedUnits('militia') >= 1) {
				r.push(`Your volunteers are not enthusiastic at the prospect of being commanded around by an old style military officer.`);
			}
			if (V.arcologies[0].FSDegradationist !== "unset" && App.SecExp.battle.deployedUnits('slaves') >= 1) {
				r.push(`Because of your degradationist society, your slave soldiers are highly distrustful of the soldier you forced them to accept as leader.`);
			}
			if (V.SecExp.war.leaderWounded) {
				r.push(`During the battle a stray bullet managed to reach The Colonel, wounding her slightly. Your troops were greatly affected by the loss of their leader.`);
			}
		}

		App.Events.addParagraph(node, r);
		r = [];

		/* tactics */
		if (V.auto === 1) {
			r.push(`${V.assistant.name}`);
		} else {
			r.push(`You`);
		}
		if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
			r.push(`chose to employ "bait and bleed" tactics or relying on quick attacks and harassment to tire and wound the enemy until their surrender.`);
		} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
			r.push(`chose to employ "guerrilla" tactics or relying on stealth, terrain knowledge and subterfuge to undermine and ultimately destroy the enemy.`);
		} else if (V.SecExp.war.chosenTactic === "Choke Points") {
			r.push(`chose to employ "choke points" tactics or the extensive use of fortified or highly defensive positions to slow down and eventually stop the enemy.`);
		} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
			r.push(`chose to employ "interior lines" tactics or exploiting the defender's shorter front to quickly disengage and concentrate troops when and where needed.`);
		} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
			r.push(`chose to employ "pincer maneuver" tactics or attempting to encircle the enemy by faking a collapsing center front.`);
		} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
			r.push(`chose to employ "defense in depth" tactics or relying on mobility to disengage and exploit overextended enemy troops by attacking their freshly exposed flanks.`);
		} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
			r.push(`chose to employ "blitzkrieg" tactics or shattering the enemy's front-line with a violent, concentrated armored assault.`);
		} else if (V.SecExp.war.chosenTactic === "Human Wave") {
			r.push(`chose to employ "human wave" tactics or overwhelming the enemy's army with a massive infantry assault.`);
		}
		if (V.SecExp.war.terrain === "urban") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`The urban terrain synergized well with bait and bleed tactics, slowly chipping away at the enemy's forces from the safety of the narrow streets and empty buildings.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`The urban terrain synergized well with guerrilla tactics, eroding your enemy's determination from the safety of the narrow streets and empty buildings.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`The urban environment offers many opportunities to hunker down and stop the momentum of the enemy's assault while keeping your soldiers in relative safety.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`While the urban environment offers many highly defensive position, it does restrict movement and with it the advantages of exploiting interior lines.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`The urban terrain does not allow for wide maneuvers, the attempts of your forces to encircle the attackers are mostly unsuccessful.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`While the urban environment offers many defensive positions, it limits mobility, limiting the advantages of using a defense in depth tactic.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`The urban terrain is difficult to traverse, making your troops attempt at a lightning strike unsuccessful.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`The urban terrain offers great advantages to the defender, your men find themselves in great disadvantage while mass assaulting the enemy's position.`);
			}
		} else if (V.SecExp.war.terrain === "rural") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`The open terrain of rural lands does not lend itself well to bait and bleed tactics, making it harder for your men to achieve tactical superiority.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`The open terrain of rural lands does not offer many hiding spots, making it harder for your men to perform guerrilla actions effectively.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`The open terrain of rural lands does not offer many natural choke points, making it hard for your troops to funnel the enemy towards highly defended positions.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`The open terrain allows your men to easily exploit the superior mobility of the defender, making excellent use of interior lines to strike where it hurts.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`The open terrain affords your men great mobility, allowing them to easily position themselves for envelopment.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`The open terrain affords your men great mobility, allowing them to exploit overextended assaults and concentrate where and when it matters.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`The open terrain affords your men great mobility, making it easier to accomplish concentrated lightning strikes.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`The open terrain affords your men great mobility, making it easier to overwhelm the enemy with mass assaults.`);
			}
		} else if (V.SecExp.war.terrain === "hills") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`While the hills offer some protection, they also make it harder to maneuver; bait and bleed tactics will not be 100% effective here.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`The hills offer protection to both your troops and your enemy's, making it harder for your men to accomplish guerrilla attacks effectively.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`While not as defensible as mountains, hills offer numerous opportunities to funnel the enemy towards highly defensible choke points.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`The limited mobility on hills hampers the capability of your troops to exploit the defender's greater mobility afforded by interior lines.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`Limited mobility due to the hills is a double edged sword, affording your men a decent shot at encirclement.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`The limited mobility on hills hampers the capability of your troops to use elastic defense tactics.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`The limited mobility on hills hampers the capability of your troops to organize lightning strikes.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`The defensibility of hills makes it harder to accomplish victory through mass assaults.`);
			}
		} else if (V.SecExp.war.terrain === "coast") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`On the coast there's little space and protection to effectively employ bait and bleed tactics.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`On the coast there's little space and protection to effectively employ guerrilla tactics.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`Amphibious attacks are difficult in the best of situations; the defender has a very easy time funneling the enemy towards their key defensive positions.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`While in an amphibious landing mobility is not the defender's best weapon, exploiting interior lines still affords your troops some advantages.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`Attempting to encircle a landing party is not the best course of action, but not the worst either.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`In an amphibious assault it's very easy for the enemy to overextend, making defense in depth tactics quite effective.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`The rough, restricted terrain does not lend itself well to lightning strikes, but the precarious position of the enemy still gives your mobile troops tactical superiority.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`The rough, restricted terrain does not lend itself well to mass assaults, but the precarious position of the enemy still gives your troops tactical superiority.`);
			}
		} else if (V.SecExp.war.terrain === "outskirts") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`Fighting just beneath the walls of the arcology does not allow for the dynamic redeployment of troops bait and bleed tactics would require.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`Fighting just beneath the walls of the arcology does not allow for the dynamic redeployment of troops guerrilla tactics would require.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`The imposing structure of the arcology itself provides plenty of opportunities to create fortified choke points from which to shatter the enemy assault.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`While the presence of the arcology near the battlefield is an advantage, it does limit maneuverability, lowering overall effectiveness of interior lines tactics.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`While the presence of the arcology near the battlefield is an advantage, it does limit maneuverability, lowering the chances of making an effective encirclement.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`Having the arcology near the battlefield means there are limited available maneuvers to your troops, who still needs to defend the structure, making defense in depth tactics not as effective.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`While an assault may save the arcology from getting involved at all, having the imposing structure so near does limit maneuverability and so the impetus of the lightning strike.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`While an attack may save the arcology from getting involved at all, having the imposing structure so near does limit maneuverability and so the impetus of the mass assault.`);
			}
		} else if (V.SecExp.war.terrain === "mountains") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`While the mountains offer great protection, they also limit maneuverability; bait and bleed tactics will not be quite as effective here.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`The mountains offer many excellent hiding spots and defensive positions, making guerrilla tactics very effective.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`The mountains offer plenty of opportunity to build strong defensive positions from which to shatter the enemy's assault.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`While the rough terrain complicates maneuvers, the defensive advantages offered by the mountains offsets its negative impact.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`The rough terrain complicates maneuvers; your men have a really hard time pulling off an effective encirclement in this environment.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`While mobility is limited, defensive positions are plentiful; your men are not able to fully exploit overextended assaults, but are able to better resist them.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`The rough terrain complicates maneuvers; your men have a really hard time pulling off an effective lightning strike in this environment.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`The rough terrain complicates maneuvers; your men have a really hard time pulling off an effective mass assault in this environment.`);
			}
		} else if (V.SecExp.war.terrain === "wasteland") {
			if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
				r.push(`While the wastelands are mostly open terrain, there are enough hiding spots to make bait and bleed tactics work well enough.`);
			} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
				r.push(`While the wastelands are mostly open terrain, there are enough hiding spots to make guerrilla tactics work well enough.`);
			} else if (V.SecExp.war.chosenTactic === "Choke Points") {
				r.push(`The wastelands are mostly open terrain; your men have a difficult time setting up effective fortified positions.`);
			} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
				r.push(`The wastelands, while rough, are mostly open terrain, where your men can exploit to the maximum the superior mobility of the defender.`);
			} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
				r.push(`The wastelands, while rough, are mostly open terrain; your men can set up an effective encirclement here.`);
			} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
				r.push(`The wastelands, while rough, are mostly open terrain, allowing your men to liberally maneuver to exploit overextended enemies.`);
			} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
				r.push(`The wastelands, while rough, are mostly open terrain, where your men are able to mount effective lightning strikes.`);
			} else if (V.SecExp.war.chosenTactic === "Human Wave") {
				r.push(`The wastelands, while rough, are mostly open terrain, where your men are able to mount effective mass assaults.`);
			}
		}

		if (V.SecExp.war.chosenTactic === "Bait and Bleed") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`Since the bands of raiders are used to be on high alert and on the move constantly, bait and bleed tactics are not effective against them.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`The modern armies hired by Free Cities are decently mobile, which means quick hit and run attacks will be less successful, but their discipline and confidence still make them quite susceptible to this type of attack.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`While old world armies are tough nuts to crack, their predictability makes them the perfect target for hit and run and harassment tactics.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`Freedom fighters live every day as chasing and being chased by far superior forces, they are far more experienced than your troops in this type of warfare and much less susceptible to it.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Guerrilla") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`Since the bands of raiders are used to be on high alert and on the move constantly, guerrilla tactics are not effective against them.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`The modern armies hired by Free Cities are highly mobile, which means quick hit and run attacks will be less successful, but their discipline and confidence still make them quite susceptible to this type of attack.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`While old world armies are tough nuts to crack, their predictability makes them the perfect target for hit and run and harassment tactics.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`Freedom fighters live every day as chasing and being chased by far superior forces, they are far more experienced than your troops in this type of warfare and much less susceptible to it.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Choke Points") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`Raiders lack heavy weaponry or armor, so making use of fortified positions is an excellent way to dissipate the otherwise powerful momentum of their assault.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`The high tech equipment Free Cities can afford to give their guns for hire means there's no defensive position strong enough to stop them, still the relatively low numbers means they will have to take a careful approach, slowing them down.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`Old world armies have both the manpower and the equipment to conquer any defensive position, making use of strong fortifications will only bring you this far against them.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`The lack of specialized weaponry means freedom fighters have a rather hard time overcoming tough defensive positions, unfortunately they have also a lot of experience in avoiding them.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Interior Lines") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`The highly mobile horde of raiders will not give much room for your troops to maneuver, lowering their tactical superiority.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`While decently mobile, Free Cities forces are not in high enough numbers to risk maintaining prolonged contact, allowing your troops to quickly disengage and redeploy where it hurts.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`Old world armies are not famous for the mobility, which makes them highly susceptible to any tactic that exploits maneuverability and speed.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`While not the best equipped army, the experience and mobility typical of freedom fighters groups make them tough targets for an army that relies itself on mobility.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Pincer Maneuver") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`While numerous, the undisciplined masses of raiders are easy prey for encirclements.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`While decently mobile, the low number of Free Cities expedition forces make them good candidates for encirclements.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`The discipline and numbers of old world armies make them quite difficult to encircle.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`While not particularly mobile, freedom fighters are used to fight against overwhelming odds, diminishing the effectiveness of the encirclement.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Defense In Depth") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`While their low discipline makes them prime candidates for an elastic defense type of strategy, their high numbers limit your troops maneuverability.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`With their low numbers Free Cities mercenaries are quite susceptible to this type of tactic, despite their mobility.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`With their low mobility old world armies are very susceptible to this type of strategy.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`Low mobility and not particularly high numbers mean freedom fighters can be defeated by employing elastic defense tactics.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Blitzkrieg") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`With their low discipline and lack of heavy equipment, lightning strikes are very effective against raider hordes.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`Having good equipment and discipline on their side, Free Cities expeditions are capable of responding to even strong lightning strikes.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`While disciplined, old world armies low mobility makes them highly susceptible to lightning strikes.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`While not well equipped, freedom fighters have plenty of experience fighting small, mobile attacks, making them difficult to defeat with lightning strikes.`);
			}
		} else if (V.SecExp.war.chosenTactic === "Human Wave") {
			if (V.SecExp.war.attacker.type === "raiders") {
				r.push(`The hordes of raiders are much more experienced than your soldiers in executing mass assaults and they also have a lot more bodies to throw in the grinder.`);
			} else if (V.SecExp.war.attacker.type === "free city") {
				r.push(`The good equipment and mobility of Free Cities mercenaries cannot save them from an organized mass assault.`);
			} else if (V.SecExp.war.attacker.type === "old world") {
				r.push(`Unfortunately the discipline and good equipment of old world armies allow them to respond well against a mass assault.`);
			} else if (V.SecExp.war.attacker.type === "freedom fighters") {
				r.push(`The relative low numbers and not great equipment typical of freedom fighters make them susceptible to being overwhelmed by an organized mass assault.`);
			}
		}
		r.push(`In the end`);
		if (V.SecExp.war.commander === "PC") {
			r.push(`you were`);
		} else {
			r.push(`your commander was`);
		}
		if (V.SecExp.war.tacticsSuccessful) {
			r.push(`<span class="green">able to successfully employ ${V.SecExp.war.chosenTactic} tactics,</span> greatly enhancing`);
		} else {
			r.push(`<span class="red">not able to effectively employ ${V.SecExp.war.chosenTactic} tactics,</span> greatly affecting`);
		}
		r.push(`the efficiency of your army.`);
		App.Events.addParagraph(node, r);
		r = [];
		node.append(unitsBattleReport());

		if (
			V.SF.Toggle && V.SF.Active >= 1 &&
			(V.SF.Squad.Firebase >= 7 || V.SF.Squad.GunS >= 1 || V.SF.Squad.Satellite >= 5 || V.SF.Squad.GiantRobot >= 6 || V.SF.Squad.MissileSilo >= 1)
		) {
			/* SF upgrades effects */
			App.Events.addParagraph(node, r);
			r = [];
			if (V.SF.Squad.Firebase >= 7) {
				r.push(`The artillery pieces installed around ${V.SF.Lower}'s firebase provided vital fire support to the troops in the field.`);
			}
			if (V.SF.Squad.GunS >= 1) {
				r.push(`The gunship gave our troops an undeniable advantage in recon capabilities, air superiority and fire support.`);
			}
			if (V.SF.Squad.Satellite >= 5 && V.SF.SatLaunched > 0) {
				r.push(`The devastating power of ${V.SF.Lower}'s satellite was employed with great efficiency against the enemy.`);
			}
			if (V.SF.Squad.GiantRobot >= 6) {
				r.push(`The giant robot of ${V.SF.Lower} proved to be a great boon to our troops, shielding many from the worst the enemy had to offer.`);
			}
			if (V.SF.Squad.MissileSilo >= 1) {
				r.push(`The missile silo exterminated many enemy soldiers even before the battle would begin.`);
			}
		}
	}/* closes check for surrender and bribery */

	App.Events.addParagraph(node, r);
	r = [];

	let menialPrice = Math.trunc((V.slaveCostFactor * 1000) / 100) * 100;
	menialPrice = Math.clamp(menialPrice, 500, 1500);

	captives = Math.trunc(captives);
	if (captives > 0) {
		let candidates = 0;
		r.push(`During the battle ${captives} attackers were captured.`);
		if (random(1, 100) <= 25) {
			candidates = 1;
			const roll = random(1, 100);
			if (roll <= 33) {
				candidates = 3;
			} else if (roll <= 66) {
				candidates = 2;
			}
			r.push(`${capFirstChar(num(candidates, true))} of them have the potential to be sex slaves.`);
		}

		const sell = function() {
			cashX((menialPrice * captives), "menialTransfer");
			return `Captives sold`;
		};

		const keep = function() {
			V.menials += (captives - candidates);
			for (let i = 0; i < candidates; i++) {
				const generateFemale = random(0, 99) < V.seeDicks;
				let slave = GenerateNewSlave((generateFemale ? "XY" : "XX"), {minAge: 16, maxAge: 32, disableDisability: 1});
				slave.weight = (generateFemale ? random(-20, 30) : random(0, 30));
				slave.muscles = (generateFemale ? random(15, 80) : random(25, 80));
				slave.waist = (generateFemale ? random(10, 80) : random(-20, 20));
				slave.skill.combat = 1;
				const {He} = getPronouns(slave);
				slave.origin = `${He} is an enslaved ${V.SecExp.war.attacker.type} soldier captured during a battle.`;
				newSlave(slave); // skip New Slave Intro
			}
			return `All captives added as slaves.`;
		};

		App.Events.addResponses(node, [
			new App.Events.Result(`sell them all immediately`, sell),
			new App.Events.Result(`keep them as slaves`, keep),
		]);
	}

	/* resets variables */
	V.majorBattle = 0;
	V.SecExp.units.bots.isDeployed = 0;
	for (const squad of App.SecExp.unit.humanSquads()) {
		squad.isDeployed = 0;
	}
	App.Events.addParagraph(node, r);
	return node;

	function unitsBattleReport() {
		const el = document.createElement("div");
		if (V.SecExp.war.losses === 0) {
			if (App.SecExp.battle.deployedUnits('bots')) {
				App.UI.DOM.appendNewElement("div", el, `Security Drones: no casualties.`);
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				App.UI.DOM.appendNewElement("div", el, `${num(V.SF.ArmySize)} soldiers from ${V.SF.Lower} joined the battle: no casualties suffered`);
			}
			const noCasualties = function(units) {
				for (const unit of units) {
					if (unit.isDeployed === 1) {
						const r = [`${unit.platoonName}: no casualties.`];
						unit.battlesFought++;
						if (unit.training < 100) {
							if (random(1, 100) > 60) {
								r.push(`Experience has increased.`);
								unit.training += random(5, 15) + V.majorBattle * random(5, 15);
							}
						}
						App.Events.addNode(el, r, "div");
					}
				}
			};
			if (App.SecExp.battle.deployedUnits('militia') >= 1) {
				noCasualties(V.SecExp.units.militia.squads);
			}
			if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
				noCasualties(V.SecExp.units.slaves.squads);
			}
			if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
				noCasualties(V.SecExp.units.mercs.squads);
			}
		} else if (V.SecExp.war.losses > 0) {
			/* if the losses are more than zero */
			/* generates a list of randomized losses, from which each unit picks one at random */
			let losses = V.SecExp.war.losses;
			const averageLosses = Math.trunc(losses / App.SecExp.battle.deployedUnits());
			let validityCount = 0;
			let assignedLosses;
			for (let i = 0; i < App.SecExp.battle.deployedUnits(); i++) {
				assignedLosses = Math.trunc(Math.clamp(averageLosses + random(-5, 5), 0, 100));
				if (assignedLosses > losses) {
					assignedLosses = losses;
					losses = 0;
				} else {
					losses -= assignedLosses;
				}
				lossesList.push(assignedLosses);
				validityCount += assignedLosses;
			}
			if (losses > 0) {
				lossesList[random(lossesList.length - 1)] += losses;
			}
			lossesList.shuffle();

			/* sanity check for losses */
			let count = 0;
			for (let i = 0; i < lossesList.length; i++) {
				if (!Number.isInteger(lossesList[i])) {
					lossesList[i] = 0;
				}
				count += lossesList[i];
			}
			if (count < V.SecExp.war.losses) {
				const rand = random(lossesList.length - 1);
				lossesList[rand] += V.SecExp.war.losses - count;
			} else if (count > V.SecExp.war.losses) {
				const diff = count - V.SecExp.war.losses;
				const rand = random(lossesList.length - 1);
				lossesList[rand] = Math.clamp(lossesList[rand] - diff, 0, 100);
			}

			/* assigns the losses and notify the player */
			if (App.SecExp.battle.deployedUnits('bots')) {
				let loss = lossesList.pluck();
				loss = Math.clamp(loss, 0, V.SecExp.units.bots.troops);
				V.SecExp.units.bots.troops -= loss;
				const r = [`Security drones:`];
				if (loss <= 0) {
					r.push(`no casualties`);
				} else if (loss <= V.SecExp.units.bots.troops * 0.2) {
					r.push(`light casualties`);
				} else if (loss <= V.SecExp.units.bots.troops * 0.4) {
					r.push(`moderate casualties`);
				} else if (loss <= V.SecExp.units.bots.troops * 0.6) {
					r.push(`heavy casualties`);
				} else {
					r.push(`catastrophic casualties`);
				}
				r.push(`suffered.`);
				if (V.SecExp.units.bots.troops <= 5) {
					V.SecExp.units.bots.active = 0;
					r.push(`Unfortunately the losses they took were simply too great, their effective combatants are in so small number you can no longer call them a deployable unit. It will take quite the investment to rebuild them.`);
				} else if (V.SecExp.units.bots.troops <= 10) {
					r.push(`The unit has very few operatives left, it risks complete annihilation if deployed again.`);
				}
				App.Events.addNode(el, r, "div");
			}
			if (V.SF.Toggle && V.SF.Active >= 1 && V.SecExp.war.deploySF) {
				let loss = lossesList.pluck();
				loss = Math.clamp(loss, 0, V.SF.ArmySize);
				const r = [`${num(V.SF.ArmySize)} soldiers from ${V.SF.Lower} joined the battle:`];
				if (loss <= 0) {
					r.push(`no casualties`);
				} else if (loss <= 10) {
					r.push(`light casualties`);
				} else if (loss <= 30) {
					r.push(`moderate casualties`);
				} else if (loss <= 60) {
					r.push(`heavy casualties`);
				} else {
					r.push(`catastrophic casualties`);
				}
				r.push(`suffered.`);
				V.SF.ArmySize -= loss;
				App.Events.addNode(el, r, "div");
			}
			if (App.SecExp.battle.deployedUnits('militia') >= 1) {
				loopThroughUnits(V.SecExp.units.militia.squads);
			}
			if (App.SecExp.battle.deployedUnits('slaves') >= 1) {
				loopThroughUnits(V.SecExp.units.slaves.squads);
			}
			if (App.SecExp.battle.deployedUnits('mercs') >= 1) {
				loopThroughUnits(V.SecExp.units.militia.squads);
			}
		} else {
			App.UI.DOM.appendNewElement("div", el, `Error: losses are a negative number or NaN`, "red");
		}/* closes check for more than zero casualties */
		return el;

		function loopThroughUnits(units) {
			for (const unit of units) {
				if (unit.isDeployed === 1) {
					unit.battlesFought++;
					let loss = lossesList.pluck();
					loss = Math.clamp(loss, 0, unit.troops);
					const r = [`${unit.platoonName}:`];
					if (loss <= 0) {
						r.push(`no casualties`);
					} else if (loss <= unit.troops * 0.2) {
						r.push(`light casualties`);
					} else if (loss <= unit.troops * 0.4) {
						r.push(`moderate casualties`);
					} else if (loss <= unit.troops * 0.6) {
						r.push(`heavy casualties`);
					} else {
						r.push(`catastrophic casualties`);
					}
					r.push(`suffered.`);
					const med = Math.round(Math.clamp(loss * unit.medics * 0.25, 1, loss));
					if (unit.medics === 1 && loss > 0) {
						r.push(`Some men were saved by their medics.`);
					}
					unit.troops -= Math.trunc(Math.clamp(loss - med, 0, unit.maxTroops));
					V.SecExp.units.militia.dead += Math.trunc(loss - med);
					if (unit.training < 100) {
						if (random(1, 100) > 60) {
							r.push(`Experience has increased.`);
							unit.training += random(5, 15) + V.majorBattle * random(5, 15);
						}
					}
					App.Events.addNode(el, r, "div");
					if (unit.troops <= 5) {
						unit.active = 0;
						App.UI.DOM.appendNewElement("div", el, `Unfortunately the losses they took were simply too great, their effective combatants are in so small number you can no longer call them a deployable unit. The remnants will be sent home honored as veterans or reorganized in a new unit.`);
					} else if (unit.troops <= 10) {
						App.UI.DOM.appendNewElement("div", el, `The unit has very few operatives left, it risks complete annihilation if deployed again.`);
					}
				}
			}
		}
	}
};
