App.Art.getMaterialById = function(scene, id) {
	for (const material of scene.materials) {
		if(material.matId === id) {
			return material;
		}
	}
	return null;
};

App.Art.getMorphById = function(scene, id) {
	for (const morph of scene.models[0].morphs) {
		if(morph.morphId === id) {
			return morph;
		}
	}
	return null;
};

App.Art.getSurfaceById = function(scene, id) {
	for (const figure of scene.models[0].figures) {
		for (const surface of figure.surfaces) {
			if (surface.surfaceId === id) {
				return surface;
			}
		}
	}
	return null;
};

App.Art.getMatIdsBySurface = function(scene, id) {
	for (const figure of scene.models[0].figures) {
		for (const surface of figure.surfaces) {
			if (surface .surfaceId === id) {
				return surface.matIds;
			}
		}
	}
};

App.Art.resetMorphs = function(scene) {
	for (let i =0; i < scene.models[0].morphs.length; i++) {
		scene.models[0].morphs[i].value = App.Art.defaultScene.models[0].morphs[i].value;
	}
};

App.Art.applyFigures = function(slave, scene) {
	let figures = [];

	figures.push("Genesis8Female");
	figures.push("Geometry Shell 3");
	figures.push("Futalicious Shell");
	figures.push("Genesis8FemaleEyelashes");

	switch(slave.hStyle) {
		case "afro": figures.push("prae-yarahair_174011"); break;
		case "cornrows": figures.push("TIGER BRAIDS_163349"); break;
		case "bun": figures.push("Adia Hair_26615"); break;
		case "neat": figures.push("SamiraHair_103927"); break;
		case "strip": figures.push("ValRebelH_12512"); break;
		case "tails": figures.push("LLF-DazStudioFemaleHair_758"); break;
		case "up": figures.push("Pina Hair Gen8 8_93350"); break;
		case "ponytail": figures.push("ElitePonytail"); break;
		case "braided": figures.push("LLF-MishkaGeBase1_31774"); break;
		case "dreadlocks": figures.push("Dreads_197696"); break;
		case "permed": figures.push("IchigoHair_77918"); break;
		case "curled": figures.push("aprilyshHavanaHair_32519"); break;
		case "luxurious": figures.push("SW_BaronessHR_33121"); break;
		case "messy bun": figures.push("KrayonHair_47547"); break;
		case "messy": figures.push("MessyHair_35245"); break;
		case "eary": figures.push("GeorginaHair_72382"); break;
		case "undercut": figures.push("EditHairGN2Female_112247"); break;
		case "bangs": figures.push("Neko Hair Genesis 3 Female_131369"); break;
		case "hime": figures.push("Nyohair_141863"); break;
		case "drills": figures.push("LLF-BunnyCurls-G8_111356"); break;
		case "bald": break;
		case "shaved": break;
		case "buzzcut": break;
		case "trimmed": break;
		default: break;
	}

	for (let i=0; i < scene.models[0].figures.length; i++) {
		scene.models[0].figures[i].visible = false;
		for (let j =0; j < figures.length; j++) {
			if (scene.models[0].figures[i].figId === figures[j]) {
				scene.models[0].figures[i].visible = true;
			}
		}
	}
};

App.Art.applySurfaces = function(slave, scene) {
	let surfaces = [];

	if (slave.dick !== 0 || (!(slave.scrotum <= 0 || slave.balls <= 0))) {
		surfaces.push(["Futalicious_Genitalia_G8F_Shaft_Futalicious_Shell", "visible", true]);
		surfaces.push(["Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "visible", true]);
		surfaces.push(["Futalicious_Genitalia_G8F_Testicles_Futalicious_Shell", "visible", true]);
		surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "visible", true]);
		surfaces.push(["Futalicious_Genitalia_G8F_Torso_Middle_Futalicious_Shell", "visible", true]);
		surfaces.push(["Futalicious_Genitalia_G8F_Torso_Back_Futalicious_Shell", "visible", true]);
		surfaces.push(["Futalicious_Genitalia_G8F_Rectum_Futalicious_Shell", "visible", false]);
		surfaces.push(["Torso_Front", "visible", true]);
		surfaces.push(["Torso_Middle", "visible", true]);
		surfaces.push(["Torso_Back", "visible", true]);

		surfaces.push(["Genitalia", "visible", true]);
		surfaces.push(["Anus", "visible", true]);
		surfaces.push(["new_gens_V8_1840_Genitalia", "visible", true]);
		surfaces.push(["new_gens_V8_1840_Anus", "visible", true]);
	} else {
		surfaces.push(["Futalicious_Genitalia_G8F_Shaft_Futalicious_Shell", "visible", false]);
		surfaces.push(["Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "visible", false]);
		surfaces.push(["Futalicious_Genitalia_G8F_Testicles_Futalicious_Shell", "visible", false]);
		surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "visible", false]);
		surfaces.push(["Futalicious_Genitalia_G8F_Torso_Middle_Futalicious_Shell", "visible", false]);
		surfaces.push(["Futalicious_Genitalia_G8F_Torso_Back_Futalicious_Shell", "visible", false]);
		surfaces.push(["Futalicious_Genitalia_G8F_Rectum_Futalicious_Shell", "visible", false]);
		surfaces.push(["Torso_Front", "visible", false]);
		surfaces.push(["Torso_Middle", "visible", false]);
		surfaces.push(["Torso_Back", "visible", false]);

		surfaces.push(["Genitalia", "visible", true]);
		surfaces.push(["Anus", "visible", true]);
		surfaces.push(["new_gens_V8_1840_Genitalia", "visible", true]);
		surfaces.push(["new_gens_V8_1840_Anus", "visible", true]);
	}

	// surfaces.push(["Arms", "visible", hasBothArms(slave)]);
	// surfaces.push(["Fingernails", "visible", hasBothArms(slave)]);
	// surfaces.push(["Legs", "visible", hasBothLegs(slave)]);
	// surfaces.push(["Toenails", "visible", hasBothLegs(slave)]);

	let cockSkin;
	let skin;

	switch (slave.skin) {
		case "pure white":
		case "ivory":
		case "white":
			cockSkin = "White";
			skin = "Ceridwen";
			break;
		case "extremely pale":
		case "very pale":
			cockSkin = "White";
			skin = "Celinette";
			break;
		case "pale":
		case "extremely fair":
			cockSkin = "White";
			skin = "Kimmy";
			break;
		case "very fair":
		case "fair":
			cockSkin = "Light";
			skin = "Saffron";
			break;
		case "light":
		case "light olive":
			cockSkin = "Light";
			skin = "FemaleBase";
			break;
		case "sun tanned":
		case "spray tanned":
		case "tan":
			cockSkin = "Light";
			skin = "Reagan";
			break;
		case "olive":
			cockSkin = "Mid";
			skin = "Kathy";
			break;
		case "bronze":
			cockSkin = "Mid";
			skin = "Mylou";
			break;
		case "dark olive":
			cockSkin = "Mid";
			skin = "Adaline";
			break;
		case "dark":
			cockSkin = "Mid";
			skin = "Daphne";
			break;
		case "light beige":
			cockSkin = "Mid";
			skin = "Minami";
			break;
		case "beige":
			cockSkin = "Mid";
			skin = "Tara";
			break;
		case "dark beige":
		case "light brown":
			cockSkin = "Dark";
			skin = "Topmodel";
			break;
		case "brown":
		case "dark brown":
			cockSkin = "Dark";
			skin = "Angelica";
			break;
		case "black":
		case "ebony":
		case "pure black":
			cockSkin = "Dark";
			skin = "DarkSkin";
			break;
		default:
			cockSkin = "Light";
			skin = "FemaleBase";
	}

	surfaces.push(["Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	surfaces.push(["Futalicious_Genitalia_G8F_Shaft_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	surfaces.push(["Futalicious_Genitalia_G8F_Testicles_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	// surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	surfaces.push(["Futalicious_Genitalia_G8F_Torso_Middle_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	surfaces.push(["Futalicious_Genitalia_G8F_Torso_Back_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	surfaces.push(["Futalicious_Genitalia_G8F_Rectum_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
	// surfaces.push(["Torso_Front", "matIds", [skin + "Torso"]]);
	surfaces.push(["Torso_Middle", "matIds", [skin + "Torso"]]);
	surfaces.push(["Torso_Back", "matIds", [skin + "Torso"]]);

	switch(slave.hStyle) {
		case "buzzcut":
		case "trimmed":
			surfaces.push(["Torso", "matIds", [skin + "Torso", "shaved_torso"]]);
			surfaces.push(["Face", "matIds", [skin + "Face", "shaved_face"]]);
			break;
		case "bald":
		case "shaved":
		default:
			surfaces.push(["Torso", "matIds", [skin + "Torso"]]);
			surfaces.push(["Face", "matIds", [skin + "Face"]]);
			break;
	}

	surfaces.push(["Lips", "matIds", [skin + "Lips"]]);
	surfaces.push(["Ears", "matIds", [skin + "Ears"]]);
	surfaces.push(["Legs", "matIds", [skin + "Legs"]]);
	surfaces.push(["Arms", "matIds", [skin + "Arms"]]);
	surfaces.push(["EyeSocket", "matIds", [skin + "Face"]]);
	surfaces.push(["Toenails", "matIds", [skin + "Toenails"]]);
	surfaces.push(["Fingernails", "matIds", [skin + "Fingernails"]]);
	// surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia"]);
	surfaces.push(["Anus", "matIds", [skin + "Anus"]]);

	switch (slave.pubicHStyle) {
		case "hairless":
		case "waxed":
		case "bald":
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
			break;
		case "neat":
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia", "PubicNeat"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso", "PubicNeat"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "PubicNeat"]]);
			break;
		case "in a strip":
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia", "PubicStrip"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso", "PubicStrip"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "PubicStrip"]]);
			break;
		case "bushy":
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia", "PubicBushy"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso", "PubicBushy"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "PubicBushy"]]);

			break;
		case "very bushy":
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia", "PubicVeryBushy"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso", "PubicVeryBushy"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "PubicVeryBushy"]]);
			break;
		case "bushy in the front and neat in the rear":
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia", "PubicBushyFront"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso", "PubicBushyFront"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell", "PubicBushyFront"]]);
			break;
		default:
			surfaces.push(["Genitalia",	"matIds", [skin + "Genitalia"]]);
			surfaces.push(["Torso_Front", "matIds", [skin + "Torso"]]);
			surfaces.push(["Futalicious_Genitalia_G8F_Torso_Front_Futalicious_Shell", "matIds", [cockSkin + "Futalicious_Genitalia_G8F_Glans_Futalicious_Shell"]]);
			break;
	}

	for (let i=0, count=0; i < scene.models[0].figures.length; i++) {
		for (let j=0; j < scene.models[0].figures[i].surfaces.length; j++, count++) {
			for (let h =0; h < surfaces.length; h++) {
				if (scene.models[0].figures[i].surfaces[j].surfaceId === surfaces[h][0]) {
					scene.models[0].figures[i].surfaces[j][surfaces[h][1]] = surfaces[h][2];
				}
			}
		}
	}
};

App.Art.applyMaterials = function(slave, scene) {
	let materials = [];

	function hexToRgb(hex) {
		hex = hex.replace('#', '');
		let r = parseInt(hex.substring(0, 2), 16);
		let g = parseInt(hex.substring(2, 4), 16);
		let b = parseInt(hex.substring(4, 6), 16);
		return [r/255, g/255, b/255];
	}

	let hairColor = hexToRgb(extractColor(slave.hColor));
	let lipsColor = hexToRgb(skinColorCatcher(slave).lipsColor);
	// let lipsColor = hexToRgb("#ffffff");

	let makeupColor;
	let makeupOpacity;
	let lipsGloss;

	switch (slave.makeup) {
		case 1:
			// Nice
			makeupColor = "#ff69b4";
			makeupOpacity = 0.5;
			lipsGloss = 32;
			break;
		case 2:
			// Gorgeous
			makeupColor = "#8b008b";
			makeupOpacity = 0.7;
			lipsGloss = 10;
			break;
		case 3:
			// Hair coordinated
			makeupColor = extractColor(slave.hColor);
			makeupOpacity = 0.3;
			lipsGloss = 10;
			break;
		case 4:
			// Slutty
			makeupColor = "#B70000";
			makeupOpacity = 0.8;
			lipsGloss = 5;
			break;
		case 5:
			// Neon
			makeupColor = "#DC143C";
			makeupOpacity = 1;
			lipsGloss = 1;
			break;
		case 6:
			// Neon hair coordinated
			makeupColor = extractColor(slave.hColor);
			makeupOpacity = 1;
			lipsGloss = 1;
			break;
		case 7:
			// Metallic
			makeupColor = "#b22222";
			makeupOpacity = 0.7;
			lipsGloss = 1;
			break;
		case 8:
			// Metallic hair coordinated
			makeupColor = extractColor(slave.hColor);
			makeupOpacity = 0.7;
			lipsGloss = 1;
			break;
		default:
			makeupColor = "#ffffff";
			makeupOpacity = 0;
			lipsGloss = 32;
			break;
	}

	makeupColor = hexToRgb(makeupColor);
	lipsColor[0] = makeupColor[0] * makeupOpacity + lipsColor[0] * (1 - makeupOpacity);
	lipsColor[1] = makeupColor[1] * makeupOpacity + lipsColor[1] * (1 - makeupOpacity);
	lipsColor[2] = makeupColor[2] * makeupOpacity + lipsColor[2] * (1 - makeupOpacity);

	let nailColor;
	switch (slave.nails) {
		case 2:
			// color-coordinated with hair
			nailColor = extractColor(slave.hColor);
			break;
		case 4:
			// bright and glittery
			nailColor = "#ff0000";
			break;
		case 6:
			// neon
			nailColor = "#DC143C";
			break;
		case 7:
			// color-coordinated neon
			nailColor = extractColor(slave.hColor);
			break;
		case 8:
			// metallic
			nailColor = "#b22222";
			break;
		case 9:
			// color-coordinated metallic
			nailColor = extractColor(slave.hColor);
			break;
		default:
			nailColor = "#ffffff";
			break;
	}

	nailColor = hexToRgb(nailColor);

	switch(slave.hStyle) {
		case "afro":
			materials.push(["yara_scalp", "Kd", hairColor]);
			materials.push(["yara_hair", "Kd", hairColor]);
			break;
		case "cornrows":
			materials.push(["tiger_scalp", "Kd", hairColor]);
			materials.push(["tiger_hair", "Kd", hairColor]);
			break;
		case "bun":
			materials.push(["adia_scalp", "Kd", hairColor]);
			materials.push(["adia_hair", "Kd", hairColor]);
			break;
		case "neat":
			materials.push(["samira_scalp", "Kd", hairColor]);
			materials.push(["samira_hair", "Kd", hairColor]);
			break;
		case "strip":
			materials.push(["rebel_scalp", "Kd", hairColor]);
			materials.push(["rebel_hair", "Kd", hairColor]);
			break;
		case "tails":
			materials.push(["kinley_scalp", "Kd", hairColor]);
			materials.push(["kinley_hair_thin_strands", "Kd", hairColor]);
			materials.push(["kinley_hair_long", "Kd", hairColor]);
			materials.push(["kinley_hair_strands", "Kd", hairColor]);
			materials.push(["kinley_hair_base", "Kd", hairColor]);
			materials.push(["kinley_hair_tie", "Kd", hairColor]);
			break;
		case "up":
			materials.push(["pina_scalp", "Kd", hairColor]);
			materials.push(["pina_hair1", "Kd", hairColor]);
			materials.push(["pina_hair2", "Kd", hairColor]);
			break;
		case "ponytail":
			materials.push(["ponytail_scalp", "Kd", hairColor]);
			materials.push(["ponytail_hair1", "Kd", hairColor]);
			materials.push(["ponytail_hair2", "Kd", hairColor]);
			materials.push(["ponytail_hair3", "Kd", hairColor]);
			materials.push(["ponytail_holder", "Kd", hairColor]);
			break;
		case "braided":
			materials.push(["mishka_scalp", "Kd", hairColor]);
			materials.push(["mishka_hair1", "Kd", hairColor]);
			materials.push(["mishka_hair2", "Kd", hairColor]);
			materials.push(["mishka_hair3", "Kd", hairColor]);
			break;
		case "dreadlocks":
			materials.push(["dreads_scalp", "Kd", hairColor]);
			materials.push(["dreads_hair", "Kd", hairColor]);
			break;
		case "permed":
			materials.push(["ichigo_scalp", "Kd", hairColor]);
			materials.push(["ichigo_hair1", "Kd", hairColor]);
			materials.push(["ichigo_hair2", "Kd", hairColor]);
			break;
		case "curled":
			materials.push(["havana_hair", "Kd", hairColor]);
			break;
		case "luxurious":
			materials.push(["baroness_scalp", "Kd", hairColor]);
			materials.push(["baroness_hair", "Kd", hairColor]);
			break;
		case "messy bun":
			materials.push(["krayon_scalp", "Kd", hairColor]);
			materials.push(["krayon_hair1", "Kd", hairColor]);
			materials.push(["krayon_hair2", "Kd", hairColor]);
			materials.push(["krayon_hair3", "Kd", hairColor]);
			materials.push(["krayon_hair4", "Kd", hairColor]);
			break;
		case "messy":
			materials.push(["messy_scalp", "Kd", hairColor]);
			materials.push(["messy_hair", "Kd", hairColor]);
			break;
		case "eary":
			materials.push(["georgina_scalp", "Kd", hairColor]);
			materials.push(["georgina_hair1", "Kd", hairColor]);
			materials.push(["georgina_hair2", "Kd", hairColor]);
			break;
		case "undercut":
			materials.push(["edit_scalp", "Kd", hairColor]);
			materials.push(["edit_hair", "Kd", hairColor]);
			break;
		case "bangs":
			materials.push(["neko_scalp", "Kd", hairColor]);
			materials.push(["neko_hair", "Kd", hairColor]);
			break;
		case "hime":
			materials.push(["nyo_scalp", "Kd", hairColor]);
			materials.push(["nyo_hair", "Kd", hairColor]);
			break;
		case "drills":
			materials.push(["bunny_scalp", "Kd", hairColor]);
			materials.push(["bunny_hair1", "Kd", hairColor]);
			materials.push(["bunny_hair2", "Kd", hairColor]);
			materials.push(["bunny_hair3", "Kd", hairColor]);
			materials.push(["bunny_hair4", "Kd", hairColor]);
			break;
		case "buzzcut":
		case "trimmed":
			materials.push(["shaved_face", "Kd", hairColor]);
			materials.push(["shaved_torso", "Kd", hairColor]);
			break;
		case "bald":
		case "shaved":
		default: break;
	}

	let irisColor;
	let scleraColor;

	if (hasAnyEyes(slave)) {
		irisColor = hexToRgb(extractColor(hasLeftEye(slave) ? extractColor(slave.eye.left.iris) : extractColor(slave.eye.right.iris)));
		scleraColor = hexToRgb(extractColor(hasLeftEye(slave) ? extractColor(slave.eye.left.sclera) : extractColor(slave.eye.right.sclera)));
	} else {
		irisColor = hexToRgb(extractColor("black"));
		scleraColor = hexToRgb(extractColor("black"));
	}

	materials.push(["Irises", "d", 3.8]);
	materials.push(["Irises", "Kd", [irisColor[0] * 0.8, irisColor[1] * 0.8, irisColor[2] * 0.8]]);
	materials.push(["Sclera", "Kd", [scleraColor[0] * 1.2, scleraColor[1] * 1.2, scleraColor[2] * 1.2]]);

	switch (slave.skin) {
		case "pure white":
		case "ivory":
		case "white":
			materials.push(["CeridwenFingernails", "Kd", nailColor]);
			materials.push(["CeridwenLips", "Kd", lipsColor]);
			materials.push(["CeridwenLips", "Ns", lipsGloss]);
			materials.push(["WhiteFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1.05, 1, 1]]);
			break;
		case "extremely pale":
		case "very pale":
			materials.push(["CelinetteFingernails", "Kd", nailColor]);
			materials.push(["CelinetteLips", "Kd", lipsColor]);
			materials.push(["CelinetteLips", "Ns", lipsGloss]);
			materials.push(["WhiteFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1.05, 1, 1]]);
			break;
		case "pale":
		case "extremely fair":
			materials.push(["KimmyFingernails", "Kd", nailColor]);
			materials.push(["KimmyLips", "Kd", lipsColor]);
			materials.push(["KimmyLips", "Ns", lipsGloss]);
			materials.push(["WhiteFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1, 0.95, 0.91]]);
			break;
		case "very fair":
		case "fair":
			materials.push(["SaffronFingernails", "Kd", nailColor]);
			materials.push(["SaffronLips", "Kd", lipsColor]);
			materials.push(["SaffronLips", "Ns", lipsGloss]);
			materials.push(["LightFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1.1, 1.1, 1.1]]);
			break;
		case "light":
		case "light olive":
			materials.push(["FemaleBaseFingernails", "Kd", nailColor]);
			materials.push(["FemaleBaseLips", "Kd", lipsColor]);
			materials.push(["FemaleBaseLips", "Ns", lipsGloss]);
			materials.push(["LightFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1.0, 1.0, 1.0]]);
			break;
		case "sun tanned":
		case "spray tanned":
		case "tan":
			materials.push(["ReaganFingernails", "Kd", nailColor]);
			materials.push(["ReaganLips", "Kd", lipsColor]);
			materials.push(["ReaganLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.97, 0.95, 0.95]]);
			break;
		case "olive":
			materials.push(["KathyFingernails", "Kd", nailColor]);
			materials.push(["KathyLips", "Kd", lipsColor]);
			materials.push(["KathyLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.95, 0.92, 0.92]]);
			break;
		case "bronze":
			materials.push(["MylouFingernails", "Kd", nailColor]);
			materials.push(["MylouLips", "Kd", lipsColor]);
			materials.push(["MylouLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.91, 0.95, 0.98]]);
			break;
		case "dark olive":
			materials.push(["AdalineFingernails", "Kd", nailColor]);
			materials.push(["AdalineLips", "Kd", lipsColor]);
			materials.push(["AdalineLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.90, 0.90, 0.90]]);
			break;
		case "dark":
			materials.push(["DaphneFingernails", "Kd", nailColor]);
			materials.push(["DaphneLips", "Kd", lipsColor]);
			materials.push(["DaphneLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.88, 0.93, 0.96]]);
			break;
		case "light beige":
			materials.push(["MinamiFingernails", "Kd", nailColor]);
			materials.push(["MinamiLips", "Kd", lipsColor]);
			materials.push(["MinamiLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.68, 0.74, 0.8]]);
			break;
		case "beige":
			materials.push(["TaraFingernails", "Kd", nailColor]);
			materials.push(["TaraLips", "Kd", lipsColor]);
			materials.push(["TaraLips", "Ns", lipsGloss]);
			materials.push(["MidFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.77, 0.77, 0.77]]);
			break;
		case "dark beige":
		case "light brown":
			materials.push(["TopmodelFingernails", "Kd", nailColor]);
			materials.push(["TopmodelLips", "Kd", lipsColor]);
			materials.push(["TopmodelLips", "Ns", lipsGloss]);
			materials.push(["DarkFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1.7, 1.75, 1.75]]);
			break;
		case "brown":
		case "dark brown":
			materials.push(["AngelicaFingernails", "Kd", nailColor]);
			materials.push(["AngelicaLips", "Kd", lipsColor]);
			materials.push(["AngelicaLips", "Ns", lipsGloss]);
			materials.push(["DarkFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.85, 0.85, 0.85]]);
			break;
		case "black":
		case "ebony":
		case "pure black":
			materials.push(["DarkSkinFingernails", "Kd", nailColor]);
			materials.push(["DarkSkinLips", "Kd", lipsColor]);
			materials.push(["DarkSkinLips", "Ns", lipsGloss]);
			materials.push(["DarkFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [0.7, 0.7, 0.77]]);
			break;
		default:
			materials.push(["FemaleBaseFingernails", "Kd", nailColor]);
			materials.push(["FemaleBaseLips", "Kd", lipsColor]);
			materials.push(["FemaleBaseLips", "Ns", lipsGloss]);
			materials.push(["LightFutalicious_Genitalia_G8F_Glans_Futalicious_Shell", "Kd", [1.0, 1.0, 1.0]]);
	}

	let pubicColor = hexToRgb(extractColor(slave.pubicHColor));
	switch (slave.pubicHStyle) {
		case "hairless":
		case "waxed":
		case "bald":
			break;
		case "neat":
			materials.push(["PubicNeat", "Kd", pubicColor]);
			break;
		case "in a strip":
			materials.push(["PubicStrip", "Kd", pubicColor]);
			break;
		case "bushy":
			materials.push(["PubicBushy", "Kd", pubicColor]);
			break;
		case "very bushy":
			materials.push(["PubicVeryBushy", "Kd", pubicColor]);
			break;
		case "bushy in the front and neat in the rear":
			materials.push(["PubicBushyFront", "Kd", pubicColor]);
			break;
		default:
			break;
	}

	let torso = App.Art.getMatIdsBySurface(scene, "Torso")[0];

	if (slave.scar.hasOwnProperty("belly") && slave.scar.belly["c-section"] > 0) {
		materials.push([torso, "map_Kn", scene.textureMap["Victoria8_Torso_CNM_1002.jpg"]]);
	} else {
		materials.push([torso, "map_Kn", scene.textureMap["Victoria8_Torso_NM_1002.jpg"]]);
	}

	for (let i =0; i < scene.materials.length; i++) {
		for (let j =0; j < materials.length; j++) {
			if (scene.materials[i].matId === materials[j][0]) {
				scene.materials[i][materials[j][1]] = materials[j][2];
			}
		}
	}
};

App.Art.applyMorphs = function(slave, scene) {
	let morphs = [];

	function convertRange(sourceMin, sourceMax, targetMin, targetMax, value) {
		return (targetMax-targetMin)/(sourceMax-sourceMin)*(value-sourceMin)+targetMin;
	}

	function random(seed) {
		let x = Math.sin(seed+1) * 10000;
		return x - Math.floor(x);
	}


	if(hasBothArms(slave) && hasBothLegs(slave)) {
		if (scene.inspectView) {
			morphs.push(["posesInspect", 1]);
			morphs.push(["posesInspectGen", 1]);
		} else if (slave.devotion > 50) {
			morphs.push(["posesHigh", 1]);
		} else if (slave.devotion > -20) {
			morphs.push(["posesMid", 1]);
		} else {
			morphs.push(["posesLow", 1]);
		}
	}

	if (slave.trust < 0) {
		morphs.push(["expressionsFear", Math.abs(slave.trust)/100]);
	} else {
		morphs.push(["expressionsHappy", slave.trust/100]);
	}

	// used for interpolating mixed race based on slave ID
	let races = ["raceWhite", "raceAsian", "raceLatina", "raceBlack", "racePacific", "raceEuropean", "raceAmerindian", "raceSemitic", "raceEastern", "raceAryan", "raceLatina", "raceMalay"];
	let index1 = Math.floor(random(slave.ID+1) * races.length);
	let index2 = Math.floor(random(slave.ID-1) * (races.length-1));

	switch (slave.race) {
		case "white":
			morphs.push(["raceWhite", 1]); break;
		case "asian":
			morphs.push(["raceAsian", 1]); break;
		case "latina":
			morphs.push(["raceLatina", 1]); break;
		case "black":
			morphs.push(["raceBlack", 1]); break;
		case "pacific islander":
			morphs.push(["racePacific", 1]); break;
		case "southern european":
			morphs.push(["raceEuropean", 1]); break;
		case "amerindian":
			morphs.push(["raceAmerindian", 1]); break;
		case "semitic":
			morphs.push(["raceSemitic", 1]); break;
		case "middle eastern":
			morphs.push(["raceEastern", 1]); break;
		case "indo-aryan":
			morphs.push(["raceAryan", 1]); break;
		case "malay":
			morphs.push(["raceMalay", 1]); break;
		case "mixed race":
			morphs.push([races[index1], 0.5]);
			races.splice(index1, index1);
			morphs.push([races[index2], 0.5]);
			break;
	}

	if (slave.lips < 10) {
		morphs.push(["lipsShapeThin", 1]);
	} else if (slave.lips < 20) {
		morphs.push(["lipsShapeNormal", 1]);
	} else if (slave.lips < 40) {
		morphs.push(["lipsShapePretty", 1]);
	} else if (slave.lips < 70) {
		morphs.push(["lipsShapePlush", 1]);
	} else if (slave.lips < 95) {
		morphs.push(["lipsShapeHuge", 1]);
	} else {
		morphs.push(["lipsShapeFacepussy", slave.lips/100]);
	}

	let eyeShape = ["eyeShapeNormal", "eyeShapeWide", "eyeShapeRound", "eyeShapeSmall", "eyeShapeSlit", "eyeShapeCute", "eyeShapeOpen"];
	let eye = Math.floor(random(slave.ID+3) * eyeShape.length);
	if (eye > 0) {
		morphs.push(eyeShape[eye], 1);
	}

	let noseShape = ["noseShapeNormal", "noseShapeWide", "noseShapeForward", "noseShapeFlat", "noseShapeTriangular", "noseShapeSmall"];
	let nose = Math.floor(random(slave.ID+4) * noseShape.length);
	if (nose > 0) {
		morphs.push(noseShape[nose], 1);
	}

	let foreheadShape = ["foreheadShapeNormal", "foreheadShapeRound", "foreheadShapeSmall"];
	let forehead = Math.floor(random(slave.ID+5) * foreheadShape.length);
	if (forehead > 0) {
		morphs.push(foreheadShape[forehead], 1);
	}

	switch (slave.faceShape) {
		case "normal":
			break;
		case "masculine":
			morphs.push(["faceShapeMasculine", 0.6]); break;
		case "androgynous":
			morphs.push(["faceShapeAndrogynous", 0.8]); break;
		case "cute":
			morphs.push(["faceShapeCute", 1]); break;
		case "sensual":
			morphs.push(["faceShapeSensual", 0.8]); break;
		case "exotic":
			morphs.push(["faceShapeExotic", 1]); break;
	}

	if (slave.boobs < 600) {
		morphs.push(["boobShapeSmall", -(slave.boobs-600)/600]);
	} else {
		switch (slave.boobShape) {
			case "normal":
				morphs.push(["boobShapeNormal", (Math.sqrt(slave.boobs-600)/70)]); break;
			case "perky":
				morphs.push(["boobShapePerky", (Math.sqrt(slave.boobs-600)/125)]); break;
			case "saggy":
				morphs.push(["boobShapeSaggy", (Math.sqrt(slave.boobs-600)/55)]); break;
			case "torpedo-shaped":
				morphs.push(["boobShapeTorpedo", (Math.sqrt(slave.boobs-600)/35)]); break;
			case "downward-facing":
				// special case to make nipple work
				if (slave.nipples === "flat" || slave.nipples === "inverted") {
					morphs.push(["boobShapeDownward", (Math.sqrt(slave.boobs-600)/80)]); break;
				} else {
					morphs.push(["boobShapeDownwardNippleFix", (Math.sqrt(slave.boobs-600)/80)]); break;
				}
			case "wide-set":
				morphs.push(["boobShapeWide", (Math.sqrt(slave.boobs-600)/40)]); break;
			case "spherical":
				// special case to make nipple work
				if (slave.nipples === "flat" || slave.nipples === "inverted") {
					morphs.push(["boobShapeSpherical", (Math.sqrt(slave.boobs-600)/80)]); break;
				} else {
					morphs.push(["boobShapeSphericalNippleFix", (Math.sqrt(slave.boobs-600)/80)]); break;
				}
		}
	}

	switch (slave.nipples) {
		case "flat":
			break;
		case "huge":
			morphs.push(["nipplesHuge", Math.sqrt(slave.boobs)/40 + 0.5]); break;
		case "tiny":
			morphs.push(["nipplesHuge", Math.sqrt(slave.boobs)/90 + 0.1]); break;
		case "cute":
			morphs.push(["nipplesHuge", Math.sqrt(slave.boobs)/60 + 0.25]); break;
		case "puffy":
			morphs.push(["nipplesPuffy", Math.sqrt(slave.boobs)/35 + 0.5]); break;
		case "inverted":
			break;
		case "partially inverted":
			morphs.push(["nipplesPuffy", Math.sqrt(slave.boobs)/50 + 0.25]); break;
		case "fuckable":
			morphs.push(["nipplesHuge", Math.sqrt(slave.boobs)/25 + 0.6]); break;
	}

	if (slave.foreskin !== 0) {
		morphs.push(["foreskin", 1]);
	}
	if (slave.dick === 0 && !(slave.scrotum <= 0 || slave.balls <= 0)) {
		morphs.push(["dickRemove", 1]);
	} else if (slave.dick !== 0) {
		morphs.push(["dick", (slave.dick / 8) -1]);
	}
	if (slave.vagina === -1) {
		morphs.push(["vaginaRemove", 1]);
	}
	if (slave.scrotum <= 0 || slave.balls <= 0) {
		morphs.push(["ballsRemove", 1]);
	} else {
		if (slave.balls <= 2) {
			morphs.push(["balls", convertRange(0, 2, -1, 0, slave.balls)]);
		} else {
			morphs.push(["balls", convertRange(2, 10, 0, 1.5, slave.balls)]);
		}
		if (slave.scrotum > 2) {
			morphs.push(["scrotum", convertRange(2, 10, 0, 0.75, slave.scrotum)]);
		}
	}

	morphs.push(["areolae", convertRange(0, 4, 0, 5, slave.areolae)]);
	morphs.push(["shoulders", slave.shoulders/1.2]);
	scene.models[0].transform.scale = slave.height/175; // height by object transform
	if (slave.muscles > 0) {
		morphs.push(["muscles", slave.muscles/33]);
	}

	if(slave.belly < 15000 ) {
		morphs.push(["belly", Math.sqrt(slave.belly)/122.5]);
	} else {
		morphs.push(["belly", 1 + (Math.sqrt(slave.belly)-122.5)/150]);
	}

	morphs.push(["hips", slave.hips/2]);

	if (slave.butt<=1) {
		morphs.push(["butt", convertRange(0, 1, -1.5, -0.75, slave.butt)]);
	} else {
		morphs.push(["butt", convertRange(2, 20, 0, 3.5, slave.butt)]);
	}

	if (slave.waist > 0) {
		morphs.push(["waist", -slave.waist/100]);
	} else {
		morphs.push(["waist", -slave.waist/50]);
	}

	if (slave.weight >= 0) {
		morphs.push(["weight", slave.weight/75]);
	} else {
		morphs.push(["weightThin", -slave.weight/80]);
	}

	if (slave.visualAge < 20) {
		morphs.push(["physicalAgeYoung", -(slave.visualAge-20)/20]);
	} else {
		morphs.push(["physicalAgeOld", (slave.visualAge-20)/66]);
	}

	if (!hasLeftArm(slave)) {
		morphs.push(["amputeeLeftArm", 1]);
	}
	if (!hasRightArm(slave)) {
		morphs.push(["amputeeRightArm", 1]);
	}
	if (!hasLeftLeg(slave)) {
		morphs.push(["amputeeLeftLeg", 1]);
	}
	if (!hasRightLeg(slave)) {
		morphs.push(["amputeeRightLeg", 1]);
	}

	App.Art.resetMorphs(scene);

	for (let i =0; i < scene.models[0].morphs.length; i++) {
		for (let j =0; j < morphs.length; j++) {
			if (scene.models[0].morphs[i].morphId === morphs[j][0]) {
				scene.models[0].morphs[i].value = morphs[j][1];
			}
		}
	}
};
