App.EndWeek.arcManagement = function() {
	const el = new DocumentFragment();
	const secExpImigrationBonus = App.SecExp.propagandaEffects("immigration");
	let r;
	let _enslaved;
	let _crime;
	let _terrain;
	let _transportHub;
	let _honeymoon;
	let _LCD;
	let _SCD;
	let _LSCD;
	let _MCD;
	let _UCD;
	let _TCD;
	let _rentMultiplier;
	let _AWeekGrowth;
	let _econMult;

	if (V.useTabs === 0) {
		App.UI.DOM.appendNewElement("h2", el, "Arcology Management");
	}
	const _schools = App.Utils.schoolCounter();

	App.UI.DOM.appendNewElement("p", el, ownershipReport(false));

	/* Sexual Satisfaction */
	if (V.arcologies[0].FSDegradationist !== "unset") {
		if (V.arcadeDemandDegResult === 1) {
			appendDiv(`Your endeavors to see slaves as less than human are hampered as citizens find that there are too few slaves ready to be treated as sexual objects around. <span class="red">Development towards a degradationist society is damaged</span> as a result.`);
		} else if (V.arcadeDemandDegResult === 2) {
			appendDiv(`Your endeavors to see slaves as less than human are slightly hampered as citizens find that there are not quite enough slaves ready to be treated as sexual objects around. <span class="red">Development towards a degradationist society is lightly damaged</span> as a result.`);
		} else if (V.arcadeDemandDegResult === 3) {
			appendDiv(`Your citizens were expecting to see more slaves available as sexual objects, but there aren't enough complaints to damage your societal development at this time.`);
		} else if (V.arcadeDemandDegResult === 4) {
			appendDiv(`Your citizens find themselves surrounded by slaves ready to be degraded and used as sexual objects, this <span class="green">helps to establish your degradationist society</span>.`);
		} else if (V.arcadeDemandDegResult === 5) {
			appendDiv(`You are providing your citizens with an adequate amount of slaves to be used as sexual objects, as is expected in your degradationist society.`);
		}
	}

	$(el).append(supplyPoliciesReport("lower"));
	$(el).append(supplyPoliciesReport("middle"));
	$(el).append(supplyPoliciesReport("upper"));
	$(el).append(supplyPoliciesReport("top"));

	/* New Population
	Populations depend on the 'demand' for them. People flock to the Free City when there are jobs. Jobs for lower class people depend on prosperity and the need for labor from other classes. They compete with slaves for work.
	More elite citizens require their own slaves and will cause the population of slaves to increase as they move in. FS and policies will impact how many slaves they desire and how productive they are. The PC's menials also compete for labor within the arcology. Slaves can now 'expire', speed depends on FS and policies. Default lifespan for menials is an average of ~4 years. */

	V.oldACitizens = V.ACitizens;
	let _FSScore = 0; /* FS progress for tourism */
	let	_slaveDemandU = 1; /* Changes to upperClass slave demand */
	let	_slaveDemandT = 1; /* Changes to topClass slave demand */
	let	_expirationFS = 0.005; /* Changes to likelihood of slave death */
	let _expirationLC = 0.003; /* Changes to likelihood of lowerClass death */
	let _expirationMC = 0.002; /* Changes to likelihood of middleClass death */
	let _expirationUC = 0.001; /* Changes to likelihood of upperClass death */
	let _expirationTC = 0.001; /* Changes to likelihood of topClass death */
	let	_slaveProductivity = 0.8; /* Changes to slave productivity*/
	let	_lowerClass = 0; /* Fixed amount of changes to lowerClass interest to move in*/
	let	_lowerClassP = 1; /* Scaling changes to lowerClass interest ("stacking bonus")*/
	let	_welfareFS = 0.004; /* Changes to likelihood of lowerClass getting enslaved*/
	let	_middleClass = 0; /* See lowerClass examples for the rest of these*/
	let	_middleClassP = 1;
	let	_upperClass = 0;
	let	_upperClassP = 1;
	let	_topClass = 0;
	let	_topClassP = 1;

	el.append(fsImpact());
	el.append(policiesImpact());

	const schoolSubsidy = Array.from(App.Data.misc.schools.keys()).reduce((acc, current) => acc + V[current].subsidize, 0);
	_middleClass += (schoolSubsidy) * 40;
	_middleClassP *= 1 + (schoolSubsidy) * 0.005;

	r = [];
	r.push(slaveRetirement());
	r.push(expiration());
	r.push(denseApartments());
	App.Events.addParagraph(el, r);

	citizenToSlave();

	V.GDP = Math.trunc(((V.NPCSlaves + V.menials) * 0.35 * _slaveProductivity) + (V.lowerClass * 0.35) + (V.middleClass * 0.75) + (V.upperClass * 2) + (V.topClass * 10)) / 10;

	/* formula to calculate localEcon effect */
	if (V.localEcon >= 100) {
		_econMult = (1 + 1.15 * (Math.trunc(1000-100000/200)/8.5)/100);
	} else {
		_econMult = (1/(1 + 5 * Math.sqrt(Math.trunc(100000/50-1000)/8.5)/100));
	}

	if (!isFrozen()) {
		transport();
	} else {
		/* enslavement happens even if there's no traffic due to weather */
		enslavement();
	}

	V.ASlaves = V.NPCSlaves + V.menials + V.fuckdolls + V.menialBioreactors;
	if (V.secExpEnabled > 0) {
		V.ASlaves += (V.SecExp.buildings.secHub ? V.SecExp.buildings.secHub.menials : 0) + App.SecExp.Manpower.employedSlave;
	}
	V.ACitizens = V.lowerClass + V.middleClass + V.upperClass + V.topClass;
	if (V.cheatMode === 1 || V.debugMode === 1) {
		appendDiv(`${V.arcologies[0].prosperity} Prosperity | ${_FSScore} FS Score | ${_honeymoon} Honeymoon | ${_transportHub} Transporthub | ${_terrain} Terrain | ${_crime} Crime`);
		appendDiv(`${num(_LSCD)} Lower + Slave Class Demand | ${num(_SCD)} Slave Class Demand | ${num(_slaveProductivity)} Slave Productivity`);
		appendDiv(`${num(_LCD)} Lower Class Demand | ${num(_lowerClassP)} LC Multiplier`);
		appendDiv(`${num(_MCD)} Middle Class Demand | ${num(_middleClassP)} MC Multiplier`);
		appendDiv(`${num(_UCD)} Upper Class Demand | ${num(_upperClassP)} UC Multiplier`);
		appendDiv(`${num(_TCD)} Top Class Demand | ${num(_topClassP)} TC Multiplier`);
	}
	const percOfPop = (n) => Math.trunc((n / (V.ACitizens + V.ASlaves)) * 1000) / 10;
	appendDiv(`${V.arcologies[0].name} is home to the following:`);
	appendDiv(`Citizens | ${num(V.ACitizens)} | ${percOfPop(V.ACitizens)}%`);
	appendDiv(`Lower Class Citizens | ${num(V.lowerClass)} | ${percOfPop(V.lowerClass)}%`);
	appendDiv(`Middle Class Citizens | ${num(V.middleClass)} | ${percOfPop(V.middleClass)}%`);
	appendDiv(`Upper Class Citizens | ${num(V.upperClass)} | ${percOfPop(V.upperClass)}%`);
	appendDiv(`Millionaires | ${num(V.topClass)} | ${percOfPop(V.topClass)}%`);
	appendDiv(`Slaves | ${num(V.ASlaves)} | ${percOfPop(V.ASlaves)}%`);

	r = [];
	if (V.arcologies[0].FSSupremacistLawME === 1) {
		r.push(`The citizenry is entirely ${V.arcologies[0].FSSupremacistRace}.`);
	}
	if (V.arcologies[0].FSRomanRevivalistLaw === 1) {
		r.push(`The citizens take pride in their martial duties, preferring to wear utilitarian clothing even when off duty.`);
	}
	if (V.arcologies[0].FSNeoImperialistLaw1 === 1) {
		r.push(`You can occasionally see an Imperial Knight in full, noble battle-dress coordinating groups of organized citizen's militias, dressed in uniform liveries. Your citizens take pride in their fighting abilities.`);
	}
	if (V.arcologies[0].FSGenderRadicalistDecoration === 100) {
		r.push(`Every single one of the slaves is female by virtue of her fuckable asshole.`);
	} else if (V.arcologies[0].FSGenderFundamentalistSMR === 1) {
		r.push(`Almost every prominent citizen is an upstanding man, while the slave population is almost completely female.`);
	}
	if (V.arcologies[0].FSEgyptianRevivalistLaw === 1) {
		r.push(`Close relationships between citizens and slaves, especially slave siblings, are common.`);
	} else if (V.arcologies[0].FSEgyptianRevivalistIncestPolicy === 1) {
		r.push(`Close relationships between citizens, slaves and siblings are common.`);
	}
	if (V.arcologies[0].FSSubjugationistLawME === 1) {
		r.push(`${capFirstChar(V.arcologies[0].FSSubjugationistRace)} subhumans form a majority of the slaves.`);
	}
	if (V.arcologies[0].FSChattelReligionistLaw === 1) {
		r.push(`The slave population as a whole is unusually accepting of its station.`);
	}
	if (V.arcologies[0].FSPaternalistLaw === 1) {
		r.push(`The slaves are well cared for, and it can sometimes be difficult to tell slaves from citizens.`);
	} else if (V.arcologies[0].FSDegradationistLaw === 1) {
		r.push(`Most of the slaves are recent captures, since the vicious society that's taken root here uses people up quickly.`);
	}
	if (V.arcologies[0].FSBodyPuristLaw === 1) {
		r.push(`The average slave is quite healthy.`);
	} else if (V.arcologies[0].FSTransformationFetishistSMR === 1) {
		if (V.arcologies[0].FSTransformationFetishistResearch === 1) {
			r.push(`Breast implants are almost universal;`);
			if (V.arcologies[0].FSSlimnessEnthusiast === "unset") {
				r.push(`an M-cup bust is below average among the slave population.`);
			} else {
				r.push(`even the most lithe slave sports a pair of overly round chest balloons.`);
			}
		} else {
			r.push(`Breast implants are almost universal;`);
			if (V.arcologies[0].FSSlimnessEnthusiast === "unset") {
				r.push(`a D-cup bust is below average among the slave population.`);
			} else {
				r.push(`even the most lithe slave sports a pair of overly round chest balloons.`);
			}
		}
	}
	if (V.arcologies[0].FSIntellectualDependencySMR === 1) {
		r.push(`The average slave is entirely dependent on its master.`);
	} else if (V.arcologies[0].FSSlaveProfessionalismSMR === 1) {
		r.push(`The average slave is entirely capable of acting on its master's behalf.`);
	}
	if (V.arcologies[0].FSSlimnessEnthusiastSMR === 1) {
		r.push(`Most of the slave population is quite slim and physically fit.`);
	} else if (V.arcologies[0].FSAssetExpansionistSMR === 1) {
		r.push(`The arcology's consumption of pharmaceuticals is impressive, since slave growth hormones are nearly ubiquitous.`);
	}
	if (V.arcologies[0].FSPetiteAdmirationSMR === 1) {
		r.push(`Slaves are both easy to identify, but hard to find in a crowd given their short stature.`);
	} else if (V.arcologies[0].FSStatuesqueGlorificationSMR === 1) {
		r.push(`${V.arcologies[0].name}'s`);
		if (V.arcologies[0].FSStatuesqueGlorificationLaw === 1) {
			r.push(`entire`);
		} else {
			r.push(`slave`);
		}
		r.push(`population stands taller than most visitors.`);
	}
	if (V.arcologies[0].FSRepopulationFocusLaw === 1) {
		r.push(`Many of the women in the arcology are pregnant.`);
	} else if (V.arcologies[0].FSRepopulationFocusSMR === 1) {
		r.push(`Most of the slaves in the arcology are pregnant.`);
	} else if (V.arcologies[0].FSRestartLaw === 1) {
		r.push(`Many of your civilians have agreed to be sterilized.`);
	} else if (V.arcologies[0].FSRestartSMR === 1) {
		r.push(`Many of slave slaves in your arcology are infertile.`);
	}
	if (V.arcologies[0].FSPastoralistLaw === 1) {
		r.push(`Much of the menial slave labor force works to service the arcology's hundreds of human cattle.`);
	}
	if (V.arcologies[0].FSPhysicalIdealistSMR === 1) {
		r.push(`The arcology must import a very large quantity of nutritive protein to nourish its slaves.`);
	}
	if (V.arcologies[0].FSHedonisticDecadenceSMR === 1) {
		r.push(`The arcology must import a very large quantity of fattening food to plump up its slaves.`);
	}

	if (V.ACitizens > V.ASlaves * 2) { /* This will need to go away Eventually*/
		r.push(`Since most citizens do not own sex slaves, <span class="yellowgreen">demand for sexual services is intense.</span>`);
	} else if (V.ACitizens > V.ASlaves) {
		r.push(`Since many citizens do not own sex slaves, <span class="yellowgreen">demand for sexual services is healthy.</span>`);
	} else if (V.ACitizens > V.ASlaves * 0.5) {
		r.push(`Since many citizens keep a personal sex slave, <span class="yellow">demand for sexual services is only moderate.</span>`);
	} else if (V.ACitizens > V.ASlaves * 0.25) {
		r.push(`Since most citizens keep at least one sex slave, <span class="gold">local demand for sexual services is low,</span> though visitors to the arcology will always keep it above a certain minimum.`);
	} else {
		r.push(`Since most of your citizens now keep private harems of sex slaves, <span class="gold">local demand for sexual services is very low,</span> though visitors to the arcology will always keep it above a certain minimum.`);
	}
	App.Events.addParagraph(el, r);
	r = [];

	_rentMultiplier = 1;
	if (V.arcologies[0].FSPaternalistLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Tenants who can prove that they abstain from certain practices are given a reduction to their rent.`);
	}
	if (V.arcologies[0].FSYouthPreferentialistLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Younger citizens are offered subsidized rent to encourage young people to join the free population of your arcology.`);
	} else if (V.arcologies[0].FSMaturityPreferentialistLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Older citizens are offered subsidized rent to encourage mature people to join the free population of your arcology.`);
	}
	if (V.arcologies[0].FSPetiteAdmirationLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Citizens are offered subsidized rent to take drastically shorter partners and harem members.`);
	} else if (V.arcologies[0].FSStatuesqueGlorificationLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Tall citizens are offered rent subsidies, at the expense of short citizens, to encourage more statuesque individuals to join the free population of your arcology.`);
	}
	if (V.arcologies[0].FSRepopulationFocusLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Pregnant citizens are offered subsidized rent to encourage free women to become pregnant and pregnant women to join the free population of your arcology.`);
	} else if (V.arcologies[0].FSRestartLaw === 1) {
		_rentMultiplier *= 1.05;
		r.push(`Non-Elite citizens who refuse to be sterilized face a moderate tax and the looming possibility of expulsion or enslavement.`);
	}
	if (V.arcologies[0].FSHedonisticDecadenceLaw === 1) {
		_rentMultiplier *= 0.95;
		r.push(`Food vendors are offered subsidized rent and operating expenses to set up shop in your arcology.`);
	}
	if (V.secExpEnabled > 0) {
		if (V.SecExp.edicts.alternativeRents === 1) { // A silly policy
			r.push(`Your citizens are allowed to pay their rents in slaves rather than cash and a few financially challenged individuals make use of this.`);
			_rentMultiplier *= 0.95;
			const _movement = random(0, 3);
			V.menials += _movement;
			V.NPCSlaves -= _movement;
		}
		if (V.SecExp.edicts.defense.discountMercenaries === 1) {
			r.push(`Mercenaries willing to come to your arcology are given a discount on rent.`);
			_rentMultiplier *= 0.98;
		}
		if (V.SecExp.edicts.defense.privilege.militiaSoldier === 1) {
			r.push(`Citizens in the militia are exempt from rent payment.`);
			_rentMultiplier *= 0.98;
		}
	}
	if (V.arcologies[0].FSArabianRevivalistLaw === 1) {
		_rentMultiplier *= 1.05;
		r.push(`Those of your citizens who have not yet subscribed to the society you are building are permitted to live and do business here, but must pay a moderate jizya tax for the privilege as part of their rent.`);
	}
	if (V.arcologies[0].FSNeoImperialistLaw2 === 1) {
		_rentMultiplier *= 1.05;
		r.push(`Your Barons, equipped with golden bands as a symbol of office, flit about their assigned sections of the arcology to personally check up on businesses and punish petty criminals. They make any evasion of your rent extraordinarily difficult, and consistently earn you more than they take.`);
	}
	App.Events.addParagraph(el, r);
	r = [];
	_rentMultiplier *= 1 + (5 - V.baseDifficulty) / 20;
	const _rents = Math.trunc((V.lowerClass * V.rent.lowerClass + V.middleClass * V.rent.middleClass + V.upperClass * V.rent.upperClass + V.topClass * V.rent.topClass) * _rentMultiplier / 25);
	if (!Number.isInteger(_rents)) {
		appendDiv(`<span class="red">Error: rents is outside accepted range, please report this issue</span>`);
	} else {
		cashX(_rents, "rents");
	}

	r.push(`This week, rents from ${V.arcologies[0].name} came to <span class="yellowgreen">${cashFormat(_rents)}.</span>`);
	if (V.difficultySwitch === 0) {
		if (V.localEcon < 100) {
			let _bribes = (V.week * 100) + random(-100, 100);
			if (V.cash > 1000) {
				_bribes += Math.trunc(V.cash * 0.02);
			}
			r.push(`The <span class="red">degenerating world economy</span> makes supplying and maintaining ${V.arcologies[0].name} extremely difficult. This week, bribes and other costs to keep it running came to <span class="yellowgreen">${cashFormat(_bribes)}.</span>`);
			cashX(forceNeg(_bribes), "rents");
		}
	}

	if (V.menials + V.menialBioreactors + V.fuckdolls > 0) {
		let _menialEarnings = 0;
		let _bioreactorEarnings = 0;
		let _fuckdollsEarnings = 0;
		r.push(`You own`);
		if (V.menials > 0) {
			if (V.menials > Math.trunc(_LSCD / _slaveProductivity - _SCD)) {
				_menialEarnings += Math.max(Math.trunc(_LSCD / _slaveProductivity - _SCD) * 10, 0);
				r.push(`<span class="red">more menial slaves than there was work,</span> consider selling some.`);
				if (_menialEarnings === 0) {
					r.push(`Actually, consider selling them all...demand for labor is so low that <span class="red">none of them made any money</span> this week.`);
				}
				r.push(`<br> You own`);
			} else {
				_menialEarnings = V.menials * 10;
				if (V.Sweatshops > 0) {
					if (V.Sweatshops * 500 <= V.menials) {
						_menialEarnings += V.Sweatshops * 7000;
						_menialEarnings += (V.menials - V.Sweatshops * 500) * 10;
					} else {
						_menialEarnings += V.menials * 14;
					}
				}
			}
			if (V.illegalDeals.menialDrug === 1) {
				_menialEarnings = Math.trunc(_menialEarnings * 1.5);
			}
			if (V.menials > 1) {
				r.push(`${num(V.menials)} menial slaves${((V.menialBioreactors > 0) && (V.fuckdolls === 0)) ? ` and` : `,`}`);
			} else {
				r.push(`one menial slave${((V.menialBioreactors > 0) && (V.fuckdolls === 0)) ? ` and` : `,`}`);
			}
			cashX(_menialEarnings, "menialTrades");
		}

		if (V.menialBioreactors > 0) {
			_bioreactorEarnings = V.menialBioreactors * (10 + (10 * V.arcologies[0].FSPastoralistLaw));
			if (V.dairy && V.dairyUpgradeMenials) {
				_bioreactorEarnings += V.menialBioreactors * 5;
			}
			if (V.menialBioreactors > 1) {
				r.push(`${num(V.menialBioreactors)} standard bioreactors,`);
			} else {
				r.push(`one standard bioreactor,`);
			}
			if (V.fuckdolls > 0) {
				r.push(`and`);
			}
			cashX(_bioreactorEarnings, "menialBioreactors");
		}


		if (V.fuckdolls > 0) {
			const arcadeFreeSpace = V.arcade - App.Entity.facilities.arcade.employeesIDs().size;
			const _fuckdollsArcade = arcadeFreeSpace > 0 ? Math.min(arcadeFreeSpace, V.fuckdolls) : 0;
			let _arcadeUpgradeInjectors;
			if (V.arcadeUpgradeInjectors === 0) {
				_arcadeUpgradeInjectors = 0;
			} else if (V.arcadeUpgradeInjectors === 1) {
				_arcadeUpgradeInjectors = 1;
			} else {
				_arcadeUpgradeInjectors = 1.5;
			}
			_fuckdollsEarnings = Math.trunc(((V.fuckdolls - _fuckdollsArcade) * 140 + _fuckdollsArcade * (175 + 35 * _arcadeUpgradeInjectors)) * (V.arcadePrice - 0.5) / 10);
			/* The "/ 10" at the end is just there to keep the price in line with other current prices, hopefully prices will get to a spot where this can be dropped*/
			if (V.fuckdolls > 1) {
				r.push(`${num(V.fuckdolls)} standard Fuckdolls,`);
			} else if (V.fuckdolls === 1) {
				r.push(`one Fuckdoll,`);
			}
			if (_fuckdollsArcade > 1) {
				r.push(`${num(_fuckdollsArcade)} of which are stationed in the arcade,`);
			} else if (_fuckdollsArcade === 1 && V.fuckdolls > 1) {
				r.push(`one of which is stationed in the arcade,`);
			} else if (_fuckdollsArcade === 1) {
				r.push(`which is stationed in the arcade,`);
			}
			if (V.policies.publicFuckdolls === 1) {
				repX(_fuckdollsEarnings / 5, "fuckdolls");
				_fuckdollsEarnings = Math.trunc(V.fuckdolls * -0.5);
				/* The upkeep of a Fuckdoll*/
			}
			cashX(_fuckdollsEarnings, "fuckdolls");
		}

		const totalEarnings = _menialEarnings + _bioreactorEarnings + _fuckdollsEarnings;
		if (totalEarnings > 0) {
			r.push(`earning you <span class="yellowgreen">${cashFormat(totalEarnings)}.</span>`);
		} else if (totalEarnings === 0) {
			r.push(`which earned you <span class="red">no money</span> this week.</span>`);
		} else {
			r.push(`costing you <span class="cash dec">${cashFormat(totalEarnings)}</span> on account of your free Fuckdoll policy.`);
		}
		if (V.illegalDeals.menialDrug === 1) {
			r.push(`Your menial slave productivity has been boosted by performance enhancing drugs.`);
		}
	}

	_AWeekGrowth = V.AGrowth;
	if (_AWeekGrowth + V.arcologies[0].prosperity > V.AProsperityCap) {
		r.push(`<span class="yellow">${V.arcologies[0].name} is at its maximum prosperity, so rents will not increase until it is improved.</span>`);
	} else if ((2 * _AWeekGrowth) + V.arcologies[0].prosperity >= V.AProsperityCap) {
		r.push(`<span class="yellow">Your arcology is nearly at its maximum prosperity.</span>`);
		V.arcologies[0].prosperity += _AWeekGrowth;
	} else {
		if (V.arcologies[0].ownership >= 100) {
			r.push(`Your controlling interest in ${V.arcologies[0].name} allows you to lead it economically, <span class="green">supercharging growth.</span>`);
			_AWeekGrowth += 3;
		} else if (V.arcologies[0].ownership >= random(40, 100)) {
			r.push(`Your interest in ${V.arcologies[0].name} allows you to lead it economically, <span class="green">boosting growth.</span>`);
			_AWeekGrowth++;
		}
		if (V.arcologies[0].prosperity < (V.rep / 100)) {
			r.push(`Your impressive reputation relative to ${V.arcologies[0].name}'s prosperity <span class="green">drives an increase in business.</span>`);
			_AWeekGrowth++;
		} else if (V.rep > 18000) { // no growth penalty if PC is at high rep, no matter how high prosperity goes
		} else if (V.arcologies[0].prosperity > (V.rep / 60)) {
			r.push(`Your low reputation relative to ${V.arcologies[0].name}'s prosperity <span class="red">seriously impedes business growth.</span>`);
			_AWeekGrowth -= 2;
		} else if (V.arcologies[0].prosperity > (V.rep / 80)) {
			r.push(`Your unimpressive reputation relative to ${V.arcologies[0].name}'s prosperity <span class="yellow">slows business growth.</span>`);
			_AWeekGrowth--;
		}
		if (V.secExpEnabled > 0) {
			if (V.SecExp.core.trade <= 20) {
				_AWeekGrowth += 1;
			} else if (V.SecExp.core.trade <= 40) {
				_AWeekGrowth += 2;
			} else if (V.SecExp.core.trade <= 60) {
				_AWeekGrowth += 3;
			} else if (V.SecExp.core.trade <= 80) {
				_AWeekGrowth += 4;
			} else {
				_AWeekGrowth += 5;
			}

			if (V.SecExp.smilingMan.progress === 10) {
				r.push(`The ex-criminal known to the world as The Smiling Man puts her impressive skills to work, improving the financial situation of the arcology with ease.`);
				_AWeekGrowth++;
			}
		}
		if (V.personalAttention === "business") {
			if ((V.PC.skill.trading >= 100) || (V.PC.career === "arcology owner")) {
				r.push(`Your <span class="springgreen">business focus and your experience</span> allow you to greatly assist in advancing the arcology's prosperity.`);
				_AWeekGrowth += 2;
			} else {
				r.push(`Your business focus allows you to help improve the arcology's prosperity.`);
				_AWeekGrowth++;
			}
			if (V.PC.actualAge >= 50) {
				if (V.arcologies[0].FSMaturityPreferentialistLaw === 1) {
					r.push(`You are able to leverage your long seniority in the business community using the arcology's favorable laws to further advance prosperity.`);
					_AWeekGrowth++;
				}
			} else if (V.PC.actualAge < 35) {
				if (V.arcologies[0].FSYouthPreferentialistLaw === 1) {
					r.push(`You are able to leverage your freshness in the business community using the arcology's favorable laws to further advance prosperity.`);
					_AWeekGrowth++;
				}
			}
		}
		if (V.arcologies[0].FSNull !== "unset") {
			r.push(`Your cultural openness is a powerful driver of economic activity.`);
			_AWeekGrowth += Math.max(1, Math.trunc(V.arcologies[0].FSNull / 25));
		}
		if (V.arcologies[0].FSRestart !== "unset") {
			r.push(`Your powerful connections open many avenues of economic expansion.`);
			_AWeekGrowth += Math.max(1, Math.trunc(V.arcologies[0].FSRestart / 10));
		}
		if (V.arcologies[0].FSPaternalist >= random(1, 100)) {
			r.push(`This week, the careful attention to slave welfare your new society emphasizes has been a driver of prosperity.`);
			_AWeekGrowth++;
		}
		if (V.arcologies[0].FSHedonisticDecadence >= random(1, 100)) {
			r.push(`This week, several new businesses opened local branches or broke ground, greatly increasing prosperity.`);
			_AWeekGrowth += 2;
		}
		if (V.arcologies[0].FSChattelReligionistCreed === 1) {
			if (V.nicaea.focus === "owners") {
				r.push(`The focus on slaveowners' whims in the creed of ${V.nicaea.name} interests the rich and powerful, increasing prosperity.`);
				_AWeekGrowth += V.nicaea.power;
			}
		}
		if (V.arcologies[0].FSSlaveProfessionalismLaw === 1) {
			r.push(`The concentrated intelligence of the free population finds innovative ways to spur prosperity.`);
			_AWeekGrowth++;
		}
		if (V.arcologies[0].FSRomanRevivalist >= random(1, 100)) {
			r.push(`This week, intense interest in your project to revive Roman values has driven prosperity.`);
			_AWeekGrowth++;
		} else if (V.arcologies[0].FSNeoImperialist >= random(1, 100)) {
			r.push(`This week, your tightly hierarchical Imperial society's efficient organization has attracted traders and increased prosperity.`);
			_AWeekGrowth++;
		} else if (V.arcologies[0].FSChineseRevivalist !== "unset") {
			if ((V.HeadGirlID !== 0) && (V.RecruiterID !== 0) && (V.BodyguardID !== 0)) {
				r.push(`This week, your imperial administration, staffed with a Head Girl, a Recruiter, and a Bodyguard, has improved prosperity.`);
				_AWeekGrowth += 2;
			}
		}
		if (V.PC.skill.trading >= 100) {
			r.push(`Your <span class="springgreen">business skills</span> drive increased prosperity.`);
			_AWeekGrowth++;
		} else if (V.PC.career === "arcology owner") {
			r.push(`Your <span class="springgreen">experience in the Free Cities</span> helps increase prosperity.`);
			_AWeekGrowth++;
		}
		if (_schools === 1) {
			r.push(`The presence of a slave school in the arcology improves the local economy.`);
		} else if (_schools > 0) {
			r.push(`The presence of slave schools in the arcology greatly improves the local economy.`);
		} else if (V.arcologies[0].prosperity > 80) {
			r.push(`The lack of a branch campus from a reputable slave school is slowing further development of the local economy.`);
			_AWeekGrowth--;
		}
		_AWeekGrowth += _schools;
		if (V.arcologies[0].FSDegradationistLaw === 1) {
			r.push(`Requiring menials to be given time to fuck human sex toys in the arcade reduces labor efficiency, slowing growth and costs money for each menial slave you own.`);
			_AWeekGrowth--;
			cashX(forceNeg(V.menials * 3 * V.arcadePrice), "fuckdolls");
		}
		if (V.arcologies[0].FSBodyPuristLaw === 1) {
			r.push(`The drug surcharge used to fund the purity regime reduces growth.`);
			_AWeekGrowth--;
		}
		if (V.arcologies[0].FSPastoralistLaw === 1) {
			r.push(`Prosperity improvement is slowed by the regulations on animal products.`);
			_AWeekGrowth--;
		}
		if (V.arcologies[0].FSPaternalistSMR === 1) {
			r.push(`Your slave market regulations slow the flow of chattel through the arcology.`);
			_AWeekGrowth--;
		}

		// deactivated with sec Exp as they are modifiers for the trade mechanic
		if (V.secExpEnabled === 0) {
			if (V.terrain === "urban") {
				r.push(`Since your arcology is located in the heart of an urban area, its commerce is naturally vibrant.`);
				_AWeekGrowth++;
			}
			if (V.terrain === "ravine") {
				r.push(`Since your arcology is located in the heart of a ravine, its commerce is hindered by a lack of accessibility.`);
				_AWeekGrowth--;
			}
		}

		if (V.arcologies[0].embargoTarget && V.arcologies[0].embargoTarget !== -1) {
			r.push(`The local economy is hurt by the double edged sword of your economic warfare.`);
			_AWeekGrowth -= V.arcologies[0].embargo * 2;
		}

		let _desc = [];
		let _descNeg = [];
		for (const arcology of V.arcologies) {
			const _opinion = App.Neighbor.opinion(V.arcologies[0], arcology);
			if (_opinion >= 100) {
				_desc.push(arcology.name);
			} else if (_opinion <= -100) {
				_descNeg.push(arcology.name);
			}
		}
		if (_desc.length > 0) {
			r.push(`Your arcology's economy benefits from close social alignment with`);
			if (_descNeg.length > 0) {
				r.push(`${toSentence(_desc)}, but`);
			} else {
				r.push(`${toSentence(_desc)}.`);
			}
			_AWeekGrowth += _desc.length;
		}
		if (_descNeg.length > 0) {
			if (_desc.length === 0) {
				r.push(`Your arcology's economy is`);
			}
			r.push(`hindered by social conflicts with ${toSentence(_descNeg)}.`);
			_AWeekGrowth -= _descNeg.length;
		}
		if (V.policies.alwaysSubsidizeGrowth === 1) {
			r.push(`Growth was subsidized as planned.`);
			_AWeekGrowth++;
		}
		if (V.secExpEnabled > 0) {
			App.Events.addParagraph(el, r);
			r = [];
			if (V.SecExp.core.authority > 18000) {
				r.push(`Your authority is so high it discourages new business, slowing down the economic growth of the arcology.`);
				_AWeekGrowth--;
			}
			if (V.SecExp.core.security > 80) {
				r.push(`Your arcology is extremely safe and stable. Many businesses are attracted to it because of this.`);
				_AWeekGrowth++;
			} else if (V.SecExp.core.security < 20) {
				r.push(`Your arcology's low security is an instability factor simply too dangerous to be ignored. Many businesses avoid your arcology because of this.`);
				_AWeekGrowth--;
			}

			if (V.SecExp.edicts.weaponsLaw === 3) {
				r.push(`The free flow of weapons in your arcology has a positive impact on its economy.`);
				_AWeekGrowth++;
			} else if (V.SecExp.edicts.weaponsLaw === 2) {
				r.push(`The fairly liberal flow of weapons in your arcology has a positive impact on its economy.`);
				_AWeekGrowth++;
			}
			if (V.SecExp.buildings.propHub && V.SecExp.buildings.propHub.upgrades.controlLeaks > 0) {
				r.push(`The authenticity department prepares extremely accurate, but false financial reports, misleading many of your competitors, allowing your arcology more space to grow undisturbed.`);
				_AWeekGrowth++;
			}
			if (V.SecExp.smilingMan.progress >= 2) {
				if (V.SecExp.smilingMan.globalCrisisWeeks && V.SecExp.smilingMan.globalCrisisWeeks > 0) {
					r.push(`The great global crisis ignited by The Smiling Man plan is a great weight on the shoulders of everyone, causing great harm to the prosperity of the arcology.`);
					_AWeekGrowth -= random(2, 4);
					V.SecExp.smilingMan.globalCrisisWeeks--;
				} else if (V.SecExp.smilingMan.progress >= 3) {
					r.push(`With the global economy recovering from the great crisis unleashed by the Smiling Man, there is plenty of room to grow. Your arcology's prosperity benefits from this greatly.`);
					_AWeekGrowth++;
				}
				if ((V.SecExp.smilingMan.globalCrisisWeeks) && V.SecExp.smilingMan.globalCrisisWeeks === 0) {
					delete V.SecExp.smilingMan.globalCrisisWeeks;
				}
			}
			const reactorDamaged = V.garrison.reactorTime;
			if (reactorDamaged > 0) {
				r.push(`The damage to the reactor caused by the last rebellion is extensive. Businesses and private citizens struggle to operate with the unreliable and limited energy production offered by the auxiliary generators. It will still take ${numberWithPluralOne(reactorDamaged, 'week')} to finish repair works.`);
				_AWeekGrowth -= random(1, 2);
				V.garrison.reactorTime--;
				IncreasePCSkills('engineering', 0.1);
			}

			const secExpTrade = App.SecExp.tradeReport();
			r.push(secExpTrade.text);
			_AWeekGrowth += secExpTrade.bonus;
			App.Events.addParagraph(el, r);
			r = [];
		}
		_AWeekGrowth = Math.trunc(0.5 * _AWeekGrowth);
		if (_AWeekGrowth > 0) {
			r.push(`Since ${V.arcologies[0].name} can support more citizens and more activity, <span class="green">its prosperity improved this week.</span>`);
		} else if (_AWeekGrowth === 0) {
			r.push(`Though ${V.arcologies[0].name} can support more citizens and more activity, <span class="yellow">growth was moribund this week.</span>`);
		} else {
			r.push(`Though ${V.arcologies[0].name} can support more citizens and more activity, <span class="red">it lost prosperity this week.</span>`);
		}

		App.Events.addNode(el, r);
		r = [];

		if (isNaN(_AWeekGrowth)) {
			App.UI.DOM.appendElement("div", el, `Error: AWeekGrowth is NaN`, "red");
		} else {
			V.arcologies[0].prosperity += _AWeekGrowth;
		}
	}

	if (_schools > 0) {
		el.append(schools());
	}

	if (V.assistant.market && V.assistant.market.limit > 0) {
		let _popCap = menialPopCap();
		let _menialSlaveValue = menialSlaveCost();
		const {HeM, heM} = getPronouns(assistant.pronouns().market).appendSuffix('M');
		r.push(`Your <span class="bold">business assistant</span> manages the menial slave market.`);
		if (_menialSlaveValue <= 900 + V.assistant.market.aggressiveness) { /* BUY */
			let _bulkMax = _popCap.value - V.menials - V.fuckdolls - V.menialBioreactors;
			if (_bulkMax <= 0) {
				r.push(`There is no room in the parts of your arcology you own for more menial slaves.`);
			} else {
				if (V.cash > V.assistant.market.limit + _menialSlaveValue) {
					let _menialBulkPremium = Math.trunc(1 + Math.clamp((V.cash - V.assistant.market.limit) / _menialSlaveValue, 0, _bulkMax) / 400);
					r.push(`${HeM} acquires more chattel, since it's a buyers' market.`);
					if ((V.arcologies[0].FSPastoralist !== "unset") && (V.arcologies[0].FSPaternalist === "unset")) {
						V.menialBioreactors += Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / (_menialSlaveValue + _menialBulkPremium - 100), 0, _bulkMax));
						V.menialSupplyFactor -= Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / (_menialSlaveValue + _menialBulkPremium - 100), 0, _bulkMax));
						cashX(forceNeg(Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / (_menialSlaveValue + _menialBulkPremium - 100), 0, _bulkMax)) * (_menialSlaveValue + _menialBulkPremium - 100)), "menialBioreactorsTransferA");
					} else if ((V.arcologies[0].FSDegradationist !== "unset")) {
						V.fuckdolls += Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / ((_menialSlaveValue + _menialBulkPremium) * 2), 0, _bulkMax));
						V.menialSupplyFactor -= Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / ((_menialSlaveValue + _menialBulkPremium) * 2), 0, _bulkMax));
						cashX(forceNeg(Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / ((_menialSlaveValue + _menialBulkPremium) * 2), 0, _bulkMax)) * ((_menialSlaveValue + _menialBulkPremium) * 2)), "fuckdollsTransferA");
					} else {
						V.menials += Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / (_menialSlaveValue + _menialBulkPremium), 0, _bulkMax));
						V.menialSupplyFactor -= Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / (_menialSlaveValue + _menialBulkPremium), 0, _bulkMax));
						cashX(forceNeg(Math.trunc(Math.clamp((V.cash - V.assistant.market.limit) / (_menialSlaveValue + _menialBulkPremium), 0, _bulkMax) * (_menialSlaveValue + _menialBulkPremium))), "menialTransferA");
					}
				}
			}
		} else if (_menialSlaveValue >= 1100 - V.assistant.market.aggressiveness) { /* SELL */
			if (V.menials + V.fuckdolls + V.menialBioreactors > 0) {
				r.push(`${HeM} liquidates your chattel holdings, since it's a sellers' market.`);
			}
			let _cashX;
			if (V.menials > 0) {
				_cashX = V.menials * (menialSlaveCost(-V.menials));
				V.menialDemandFactor -= V.menials;
				V.menials = 0;
				cashX(_cashX, "menialTransferA");
			}
			if (V.fuckdolls > 0) {
				_cashX = V.fuckdolls * (menialSlaveCost(-V.fuckdolls) * 2);
				V.menialDemandFactor -= V.fuckdolls;
				V.fuckdolls = 0;
				cashX(_cashX, "fuckdollsTransferA");
			}
			if (V.menialBioreactors > 0) {
				_cashX = V.menialBioreactors * (menialSlaveCost(-V.menialBioreactors) - 100);
				V.menialDemandFactor -= V.menialBioreactors;
				V.menialBioreactors = 0;
				cashX(_cashX, "menialBioreactorsTransferA");
			}
		} else {
			r.push(`Prices are average, so ${heM} does not make any significant moves.`);
		}
		App.Events.addParagraph(el, r);
		r = [];
	}

	const food = document.createElement("span");
	food.id = "food";
	if (V.foodMarket > 0) {
		food.append(App.UI.DOM.renderPassage("Food Report"));
	}
	el.append(food);

	App.Events.addNode(el, r);
	return el;

	function fsImpact() {
		const el = new DocumentFragment();
		const r = [];

		if (V.arcologies[0].FSSupremacist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSSupremacist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * 0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * 0.05;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * -80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * -0.004;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * -16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * 5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * 2;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSupremacist, 100) / 20) * 0.004;
			r.push(`Your racial policies are concentrating power in the hands of ${V.arcologies[0].FSSupremacistRace} people.`); /* perhaps too obvious to bother with printing? */
		}
		if (V.arcologies[0].FSSubjugationist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSSubjugationist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * 0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * 0.05;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * -80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * -0.004;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * -16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * 5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * 2;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSubjugationist, 100) / 20) * 0.004;
			r.push(`Your racial policies are stripping all power from the ${V.arcologies[0].FSSubjugationistRace} people.`); /* perhaps too obvious to bother with printing? */
		}
		if (V.arcologies[0].FSGenderRadicalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSGenderRadicalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSGenderRadicalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSGenderRadicalist, 100) / 20) * 0.025;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSGenderRadicalist, 100) / 20) * -40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSGenderRadicalist, 100) / 20) * -0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSGenderRadicalist, 100) / 20);
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSGenderRadicalist, 100) / 20) * 0.002;
			r.push(`Your radical views on gender are scaring away the more traditionally minded.`);
		}
		if (V.arcologies[0].FSGenderFundamentalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSGenderFundamentalist, 100);
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSGenderFundamentalist, 100) / 20) * 40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSGenderFundamentalist, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSGenderFundamentalist, 100) / 20) * -1;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSGenderFundamentalist, 100) / 20) * -0.002;
			r.push(`Your traditional views on gender are comforting to many, unimaginative to some.`);
		}
		if (V.arcologies[0].FSPaternalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSPaternalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.05;
			_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.15;
			_slaveProductivity += Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * 0.02;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * 80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * 0.004;
			_welfareFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.1;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * 16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * 0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -2;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.002;
			r.push(`Poor citizens can rely on their better-off peers in ${V.arcologies[0].name}.`);
		}
		if (V.arcologies[0].FSDegradationist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSDegradationist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.05;
			_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.2;
			_slaveProductivity += Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.01;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * -80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * -0.004;
			_welfareFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.1;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * -16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 2;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSDegradationist, 100) / 20) * 0.004;
			r.push(`The arcology is a cutthroat place in which falling into slavery is very easy.`);
		}
		if (V.arcologies[0].FSIntellectualDependency !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSIntellectualDependency, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 0.03;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 0.04;
			_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 0.05;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 20;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 0.002;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 10;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * 0.003;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * -3;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSIntellectualDependency, 100) / 20) * -0.020;
			r.push(`It's always a party in ${V.arcologies[0].name}, giving it a strong appeal to those unable to host such an event.`);
		}
		if (V.arcologies[0].FSSlaveProfessionalism !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSSlaveProfessionalism, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * -0.1;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * -0.125;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * -20;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * 2.7;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * 0.001;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * 0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSSlaveProfessionalism, 100) / 20) * 0.001;
			r.push(`The intelligent atmosphere of ${V.arcologies[0].name} makes it an attractive place for those with the brains to define their place in the world.`);
		}
		if (V.arcologies[0].FSBodyPurist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSBodyPurist, 100);
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * 40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * 0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * -2.7;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * -0.001;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * -0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * -0.001;
			r.push(`Body purist fashion standards comfort the poor as they stand out less from their more fortunate neighbors.`);
		}
		if (V.arcologies[0].FSTransformationFetishist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSTransformationFetishist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * 0.025;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * -40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * 2.7;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * 0.001;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * 0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSTransformationFetishist, 100) / 20) * 0.001;
			r.push(`The lower class fear the kind of transformations could be forced on them if they ever end up enslaved, whereas the rich enjoy wielding such power.`);
		}
		if (V.arcologies[0].FSYouthPreferentialist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSYouthPreferentialist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSYouthPreferentialist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSYouthPreferentialist, 100) / 20) * 0.025;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSYouthPreferentialist, 100) / 20) * 40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSYouthPreferentialist, 100) / 20) * 0.002;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSYouthPreferentialist, 100) / 20) * -8;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSYouthPreferentialist, 100) / 20) * -0.002;
			r.push(`Preference for youth makes the young poor in your arcology feel appreciated despite their lack of wealth.`);
		}
		if (V.arcologies[0].FSMaturityPreferentialist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSMaturityPreferentialist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSMaturityPreferentialist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSMaturityPreferentialist, 100) / 20) * 0.025;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSMaturityPreferentialist, 100) / 20) * -40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSMaturityPreferentialist, 100) / 20) * -0.002;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSMaturityPreferentialist, 100) / 20) * 8;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSMaturityPreferentialist, 100) / 20) * 0.002;
			r.push(`Preference for maturity makes the middle class of your arcology feel like their experience is finally properly appreciated.`);
		}
		if (V.arcologies[0].FSPetiteAdmiration !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSPetiteAdmiration, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPetiteAdmiration, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPetiteAdmiration, 100) / 20) * 0.025;
		}
		if (V.arcologies[0].FSStatuesqueGlorification !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSStatuesqueGlorification, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSStatuesqueGlorification, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSStatuesqueGlorification, 100) / 20) * 0.025;
		}
		if (V.arcologies[0].FSSlimnessEnthusiast !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSSlimnessEnthusiast, 100);
		}
		if (V.arcologies[0].FSAssetExpansionist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSAssetExpansionist, 100);
			if (V.arcologies[0].FSBodyPurist !== "unset") {
				_expirationFS *= 1 + (Math.trunc(Math.min(V.arcologies[0].FSAssetExpansionist, 100) / 20) * 0.05) * (1 + (Math.trunc(Math.min(V.arcologies[0].FSBodyPurist, 100) / 20) * -0.1));
			} else {
				_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSAssetExpansionist, 100) / 20) * 0.05;
			}
		}
		if (V.arcologies[0].FSPastoralist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSPastoralist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.05;
			if (V.arcologies[0].FSPaternalist !== "unset") {
				_expirationFS *= 1 + (Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.05) * (1 + (Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.1));
			} else {
				_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.05;
			}
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * -80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * -0.004;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 2.7;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.001;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPastoralist, 100) / 20) * 0.001;
			r.push(`The pastoralization of ${V.arcologies[0].name} spurs a whole industry around human produce.`);
		}
		if (V.arcologies[0].FSPhysicalIdealist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSPhysicalIdealist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 0.025;
			_slaveProductivity += Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 0.01;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * -40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 2.7;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 0.001;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSPhysicalIdealist, 100) / 20) * 0.001;
			r.push(`Fit slaves and citizens are more productive! However, your arcology's poor do not look forward to even more toil and sweat.`);
		}
		if (V.arcologies[0].FSChattelReligionist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSChattelReligionist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * 0.025;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * -40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * 2.7;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * 0.001;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * 0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChattelReligionist, 100) / 20) * 0.001;
			r.push(`Chattel Religionism helps some poor citizens see slavery as a spiritually pure fate.`);
		}
		if (V.arcologies[0].FSRomanRevivalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSRomanRevivalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * 0.025;
			_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * -0.1;
			_welfareFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * -0.05;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * 40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * 0.00;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20);
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRomanRevivalist, 100) / 20) * -0.002;
			r.push(`Your citizens take pride in looking after each other.`);
		}
		if (V.arcologies[0].FSNeoImperialist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSNeoImperialist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 0.05;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 0.030;
			_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * -0.06;
			_welfareFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * -0.025;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * -20;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * -0.002;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 0.004;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 0.5;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNeoImperialist, 100) / 20) * 0.002;
			r.push(`Your new Imperium creates a staunchly hierarchical society, and while your elites and soldiers enjoy social prestige and luxury, the lower classes are often unhappy about being made to grovel.`);
		}
		if (V.arcologies[0].FSEgyptianRevivalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSEgyptianRevivalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20) * 0.025;
			_welfareFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20) * -0.05;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20) * 40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20);
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEgyptianRevivalist, 100) / 20) * -0.002;
			r.push(`Egyptian Revivalism is benevolent in some ways, and charity is common here.`);
		}
		if (V.arcologies[0].FSEdoRevivalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSEdoRevivalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEdoRevivalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSEdoRevivalist, 100) / 20) * 0.025;
		}
		if (V.arcologies[0].FSArabianRevivalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSArabianRevivalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSArabianRevivalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSArabianRevivalist, 100) / 20) * 0.025;
		}
		if (V.arcologies[0].FSChineseRevivalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSChineseRevivalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChineseRevivalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSChineseRevivalist, 100) / 20) * 0.025;
		}
		if (V.arcologies[0].FSAztecRevivalist !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSAztecRevivalist, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSAztecRevivalist, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSAztecRevivalist, 100) / 20) * 0.025;
		}
		if (V.arcologies[0].FSNull !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSNull, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * -0.1;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * -0.125;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * 400;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * 0.016;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * 64;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * 0.008;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * -21.6;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * -0.008;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * -8;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSNull, 100) / 20) * -0.016;
			r.push(`Your arcology's vibrant, open culture helps everyone succeed, preventing many struggling citizens from falling into slavery.`);
		}
		if (V.arcologies[0].FSRepopulationFocus !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSRepopulationFocus, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 0.05;
			_slaveProductivity += Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * -0.01;
			if (V.arcologies[0].FSPaternalist !== "unset") {
				_expirationFS *= 1 + (Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 0.05) * (1 + (Math.trunc(Math.min(V.arcologies[0].FSPaternalist, 100) / 20) * -0.1));
			} else {
				_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 0.05;
			}
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 0.004;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * 0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * -5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * -0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * -2;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRepopulationFocus, 100) / 20) * -0.004;
			r.push(`You've made repopulation a priority and the less fortunate hope all these new children will make their lives easier in the future, but the wealthy are wary.`);
		}
		if (V.arcologies[0].FSRestart !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSRestart, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * 0.04;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * 0.05;
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * -80;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * -0.004;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * -16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * 5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * 0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * 2;
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSRestart, 100) / 20) * 0.004;
			r.push(`Highly restricted breeding pleases the powerful, but the less fortunate may seek reproductive freedom elsewhere.`);
		}
		if (V.arcologies[0].FSHedonisticDecadence !== "unset") {
			_FSScore += Math.min(V.arcologies[0].FSHedonisticDecadence, 100);
			_slaveDemandU *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * 0.02;
			_slaveDemandT *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * 0.025;
			_slaveProductivity += Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * -0.01;
			_expirationFS *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * 0.1; /* too high?*/
			_lowerClass += Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * 40;
			_lowerClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * 0.002;
			_middleClass += Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * -16;
			_middleClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * -0.002;
			_upperClass += Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * -5.4;
			_upperClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * -0.002;
			_topClass += Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20);
			_topClassP *= 1 + Math.trunc(Math.min(V.arcologies[0].FSHedonisticDecadence, 100) / 20) * 0.002;
			r.push(`Your citizens enjoy the pleasures of life to their fullest, but some prefer to earn these pleasures.`);
		}
		if (r.length > 0) {
			App.UI.DOM.appendNewElement("h3", el, "Future Societies");
		}
		App.Events.addNode(el, r);
		return el;
	}

	function policiesImpact() {
		const el = new DocumentFragment();
		const r = [];
		if (V.policies.retirement.menial2Citizen === 1) {
			_slaveDemandU *= 0.8;
			_slaveDemandT *= 0.75;
			_slaveProductivity += 0.05;
			_expirationFS *= 0.8;
			_lowerClass += 200;
			_lowerClassP *= 1.01;
			_middleClass += 80;
			_middleClassP *= 1.01;
			_upperClass += -27;
			_upperClassP *= 0.99;
			_topClass += -5;
			_topClassP *= 0.99;
		}
		if (V.policies.proRefugees === 1) {
			_slaveDemandU *= 1.1;
			_slaveDemandT *= 1.125;
			r.push(`Some desperate people filtered into the arcology during the week: as owner, you were able to enslave a handful of them.`);
		}
		if (V.policies.immigrationCash === 1) {
			_lowerClass += 200;
			_lowerClassP *= 1.01;
			_middleClass += 40;
			_middleClassP *= 1.005;
			_upperClass += -13.5;
			_upperClassP *= 0.995;
			_topClass += -5;
			_topClassP *= 0.99;
			r.push(`The rent promotion for new immigrants brings new citizens to the arcology.`);
		}
		if (V.policies.immigrationRep === 1) {
			_lowerClass += 200;
			_lowerClassP *= 1.01;
			_middleClass += 40;
			_middleClassP *= 1.005;
			_upperClass += -13.5;
			_upperClassP *= 0.995;
			_topClass += -5;
			_topClassP *= 0.99;
			r.push(`Your welcome program for new citizens helps encourage wealthy people from the old world to immigrate, but <span class="red">annoys some longstanding citizens.</span>`);
			repX(forceNeg(100), "policies");
		}
		if (V.policies.immigrationCash === -1) {
			_lowerClass += -200;
			_lowerClassP *= 0.99;
			_middleClass += -40;
			_middleClassP *= 0.995;
			_upperClass += 13.5;
			_upperClassP *= 1.005;
			_topClass += 5;
			_topClassP *= 1.01;
			r.push(`You covertly <span class="yellowgreen">sell</span> the private information of potential arcology immigrants on the old world black market.`);
			cashX(random(500, 1500), "policies");
		}
		if (V.policies.immigrationRep === -1) {
			_lowerClass += -200;
			_lowerClassP *= 0.99;
			_middleClass += -40;
			_middleClassP *= 0.995;
			_upperClass += 13.5;
			_upperClassP *= 1.005;
			_topClass += 5;
			_topClassP *= 1.01;
			r.push(`You allow citizens input on potential immigrants, a <span class="green">popular</span> program.`);
			repX(100, "policies");
		}
		if (V.policies.enslavementCash === 1) {
			_slaveDemandU *= 1.1;
			_slaveDemandT *= 1.125;
			_lowerClass += -200;
			_lowerClassP *= .99;
			_topClass += 5;
			_topClassP *= 1.01;
			r.push(`You <span class="yellowgreen">take kickbacks</span> for ignoring enslavement of citizens.`);
			cashX(random(500, 1500), "policies");
		}
		if (V.policies.enslavementRep === 1) {
			_slaveDemandU *= 1.1;
			_slaveDemandT *= 1.125;
			_lowerClass += -200;
			_lowerClassP *= 0.99;
			_topClass += 5;
			_topClassP *= 1.01;
			r.push(`You <span class="green">make friends</span> by tacitly supporting enslavement of upstart citizens.`);
			repX(100, "policies");
		}
		if (V.policies.enslavementCash === -1) {
			_slaveDemandU *= 0.9;
			_slaveDemandT *= 0.875;
			_lowerClass += 200;
			_lowerClassP *= 1.02;
			_topClass += -5;
			_topClassP *= 0.98;
			r.push(`Your charity purse prevents a few citizens from falling into slavery.`);
		}
		if (V.policies.enslavementRep === -1) {
			_slaveDemandU *= 0.9;
			_slaveDemandT *= 0.875;
			_lowerClass += 200;
			_lowerClassP *= 1.01;
			_topClass += -5;
			_topClassP *= 0.99;
			r.push(`You use your personal influence to help struggling citizens.`);
			repX(forceNeg(100), "policies");
		}
		if (V.arcologies[0].FSSupremacistLawME === 1) {
			_slaveDemandU *= 2.2;
			_slaveDemandT *= 2.5;
			_lowerClass += -400;
			_lowerClassP *= 0.98;
			_middleClass += -80;
			_middleClassP *= 0.99;
			_upperClass += 27;
			_upperClassP *= 1.01;
			_topClass += 10;
			_topClassP *= 1.02;
			if (V.FSSupLawTrigger === 1) {
				const _slavesSupLaw = Math.trunc((V.lowerClass + V.middleClass + V.upperClass) * 0.65);
				V.NPCSlaves += Math.trunc(_slavesSupLaw * 0.7);
				V.menials += Math.trunc(_slavesSupLaw * 0.2);
				V.lowerClass = Math.trunc(V.lowerClass * 0.35);
				V.middleClass = Math.trunc(V.middleClass * 0.35);
				V.upperClass = Math.trunc(V.upperClass * 0.35);
				V.FSSupLawTrigger = 2;
			}
		}
		if (V.arcologies[0].FSSubjugationistLawME === 1) {
			_slaveDemandU *= 1.24;
			_slaveDemandT *= 1.3;
			_lowerClass += -200;
			_lowerClassP *= 0.99;
			_middleClass += -40;
			_middleClassP *= 0.995;
			_upperClass += 13.5;
			_upperClassP *= 1.005;
			_topClass += 5;
			_topClassP *= 1.01;
			if (V.FSSubLawTrigger === 1) {
				const _slavesSubLaw = Math.trunc((V.lowerClass + V.middleClass + V.upperClass) * 0.2);
				V.NPCSlaves += Math.trunc(_slavesSubLaw * 0.7);
				V.menials += Math.trunc(_slavesSubLaw * 0.2);
				V.lowerClass = Math.trunc(V.lowerClass * 0.8);
				V.middleClass = Math.trunc(V.middleClass * 0.8);
				V.upperClass = Math.trunc(V.upperClass * 0.8);
				V.FSSubLawTrigger = 2;
			}
		}
		if (V.arcologies[0].FSRepopulationFocusLaw === 1) {
			_lowerClass += 100;
			_lowerClassP *= 1.005;
			_topClass += -2.5;
			_topClassP *= 0.995;
			r.push(`The rent promotion for pregnant women attracts several gravid ladies and a few girls eager to become mothers to enroll as citizens in your arcology.`);
		}
		if (V.arcologies[0].FSRestartLaw === 1) {
			_lowerClass += -100;
			_lowerClassP *= 0.99;
			_topClass += 2.5;
			_topClassP *= 1.01;
			r.push(`Your sterilization program drives several disloyal citizens out of the arcology.`);
		}
		if (V.arcologies[0].FSHedonisticDecadenceLaw === 1) {
			_middleClass += 80;
			_middleClassP *= 1.01;
		}
		if (V.arcologies[0].FSDegradationistLaw === 1) {
			_slaveProductivity += -0.05;
		}
		if (V.arcologies[0].FSPaternalistLaw === 1) {
			_slaveDemandU *= 0.9;
			_slaveDemandT *= 0.875;
			_upperClass += -13.5;
			_upperClassP *= 1.005;
			_topClass += -2.5;
			_topClassP *= 1.005;
		}
		if (V.arcologies[0].FSYouthPreferentialistLaw === 1) {
			_lowerClass += 200;
			_lowerClassP *= 1.01;
			_middleClass += -80;
			_middleClassP *= 0.99;
		}
		if (V.arcologies[0].FSMaturityPreferentialistLaw === 1) {
			_lowerClass += -200;
			_lowerClassP *= 0.99;
			_middleClass += 80;
			_middleClassP *= 1.01;
		}
		if (V.arcologies[0].FSPetiteAdmirationLaw === 1) {
			_lowerClass += -200;
			_lowerClassP *= 0.99;
			_middleClass += 80;
			_middleClassP *= 1.01;
		}
		if (V.arcologies[0].FSStatuesqueGlorificationLaw === 1) {
			_lowerClass += -400;
			_lowerClassP *= 0.95;
			_middleClass += 40;
			_middleClassP *= 1.01;
			_upperClass += -10;
			_upperClassP *= .99;
		}
		if (V.arcologies[0].FSIntellectualDependencyLaw === 1) {
			_slaveDemandU *= 1.24;
			_slaveDemandT *= 1.3;
			_lowerClass += -50;
			_lowerClassP *= 0.90;
			_middleClass += -40;
			_middleClassP *= 0.90;
			_upperClass += -1;
			_upperClassP *= .99;
		}
		if (V.arcologies[0].FSSlaveProfessionalismLaw === 1) {
			_slaveDemandU *= 1.4;
			_slaveDemandT *= 1.5;
			_lowerClass += -300;
			_lowerClassP *= 0.95;
			_middleClass += -40;
			_middleClassP *= 0.995;
			_upperClass += -5;
			_upperClassP *= .99;
			_topClass += 7;
			_topClassP *= 1.05;
			if (V.FSSlaveProfLawTrigger === 1) {
				V.lowerClass = Math.trunc(V.lowerClass * 0.8);
				V.middleClass = Math.trunc(V.middleClass * 0.8);
				V.upperClass = Math.trunc(V.upperClass * 0.8);
				V.FSSlaveProfLawTrigger = 2;
			}
		}
		if (V.arcologies[0].FSChattelReligionistCreed === 1) {
			if (V.nicaea.focus === "slaves") {
				_slaveDemandU *= 1 + V.nicaea.power * -0.05;
				_slaveDemandT *= 1 + V.nicaea.power * -0.0625;
				_slaveProductivity += V.nicaea.power * 0.025;
				_expirationFS *= 1 + V.nicaea.power * -0.125;
				_lowerClass += V.nicaea.power * 100;
				_lowerClassP *= 1 + V.nicaea.power * 0.005;
				_topClass += V.nicaea.power * -2.5;
				_topClassP *= 1 + V.nicaea.power * -0.005;
			} else if (V.nicaea.focus === "owners") {
				_slaveDemandU *= 1 + V.nicaea.power * 0.05;
				_slaveDemandT *= 1 + V.nicaea.power * 0.0625;
				_lowerClass += V.nicaea.power * -100;
				_lowerClassP *= 1 + V.nicaea.power * -0.005;
				_middleClass += V.nicaea.power * -20;
				_middleClassP *= 1 + V.nicaea.power * -0.0025;
				_upperClass += V.nicaea.power * 6.75;
				_upperClassP *= 1 + V.nicaea.power * 0.0025;
				_topClass += V.nicaea.power * 2.5;
				_topClassP *= 1 + V.nicaea.power * 0.005;
			}
			if (V.nicaea.assignment === "whore") {
				_upperClass += V.nicaea.power * 6.75;
				_upperClassP *= 1 + V.nicaea.power * 0.0025;
				_topClass += V.nicaea.power * 1.25;
				_topClassP *= 1 + V.nicaea.power * 0.0025;
			} else if (V.nicaea.assignment === "serve the public") {
				_lowerClass += V.nicaea.power * 50;
				_lowerClassP *= 1 + V.nicaea.power * 0.0025;
				_middleClass += V.nicaea.power * 20;
				_middleClassP *= 1 + V.nicaea.power * 0.0025;
			} else {
				_slaveDemandU *= 1 + V.nicaea.power * 0.05;
				_slaveDemandT *= 1 + V.nicaea.power * 0.0625;
				_lowerClass += V.nicaea.power * -50;
				_lowerClassP *= 1 + V.nicaea.power * -0.0025;
				_middleClass += V.nicaea.power * -20;
				_middleClassP *= 1 + V.nicaea.power * -0.0025;
				_upperClass += V.nicaea.power * 13.5;
				_upperClassP *= 1 + V.nicaea.power * 0.005;
				_topClass += V.nicaea.power * 2.5;
				_topClassP *= 1 + V.nicaea.power * 0.005;
			}
			if (V.nicaea.achievement === "slaves") {
				_slaveDemandU *= 1 + V.nicaea.power * 0.2;
				_slaveDemandT *= 1 + V.nicaea.power * 0.25;
				_lowerClass += V.nicaea.power * -200;
				_lowerClassP *= 1 + V.nicaea.power * -0.01;
			}
		}
		if (V.arcologies[0].FSAztecRevivalistLaw === 1) {
			_lowerClass += 200;
			_lowerClassP *= 1.01;
			_middleClass += -40;
			_middleClassP *= 0.995;
			_upperClass += -13.5;
			_upperClassP *= 0.995;
		}
		if (r.length > 0) {
			App.UI.DOM.appendNewElement("h3", el, "Policies");
		}
		App.Events.addNode(el, r);
		return el;
	}

	function schools() {
		const el = document.createElement("p");
		for (const [SCH, schObj] of App.Data.misc.schools) {
			if (V[SCH].schoolPresent !== 1) {
				continue;
			}
			const r = [];
			r.push(`${capFirstChar(schObj.title)} has a`);
			if (V[SCH].schoolProsperity > 4) {
				r.push(`very prosperous`);
			} else if (V[SCH].schoolProsperity < -4) {
				r.push(`struggling`);
			} else {
				r.push(`thriving`);
			}
			r.push(`${schObj.branchName} in ${V.arcologies[0].name}.`);
			if (V[SCH].schoolProsperity >= 10) {
				switch (SCH) {
					case "GRI":
						r.push(`It is one of the finest research facilities in the world`);
						break;
					case "TFS":
						r.push(`They are one of the most renowned futa societies in the world`);
						break;
					case "HA":
						r.push(`It is one of the most famous schools in the world`);
						break;
					default:
						r.push(`It is one of the finest slave schools in the world`);
				}
				if (V.rep > 19000) {
					r.push(r.pop() + `.`);
				} else {
					r.push(r.pop() + `, <span class="green">improving your reputation.</span>`);
					repX(200, "policies");
				}
				V[SCH].subsidize = 0;
				V[SCH].schoolProsperity = 10;
			}
			if (V[SCH].subsidize === 1) {
				r.push(`You have a policy of subsidizing them.`);
				V[SCH].schoolProsperity++;
			} else if (V[SCH].subsidize === -1) {
				r.push(`You have a policy of covertly undermining them.`);
				V[SCH].schoolProsperity--;
			}
			App.Events.addNode(el, r, "div");
		}

		return el;
	}

	function isFrozen() {
		/* during bad weather and without appropriate upgrades, transport (including visitors and immigration/emigration) will be halted */
		let _weatherFreeze = 0;
		if (V.weatherToday.severity > 3) {
			if (V.secExpEnabled > 0 && V.SecExp.buildings.transportHub) {
				if (V.SecExp.buildings.transportHub.surfaceTransport < 4) {
					_weatherFreeze = 1;
				}
			} else if (V.antiWeatherFreeze < 2) {
				_weatherFreeze = 1;
			}
		} else if (V.weatherToday.severity > 2) {
			if (V.secExpEnabled > 0 && V.SecExp.buildings.transportHub) {
				if (V.SecExp.buildings.transportHub.surfaceTransport < 3) {
					_weatherFreeze = 1;
				}
			} else if (V.antiWeatherFreeze < 1) {
				_weatherFreeze = 1;
			}
		}
		if (_weatherFreeze) {
			const warning = App.UI.DOM.combineNodes(`The terrible weather is `, App.UI.DOM.makeElement("span", `preventing people from entering or leaving`, "red"), ` your arcology. Improving your transport infrastructure will prevent this from happening.`);
			App.UI.DOM.appendNewElement("div", el, warning, "note");
			V.weatherAwareness = 1;
		}
		return _weatherFreeze;
	}

	function enslavement() {
		if (_enslaved > 0) {
			const _enslavedPC = Math.max(Math.trunc(_enslaved / 4), 1);
			const _enslavedNPC = _enslaved - _enslavedPC;
			V.menials += _enslavedPC;
			V.NPCSlaves += _enslavedNPC;
			if (_enslaved > 1) {
				appendDiv(`In total <span class="green">${num(_enslaved)} lower class citizens</span> were enslaved for failing to pay their debts.`);
				appendDiv(`<span class="green">You enslaved ${num(_enslavedPC)}</span> of them while other debtholders in the arcology enslaved the remaining ${num(_enslavedNPC)}.`);
			} else {
				appendDiv(`<span class="green">As arcology owner you claimed the slave.</span>`);
			}
		}
	}

	function transport() {
		_FSScore = _FSScore / V.FSCreditCount;
		_transportHub = 1;
		_crime = 0.8;
		if (V.secExpEnabled > 0) {
			_transportHub = 0.7;
			if (V.SecExp.buildings.transportHub) {
				_transportHub += V.SecExp.buildings.transportHub.airport / 10 + V.SecExp.buildings.transportHub.surfaceTransport / 10;
			}
			_crime = (100 - V.SecExp.core.crimeLow) / 100 + 0.2;
		}
		if (V.terrain === "urban") {
			_terrain = 1.2;
		} else if (V.terrain === "rural" || V.terrain === "marine") {
			_terrain = 1;
		} else {
			_terrain = 0.8;
		}

		_honeymoon = 0;
		if (V.arcologies[0].honeymoon > 0) {
			_honeymoon = 10 * V.arcologies[0].honeymoon;
		}
		const _oldVisitors = V.visitors;
		V.visitors = Math.trunc(((V.arcologies[0].prosperity + _FSScore * 5 + _honeymoon) * _transportHub * _terrain * _crime) * _econMult);
		if (V.visitors < 50) {
			V.visitors = normalRandInt(50, 2);
		}
		if (isNaN(V.visitors)) {
			appendDiv(`<span class="red">Visitors is NaN, report this issue!</span>`);
			V.visitors = _oldVisitors;
		}
		appendDiv(`<span class="green">${num(V.visitors)} traders and tourists</span> visited your arcology this week.`);
		appendDiv(App.SecExp.propagandaEffects("enslavement").text);
		_enslaved += App.SecExp.propagandaEffects("enslavement").effect;

		/* slaves*/
		/* Slaves getting retired*/
		if (V.policies.retirement.menial2Citizen === 1) {
			let _weeklyRetiredMenials = V.menials / ((V.customMenialRetirementAge - 15) * 52);
			let _weeklyRetiredNPCMenials = V.NPCSlaves / ((V.customMenialRetirementAge - 15) * 52);
			/* This implies a minimum menial age of 15. Even if the player sets minimum ages lower, there's no point having a 3 year old menial slave. 15 seems alright while being nice and round. This also implies ages are distributed evenly, no easy way around that.*/
			if (_weeklyRetiredMenials > 1) {
				_weeklyRetiredMenials = Math.trunc(_weeklyRetiredMenials);
				if (_weeklyRetiredMenials > 1) {
					appendDiv(`<span class="red">${num(_weeklyRetiredMenials)} of your menial slaves</span> retired as free citizens this week.`);
				} else {
					appendDiv(`<span class="red">One of your menial slaves</span> retired as a free citizen this week.`);
				}
			} else {
				_weeklyRetiredMenials *= 100;
				if (_weeklyRetiredMenials > random(1, 100)) {
					_weeklyRetiredMenials = 1;
					appendDiv(`<span class="red">One of your menial slaves</span> retired as a free citizen this week.`);
				} else {
					_weeklyRetiredMenials = 0;
				}
			}
			if (_weeklyRetiredNPCMenials > 1) {
				_weeklyRetiredNPCMenials = Math.trunc(_weeklyRetiredNPCMenials);
				if (_weeklyRetiredNPCMenials > 1) {
					appendDiv(`<span class="red">${num(_weeklyRetiredNPCMenials)} menial slaves</span> were retired as free citizens by other slave owners in your arcology this week.`);
				} else {
					appendDiv(`<span class="red">One menial slave</span> was retired as a free citizen by another slave owner in your arcology this week.`);
				}
			} else {
				_weeklyRetiredNPCMenials *= 100;
				if (_weeklyRetiredNPCMenials > random(1, 100)) {
					_weeklyRetiredNPCMenials = 1;
					appendDiv(`<span class="red">One menial slave</span> was retired as a free citizen by another slave owner in your arcology this week.`);
				} else {
					_weeklyRetiredNPCMenials = 0;
				}
			}
			V.menials -= _weeklyRetiredMenials;
			V.NPCSlaves -= _weeklyRetiredNPCMenials;
			V.lowerClass += _weeklyRetiredMenials + _weeklyRetiredNPCMenials;
		}
		/* Demand for simple labor*/
		_LSCD = Math.trunc((V.LSCBase * _econMult) + (V.arcologies[0].prosperity * 4) + ((V.middleClass + V.visitors * 0.6) * 1.5) + ((V.upperClass + V.visitors * 0.2) * 3.5) + (V.topClass * 18));
		/* Demand for owning slaves*/
		_SCD = Math.trunc((V.upperClass * (2 + _slaveDemandU)) + (V.topClass * (12 + _slaveDemandT)));
		if (isNaN(_LSCD)) {
			appendDiv(`<span class="red">LSCD is NaN, report this issue!</span>`);
		} else if (isNaN(_SCD)) {
			appendDiv(`<span class="red">SCD is NaN, report this issue!</span>`);
		} else {
			/* More slaves than they know what to do with*/
			if (V.NPCSlaves > _SCD * 1.6) {
				const _NPCSlavesSold = V.NPCSlaves - Math.trunc(_SCD * 1.6);
				V.menialDemandFactor -= _NPCSlavesSold;
				V.NPCSlaves = Math.trunc(_SCD * 1.6);
				if (_NPCSlavesSold > 1) {
					appendDiv(`<span class="red">${num(_NPCSlavesSold)}</span> slaves were sold by your inhabitants. They've got more than enough of them already.`);
				} else if (_NPCSlavesSold > 0) {
					appendDiv(`<span class="red">One slave</span> was sold by your inhabitants. They've got more than enough of them already.`);
				}
				/* More slaves than there is work*/
			} else if (V.NPCSlaves > (_LSCD / _slaveProductivity) - V.menials + _SCD) {
				const _NPCSlavesSold = V.NPCSlaves - Math.trunc(_LSCD / _slaveProductivity - V.menials + _SCD);
				V.menialDemandFactor -= _NPCSlavesSold;
				V.NPCSlaves = Math.trunc(_LSCD / _slaveProductivity);
				if (_NPCSlavesSold > 1) {
					appendDiv(`<span class="red">${num(_NPCSlavesSold)}</span> slaves were sold by your inhabitants. There was so little work that they failed to earn their keep.`);
				} else if (_NPCSlavesSold > 0) {
					appendDiv(`<span class="red">One slave</span> was sold by your inhabitants. There was so little work that it failed to earn its keep.`);
				}
				/* Cutting back on slaves*/
			} else if (V.NPCSlaves > _SCD * 1.4) {
				if (V.slaveCostFactor > 0.95) {
					const _NPCSlavesSold = Math.trunc((V.NPCSlaves - _SCD) * 0.4);
					V.menialDemandFactor -= _NPCSlavesSold;
					V.NPCSlaves -= _NPCSlavesSold;
					if (_NPCSlavesSold > 1) {
						appendDiv(`<span class="red">${num(_NPCSlavesSold)}</span> slaves were sold by your inhabitants. They've got more than enough of them already.`);
					} else if (_NPCSlavesSold > 0) {
						appendDiv(`<span class="red">One slave</span> was sold by your inhabitants. They've got more than enough of them already.`);
					}
				}
				/* Selling excess slaves for profit*/
			} else if (V.NPCSlaves > _SCD * 1.2) {
				if (V.slaveCostFactor > 1.1) {
					const _NPCSlavesSold = Math.trunc((V.NPCSlaves - _SCD) * 0.4);
					V.menialDemandFactor -= _NPCSlavesSold;
					V.NPCSlaves -= _NPCSlavesSold;
					if (_NPCSlavesSold > 1) {
						appendDiv(`<span class="red">${num(_NPCSlavesSold)}</span> were sold by your inhabitants. They saw an opportunity for profit.`);
					} else if (_NPCSlavesSold > 0) {
						appendDiv(`<span class="red">One slave</span> was sold by your inhabitants. They saw an opportunity for profit.`);
					}
				}
			}
			/* Buying slaves because they are really cheap*/
			if (V.slaveCostFactor < 0.8) {
				if (V.NPCSlaves < _SCD * 1.5) {
					const _NPCSlavesBought = Math.trunc(_SCD * 0.05);
					V.menialSupplyFactor -= _NPCSlavesBought;
					V.NPCSlaves += _NPCSlavesBought;
					if (_NPCSlavesBought > 1) {
						appendDiv(`<span class="green">${num(_NPCSlavesBought)} slaves</span> were bought by your inhabitants. They were too cheap to pass up on.`);
					} /* there's no way this ever ends up needing a 1 slave version*/
				}
			}
		}

		/* Lower Class Citizens*/
		/* Work left for lower class citizens*/
		_LCD = Math.trunc(((V.LSCBase * _econMult) + (V.arcologies[0].prosperity * 4) + _lowerClass + ((V.middleClass + V.visitors * 0.6) * 1.5) + ((V.upperClass + V.visitors * 0.2) * 3.5) + (V.topClass * 18) - (V.NPCSlaves + V.menials) * _slaveProductivity) * V.rentEffectL * _lowerClassP);
		if (V.classSatisfied.lowerClass !== 0) {
			_LCD *= 1 + V.classSatisfied.lowerClass * 0.06;
		}
		if (_LCD < 0) {
			_LCD = 0;
		}
		if (isNaN(_LCD)) {
			appendDiv(`<span class="red">LCD is NaN, report this issue!</span>`);
		} else { /* Changing population depending on work available*/
			if (V.classSatisfied.lowerClass < 0) {
				appendDiv(`Your lower class is <span class="red">sexually frustrated</span> and would rather live elsewhere.`);
			} else if (V.classSatisfied.lowerClass > 0) {
				appendDiv(`Your lower class is <span class="green">sexually satiated</span> and their happiness attracts others.`);
			}
			r = [];
			if (V.lowerClass < _LCD) {
				let _LCImmigration = Math.trunc((_LCD - V.lowerClass) * (0.3 * _terrain)) + 1 + secExpImigrationBonus.effect;
				if (V.arcologies[0].FSIntellectualDependencyLaw === 1) { /* Enslaving the dumb lower class immigrants*/
					const _intellectualDependencyEnslaved = Math.trunc(_LCImmigration * 0.25);
					_LCImmigration -= _intellectualDependencyEnslaved;
					_enslaved += _intellectualDependencyEnslaved;
					r.push(`<span class="green">${num(_intellectualDependencyEnslaved)} dumb immigrants</span> were enslaved for their own good.`);
				}

				V.lowerClass += _LCImmigration;
				if (_LCImmigration > 1) {
					r.push(`<span class="green">${num(_LCImmigration)} lower class citizens</span> moved to your arcology.`);
				} else if (_LCImmigration > 0) {
					r.push(`<span class="green">One lower class citizen</span> moved to your arcology.`);
				}
			} else if (V.lowerClass > _LCD) {
				const _LCEmigration = Math.trunc((V.lowerClass - _LCD) * 0.4);
				const enslaveChance = 0.2;
				const _enslavedEmigrants = Math.trunc(_LCEmigration * enslaveChance * (1.0 - getBanishRatio()));
				V.lowerClass -= _LCEmigration;
				_enslaved += _enslavedEmigrants;
				if (_LCEmigration > 1) {
					r.push(`<span class="red">${num(_LCEmigration)} lower class citizens</span> had no work and tried to leave your arcology.`);
					if (_enslavedEmigrants > 1) {
						r.push(`<span class="green">${num(_enslavedEmigrants)} of them were enslaved instead.</span>`);
					} else if (_enslavedEmigrants > 0) {
						r.push(`<span class="green">One of them was enslaved instead.</span>`);
					}
				} else if (_LCEmigration > 0) {
					r.push(`<span class="red">One lower class citizen</span> left your arcology due to a lack of work.`);
				}
			}
			App.Events.addNode(el, r, "div");
			enslavement();
			/* Need more slaves still*/
			if (V.NPCSlaves < _SCD) {
				const _NPCSlavesBought = Math.trunc((_SCD - V.NPCSlaves) * 0.75) + 1;
				V.menialSupplyFactor -= _NPCSlavesBought;
				V.NPCSlaves += _NPCSlavesBought;
				if (_NPCSlavesBought > 1) {
					appendDiv(`<span class="green">${num(_NPCSlavesBought)} slaves</span> were bought by your inhabitants. They did not have enough of them to satisfy their needs.`);
				} else if (_NPCSlavesBought > 0) {
					appendDiv(`<span class="green">One slave</span> was bought by your inhabitants. They did not quite have enough of them to satisfy their needs.`);
				}
			}
		}

		/* Middle Class Citizens*/
		/* Demand for Middle Class*/
		_MCD = Math.trunc(((V.MCBase * _econMult) + V.arcologies[0].prosperity + _middleClass + (V.NPCSlaves * 0.15) + (V.lowerClass * 0.1) + ((V.upperClass + V.visitors * 0.2) * 0.5) + (V.topClass * 2.5)) * V.rentEffectM * _middleClassP);
		if (V.classSatisfied.middleClass !== 0) {
			_MCD *= 1 + V.classSatisfied.middleClass * 0.06;
		}
		if (_MCD < 200) {
			_MCD = 200;
		}
		if (isNaN(_MCD)) {
			appendDiv(`<span class="red">MCD is NaN, report this issue!</span>`);
		} else {
			/* Middle Class Citizens immigrating*/
			if (V.classSatisfied.middleClass < 0) {
				appendDiv(`Your middle class is <span class="red">sexually frustrated</span> and would rather live elsewhere.`);
			} else if (V.classSatisfied.middleClass > 0) {
				appendDiv(`Your middle class is <span class="green">sexually satiated</span> and their happiness attracts others.`);
			}
			if (V.middleClass < _MCD) {
				const _MCImmigration = Math.trunc((_MCD - V.middleClass) * (0.3 * _terrain)) + 1 + secExpImigrationBonus.effect;
				V.middleClass += _MCImmigration;
				if (_MCImmigration > 1) {
					appendDiv(`<span class="green">${num(_MCImmigration)} middle class citizens</span> moved to your arcology.`);
				} else if (_MCImmigration > 0) {
					appendDiv(`<span class="green">One middle class citizen</span> moved to your arcology.`);
				}
				/* Middle Class Citizens emigrating*/
			} else if (V.middleClass > _MCD) {
				const _MCEmigration = Math.trunc((V.middleClass - _MCD) * 0.4);
				V.middleClass -= _MCEmigration;
				if (_MCEmigration > 1) {
					appendDiv(`<span class="red">${num(_MCEmigration)} middle class citizens</span> left your arcology.`);
				} else if (_MCEmigration > 0) {
					appendDiv(`<span class="red">One middle class citizen</span> left your arcology.`);
				}
			}
		}

		/* Upper Class Citizens*/
		/* Demand for Upper Class*/
		_UCD = Math.trunc(((V.UCBase * _econMult) + (V.arcologies[0].prosperity * 0.2) + _upperClass + (V.NPCSlaves * 0.02) + (V.lowerClass * 0.025) + ((V.middleClass + V.visitors * 0.6) * 0.05) + (V.topClass * 0.3)) * V.rentEffectU * _upperClassP);
		if (V.classSatisfied.upperClass !== 0) {
			_UCD *= 1 + V.classSatisfied.upperClass * 0.06;
		}
		if (_UCD < 50) {
			_UCD = 50;
		}
		if (isNaN(_UCD)) {
			appendDiv(`<span class="red">UCD is NaN, report this issue!</span>`);
		} else {
			/* Upper Class Citizens immigrating*/
			if (V.classSatisfied.upperClass < 0) {
				appendDiv(`Your upper class is <span class="red">sexually frustrated</span> and would rather live elsewhere.`);
			} else if (V.classSatisfied.upperClass > 0) {
				appendDiv(`Your upper class is <span class="green">sexually satiated</span> and their happiness attracts others.`);
			}
			if (V.upperClass < _UCD) {
				const _UCImmigration = Math.trunc((_UCD - V.upperClass) * (0.3 * _terrain)) + 1 + secExpImigrationBonus.effect;
				V.upperClass += _UCImmigration;
				if (_UCImmigration > 1) {
					appendDiv(`<span class="green">${num(_UCImmigration)} upper class citizens</span> moved to your arcology.`);
				} else if (_UCImmigration > 0) {
					appendDiv(`<span class="green">One upper class citizen</span> moved to your arcology.`);
				}
				/* Upper Class Citizens Emigrating*/
			} else if (V.upperClass > _UCD) {
				const _UCEmigration = Math.trunc((V.upperClass - _UCD) * 0.4);
				V.upperClass -= _UCEmigration;
				if (_UCEmigration > 1) {
					appendDiv(`<span class="red">${num(_UCEmigration)} upper class citizens</span> left your arcology.`);
				} else if (_UCEmigration > 0) {
					appendDiv(`<span class="red">One upper class citizen</span> left your arcology.`);
				}
			}
		}

		/* Top Class Citizens*/
		/* Top Class Interest in living in your arcology*/
		if (V.eliteFailTimer > 0) {
			/* when you fail the eugenics Elite and they leave this triggers*/
			_TCD = Math.trunc((V.GDP / 15 + _topClass) * V.rentEffectT * _topClassP + V.TCBase - (V.eliteFail / 15 * V.eliteFailTimer));
			V.eliteFailTimer -= 1;
		} else {
			_TCD = Math.trunc((V.GDP / 15 + _topClass) * V.rentEffectT * _topClassP + V.TCBase);
		}
		if (V.classSatisfied.topClass !== 0) {
			_TCD *= 1 + V.classSatisfied.topClass * 0.06;
		}
		if (_TCD < 15) {
			_TCD = 15;
		}
		if (isNaN(_TCD)) {
			appendDiv(`<span class="red">TCD is NaN, report this issue!</span>`);
		} else {
			/* Top Class Citizens immigrating*/
			if (V.classSatisfied.topClass < 0) {
				appendDiv(`Your millionaires are <span class="red">sexually frustrated</span> and would rather live elsewhere.`);
			} else if (V.classSatisfied.topClass > 0) {
				appendDiv(`Your millionaires are <span class="green">sexually satiated</span> and their happiness attracts others.`);
			}
			if (V.topClass < _TCD) {
				const _TCImmigration = Math.trunc((_TCD - V.topClass) * (0.3 * _terrain)) + 1 + secExpImigrationBonus.effect;
				V.topClass += _TCImmigration;
				if (_TCImmigration > 1) {
					appendDiv(`<span class="green">${num(_TCImmigration)} millionaires</span> moved to your arcology.`); /* Fat Cat? One-Percenter? */
				} else if (_TCImmigration > 0) {
					appendDiv(`<span class="green">One millionaire</span> moved to your arcology.`);
				}
				/* Top Class Citizens emigrating*/
			} else if (V.topClass > _TCD) {
				const _TCEmigration = Math.trunc((V.topClass - _TCD) * 0.4) + 1;
				V.topClass -= _TCEmigration;
				if (_TCEmigration > 1) {
					appendDiv(`<span class="red">${num(_TCEmigration)} millionaires</span> left your arcology.`);
				} else if (_TCEmigration > 0) {
					appendDiv(`<span class="red">One millionaire</span> left your arcology.`);
				}
			}
		}
		appendDiv(secExpImigrationBonus.text);
	}

	function slaveRetirement() {
		const el = new DocumentFragment();
		const r = [];
		/* Slave retirement trigger pulled (one time only)*/
		if (V.citizenRetirementTrigger === 1) {
			let _citizenRetirementImpact;
			if (V.customMenialRetirementAge >= 65) {
				_citizenRetirementImpact = 0.475 - Math.clamp(V.customMenialRetirementAge / 200, 0.325, 0.475);
			} else {
				_citizenRetirementImpact = 0.9 - Math.clamp(V.customMenialRetirementAge / 100, 0.2, 0.65);
			}
			if (V.arcologies[0].FSSupremacistLawME + V.arcologies[0].FSSubjugationistLawME > 0) {
				_citizenRetirementImpact *= 2 / 3;
			}
			V.lowerClass += Math.trunc((V.NPCSlaves + V.menials) * (0.05 + _citizenRetirementImpact));
			const _menialsRetirement = Math.trunc(V.menials * (0.05 + _citizenRetirementImpact));
			V.menials = Math.trunc(V.menials * (0.95 - _citizenRetirementImpact));
			const _ASlavesRetirement = Math.trunc(V.NPCSlaves * (0.05 + _citizenRetirementImpact));
			V.NPCSlaves = Math.trunc(V.NPCSlaves * (0.95 - _citizenRetirementImpact));
			V.citizenRetirementTrigger = 2;
			r.push(`You have enacted citizen retirement, the slaves of eligible age are granted freedom.`);
			if (_menialsRetirement > 1) {
				r.push(`<span class="red">${num(_menialsRetirement)} of your menial slaves</span> were retired.`);
			} else if (_menialsRetirement > 0) {
				r.push(`<span class="red">One of your menial slaves</span> was retired.`);
			}
			if (_ASlavesRetirement > 1) {
				r.push(`<span class="red">${num(_ASlavesRetirement)} slaves</span> in your arcology were given a citizen retirement.`);
			}
			/* I could bother with a single slave retirement message, but that's never going to get used*/
		}
		App.Events.addNode(el, r);
		return el;
	}

	function expiration() {
		const el = document.createElement("div");
		const r = [];
		/* Citizen expiration */
		let z = [];
		const _deathsLC = Math.trunc(V.lowerClass * _expirationLC);
		const _deathsMC = Math.trunc(V.middleClass * _expirationMC);
		const _deathsUC = Math.trunc(V.upperClass * _expirationUC);
		const _deathsTC = Math.trunc(V.topClass * _expirationTC);
		V.lowerClass -= _deathsLC;
		V.middleClass -= _deathsMC;
		V.upperClass -= _deathsUC;
		V.lowerClass -= _deathsTC;
		if (_deathsLC > 0) {
			z.push(numberWithPluralOne(_deathsLC, "lower class citizen"));
		}
		if (_deathsMC > 0) {
			z.push(numberWithPluralOne(_deathsMC, "middle class citizen"));
		}
		if (_deathsUC > 0) {
			z.push(numberWithPluralOne(_deathsUC, "upper class citizen"));
		}
		if (_deathsTC > 0) {
			z.push(numberWithPluralOne(_deathsTC, "millionaire"));
		}
		if (_deathsLC > 0 || _deathsMC > 0 || _deathsUC > 0 || _deathsTC > 0) {
			r.push(App.UI.DOM.makeElement("span", `${capFirstChar(toSentence(z))} passed away due to natural causes.`, "red"));
		}

		/* Slave expiration*/
		const _expirationPC = Math.trunc(V.menials * _expirationFS);
		const _expirationFD = Math.trunc(V.fuckdolls * _expirationFS);
		const _expirationBR = Math.trunc(V.menialBioreactors * _expirationFS);
		const _expirationNPC = Math.trunc(V.NPCSlaves * _expirationFS);
		const _expiration = _expirationPC + _expirationNPC + _expirationFD + _expirationBR;
		V.NPCSlaves -= _expirationNPC;
		V.menials -= _expirationPC;
		V.fuckdolls -= _expirationFD;
		V.menialBioreactors -= _expirationBR;
		if (_expiration > 0) {
			if (_expirationFS <= 0.5) {
				r.push(`<span class="red">${capFirstChar(numberWithPluralOne(_expiration, "slave"))} passed away</span> due to natural causes.`);
			} else {
				r.push(`<span class="red">${capFirstChar(numberWithPluralOne(_expiration, "slave"))} died</span> due to the tough working conditions in your arcology.`);
			}
			if (_expirationPC > 1) {
				r.push(`Of which <span class="red">${num(_expirationPC)} were yours.</span>`);
			} else if (_expirationPC > 0) {
				r.push(`<span class="red">One of them was yours.</span>`);
			}
		}

		App.Events.addNode(el, r);
		return el;
	}

	function denseApartments() {
		/* increases lowerclass attraction based on number of dense apartments */
		let el = new DocumentFragment();
		let r = [];
		let _count = 0;
		V.building.findCells(cell => !(cell instanceof App.Arcology.Cell.Penthouse))
			.forEach(cell => {
				if (cell instanceof App.Arcology.Cell.Apartment) {
					if (cell.type === 3) {
						_count += 1;
						_lowerClass += 40;
					}
				}
			});
		if (_count > 9) {
			r.push(App.UI.DOM.makeElement("span", `A great amount of lower class citizens`, "green"));
			r.push(` were attracted by the sectors filled with dense apartments.`);
		} else if (_count > 5) {
			r.push(App.UI.DOM.makeElement("span", `A large amount of lower class citizens`, "green"));
			r.push(` were attracted by your sprawling blocks of dense apartments.`);
		} else if (_count > 2) {
			r.push(App.UI.DOM.makeElement("span", `A moderate amount of lower class citizens`, "green"));
			r.push(` were attracted by your dense apartment complexes`);
		} else if (_count > 0) {
			r.push(App.UI.DOM.makeElement("span", `A small amount of lower class citizens`, "green"));
			r.push(` were attracted by your dense apartments.`);
		}
		App.Events.addNode(el, r);
		return el;
	}

	function getBanishRatio() {
		/* Some proportion of newly-enslaved citizens might instead be banished, if you don't keep old menials.
		 * This should probably use an actuarial age distribution instead of this piecewise function. */
		let _banishedRatio = 0.0;
		if (V.policies.retirement.menial2Citizen === 1) {
			if (V.customMenialRetirementAge >= 65) {
				_banishedRatio = 0.475 - Math.clamp(V.customMenialRetirementAge / 200, 0.325, 0.475);
			} else {
				_banishedRatio = 0.9 - Math.clamp(V.customMenialRetirementAge / 100, 0.2, 0.65);
			}
			if (V.arcologies[0].FSSupremacistLawME + V.arcologies[0].FSSubjugationistLawME > 0) {
				_banishedRatio *= 2 / 3;
			}
			_banishedRatio += 0.05; // not sure what the extra 5% is for...
		}
		return _banishedRatio;
	}

	function citizenToSlave() {
		/* Citizens turning into slaves, or being banished because they can't be */
		const _banished = Math.trunc((V.lowerClass * _welfareFS) * getBanishRatio());
		_enslaved = Math.trunc(V.lowerClass * _welfareFS) - _banished;
		V.lowerClass -= (_enslaved + _banished);
		if (_banished > 0) {
			appendDiv(`<span class="red">${_banished} citizens were banished</span> from your arcology; they committed enslavable offenses, but were too old to be enslaved.`);
		}
	}

	function appendDiv(text) {
		const div = document.createElement("div");
		$(div).append(text);
		el.append(div);
	}
};
