/**
 * These are variables that either should be made into temp vars or should be Zeroed out once done with them instead of here. This can also interfere with debugging or hide NaN's as zeroing things out would clear a NaN. Also could stop from NaN's getting worse?
 */
App.EndWeek.resetGlobals = function() {
	// Integer and float variables. No real need to zero them out but doesn't hurt to have them in a known state, though this might mask variables NaN'ing out. Takes up the least amount of Memory besides a "" string.
	V.i = 0;
	V.j = 0;
	V.averageProsperity = 0;
	V.motherSlave = -1;
	V.daughterSlave = -1;
	V.devMother = -1;
	V.devDaughter = -1;
	V.youngerSister = -1;
	V.olderSister = -1;

	// Other arrays
	V.events = [];
	V.RESSevent = [];
	V.RESSTRevent = [];
	V.RETSevent = [];
	V.RECIevent = [];
	V.RecETSevent = [];
	V.REFIevent = [];
	V.REFSevent = [];
	V.PESSevent = [];
	V.PETSevent = [];
	V.FSAcquisitionEvents = [];
	V.FSNonconformistEvents = [];
	V.REButtholeCheckinIDs = [];
	V.recruit = [];
	V.rebelSlaves = [];
	V.eligibleSlaves = [];

	// Slave Objects using 0 instead of null. Second most memory eaten up.
	V.activeSlave = 0;
	V.eventSlave = 0;
	V.subSlave = 0;
	V.relative = 0;
	V.relative2 = 0;

	// Strings Memory varies.
	V.buyer = "";
	V.desc = "";
	V.event = "";
	V.malefactor = "";
	// Done with zeroing out, what should be for the most part Temps
};
