App.Events.SEPitFight = class SEPitFight extends App.Events.BaseEvent {
	constructor(actors, params) {
		super(actors, params);
	}

	eventPrerequisites() {
		return [
			() => !!V.pit,
			() => !V.pit.fought,
		];
	}

	castActors() {
		const available = [...new Set(V.pit.fighterIDs)];

		if (V.pit.slaveFightingBodyguard) {	// slave is fighting bodyguard for their life
			this.actors.push(S.Bodyguard.ID, V.pit.slaveFightingBodyguard);
		} else {
			if (available.length > 0) {
				// first fighter
				if (S.Bodyguard && V.pit.bodyguardFights) {
					available.delete(S.Bodyguard.ID);
					this.actors.push(S.Bodyguard.ID);
				} else {
					this.actors.push(available.pluck());
				}

				// second fighter
				if (!V.pit.animal) {
					if (available.length > 0) {
						this.actors.push(available.pluck());
					} else {
						return false; // couldn't cast second fighter
					}
				}
			}
		}

		return this.actors.length > 0;
	}

	execute(node) {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event";
		V.returnTo = "Scheduled Event";

		V.pit.fought = true;

		node.appendChild(V.pit.lethal ?
			App.Facilities.Pit.lethalFight(this.actors) :
			App.Facilities.Pit.nonlethalFight(this.actors)
		);
	}
};
