/** The base animal class. */
App.Entity.Animal = class {
	/**
	 * @param {string} name
	 * @param {string} species
	 * @param {'canine'|'hooved'|'feline'} type
	 * @param {'domestic'|'exotic'} rarity
	 */
	constructor(name, species, type, rarity) {
		this.name = name;
		this.species = species;
		this.type = type;
		this.rarity = rarity;
		this.articleAn = 'a';
		this.dick = {
			/** Corresponds directly to the sizes in SlaveState. */
			size: this.species === 'cat' ? 2 : 4,
			desc: this.species === 'cat' ? 'little' : 'large',
		};
		this.deadliness = this.type === 'feline' ? this.species === 'cat' ? 1 : 4 : 3;
	}

	/** @returns {boolean} */
	get purchased() {
		return V[this.type].includes(this.name);
	}

	/** @returns {boolean} */
	get isActive() {
		return V.active[this.type].name === this.name;
	}

	/** @type {function():this} */
	purchase() {
		V[this.type].push(this.name);

		return this;
	}

	/** @param {string} name */
	setName(name) {
		this.name = name;

		return this;
	}

	/** @param {string} species */
	setSpecies(species) {
		this.species = species;

		return this;
	}

	/** @param {'canine'|'hooved'|'feline'} type */
	setType(type) {
		this.type = type;

		return this;
	}

	/** @param {'domestic'|'exotic'} rarity */
	setRarity(rarity) {
		this.rarity = rarity;

		return this;
	}

	/** @type {function():this} */
	setActive() {
		V.active[this.type] = this;

		return this;
	}

	/** @param {'a'|'an'} setter */
	setArticle(setter) {
		this.articleAn = setter;

		return this;
	}

	/**
	 * @param {number} size
	 * @param {string} desc
	 */
	setDick(size = 2, desc = null) {
		this.dick.size = size;
		this.dick.desc = desc;

		return this;
	}

	/** @param {number} setter */
	setDeadliness(setter) {
		this.deadliness = setter;

		return this;
	}
};

App.Facilities.Farmyard.animals = function() {
	App.Facilities.Farmyard.animals.init();

	const frag = new DocumentFragment();

	const domesticDiv = App.UI.DOM.appendNewElement("div", frag, '', 'farmyard-domestic');
	const exoticDiv = App.UI.DOM.appendNewElement("div", frag, '', 'farmyard-exotic');

	const hrMargin = '0';

	const canine = 'canine';
	const hooved = 'hooved';
	const feline = 'feline';
	const exotic = 'exotic';
	const domestic = 'domestic';

	V.nextButton = "Back";
	V.nextLink = "Farmyard";
	V.returnTo = "Farmyard Animals";
	V.encyclopedia = "Farmyard";

	App.UI.DOM.appendNewElement("span", domesticDiv, 'Domestic Animals', 'farmyard-heading');

	if (V.farmyardKennels > 1 || V.farmyardStables > 1 || V.farmyardCages > 1) {
		App.UI.DOM.appendNewElement("span", exoticDiv, 'Exotic Animals', 'farmyard-heading');
	}

	if (V.farmyardKennels) {
		domesticDiv.append(domesticCanines());
	}

	if (V.farmyardStables) {
		domesticDiv.append(domesticHooved());
	}

	if (V.farmyardCages) {
		domesticDiv.append(domesticFelines());
	}

	if (V.farmyardKennels > 1) {
		exoticDiv.append(exoticCanines());
	}

	if (V.farmyardStables > 1) {
		exoticDiv.append(exoticHooved());
	}

	if (V.farmyardCages > 1) {
		exoticDiv.append(exoticFelines());
	}

	if (V.debugMode || V.cheatMode) {
		frag.appendChild(addAnimal());
	}

	return frag;



	// Domestic Animals

	function domesticCanines() {
		const canineDiv = App.UI.DOM.makeElement("div", '', 'farmyard-animals');
		const hr = document.createElement("hr");

		hr.style.margin = hrMargin;

		App.UI.DOM.appendNewElement("span", canineDiv, 'Dogs', 'farmyard-animal-type');

		canineDiv.append(hr, animalList(canine, domestic, 5000, canine));

		return canineDiv;
	}

	function domesticHooved() {
		const hoovedDiv = App.UI.DOM.makeElement("div", '', 'farmyard-animals');
		const hr = document.createElement("hr");

		hr.style.margin = hrMargin;

		App.UI.DOM.appendNewElement("span", hoovedDiv, 'Hooved Animals', 'farmyard-animal-type');

		hoovedDiv.append(hr, animalList(hooved, domestic, 20000, hooved));

		return hoovedDiv;
	}

	function domesticFelines() {
		const felineDiv = App.UI.DOM.makeElement("div", '', 'farmyard-animals');
		const hr = document.createElement("hr");

		hr.style.margin = hrMargin;

		App.UI.DOM.appendNewElement("span", felineDiv, 'Cats', 'farmyard-animal-type');

		felineDiv.append(hr, animalList(feline, domestic, 1000, feline));

		return felineDiv;
	}



	// Exotic Animals

	function exoticCanines() {
		const canineDiv = App.UI.DOM.makeElement("div", '', 'farmyard-animals');
		const hr = document.createElement("hr");

		hr.style.margin = hrMargin;

		App.UI.DOM.appendNewElement("span", canineDiv, 'Canines', 'farmyard-animal-type');

		canineDiv.append(hr, animalList(canine, exotic, 50000, canine));

		return canineDiv;
	}

	function exoticHooved() {
		const hoovedDiv = App.UI.DOM.makeElement("div", '', 'farmyard-animals');
		const hr = document.createElement("hr");

		hr.style.margin = hrMargin;

		App.UI.DOM.appendNewElement("span", hoovedDiv, 'Hooved Animals', 'farmyard-animal-type');

		hoovedDiv.append(hr, animalList(hooved, exotic, 75000, hooved));

		return hoovedDiv;
	}

	function exoticFelines() {
		const felineDiv = App.UI.DOM.makeElement("div", '', 'farmyard-animals');
		const hr = document.createElement("hr");

		hr.style.margin = hrMargin;

		App.UI.DOM.appendNewElement("span", felineDiv, 'Felines', 'farmyard-animal-type');

		felineDiv.append(hr, animalList(feline, exotic, 100000, feline));

		return felineDiv;
	}



	// Helper Functions

	/**
	 * Creates either a link or note text depending on parameters given
	 * @param {object} param
	 * @param {App.Entity.Animal} param.animal
	 * @param {string} param.active
	 * @param {string} param.type
	 * @param {number} param.price
	 * @param {function():void} param.setActiveHandler
	 * @param {function():void} param.purchaseHandler
	 * @returns {string|HTMLElement}
	 */
	function animalLink({animal, active, type, price, setActiveHandler, purchaseHandler}) {
		if (animal.purchased) {
			if (V.active[active] && V.active[active].name === animal.name) {
				return App.UI.DOM.makeElement("span", `Set as active ${type}`, "note");
			} else {
				return App.UI.DOM.link(`Set as active ${type}`, setActiveHandler);
			}
		} else {
			return App.UI.DOM.link(`Purchase for ${cashFormat(price)}`, purchaseHandler);
		}
	}

	/**
	 * Creates a list of the specified animal type from the main animal array.
	 * @param {"canine"|"hooved"|"feline"} type One of 'canine', 'hooved', or 'feline', also used determine the active animal type.
	 * @param {string} rarity One of domestic or exotic.
	 * @param {number} price
	 * @param {string} active The name of the current active animal of the given type.
	 * @returns {HTMLDivElement}
	 */
	function animalList(type, rarity, price, active) {
		const mainDiv = document.createElement("div");
		let filteredArray = App.Data.animals.filter(animal => animal.rarity === rarity && animal.type === type);

		for (const i in filteredArray) {
			const animalDiv = document.createElement("div");
			const optionSpan = document.createElement("span");

			const args = {
				animal: filteredArray[i],
				active: active,
				type: type,
				price: price,
				setActiveHandler() {
					filteredArray[i].setActive();
					App.UI.DOM.replace(mainDiv, animalList(type, rarity, price, active));
				},
				purchaseHandler() {
					cashX(forceNeg(price), "farmyard");
					filteredArray[i].purchase();
					App.UI.DOM.replace(mainDiv, animalList(type, rarity, price, active));
				}
			};

			optionSpan.append(animalLink(args));

			animalDiv.append(capFirstChar(filteredArray[i].name), ' ', optionSpan);

			mainDiv.appendChild(animalDiv);
		}

		// filteredArray = [];

		return mainDiv;
	}

	function addAnimal() {
		const addAnimalDiv = document.createElement("div");
		const dickDiv = document.createElement("div");
		const deadlinessDiv = document.createElement("div");
		const addDiv = App.UI.DOM.makeElement("div", null, ['animal-add']);

		const animal = new App.Entity.Animal(null, null, "canine", "domestic");

		App.UI.DOM.appendNewElement("div", addAnimalDiv, `Add a New Animal`, ['farmyard-heading']);

		addAnimalDiv.append(
			name(),
			species(),
			type(),
			rarity(),
			article(),
			dick(),
			deadliness(),
			add(),
		);

		return addAnimalDiv;

		function name() {
			const nameDiv = document.createElement("div");

			nameDiv.append(
				`Name: `,
				App.UI.DOM.makeTextBox(animal.name || '', value => {
					animal.setName(value);

					App.UI.DOM.replace(nameDiv, name);
					App.UI.DOM.replace(dickDiv, dick);
					App.UI.DOM.replace(deadlinessDiv, deadliness);
					App.UI.DOM.replace(addDiv, add);
				}),
			);

			return nameDiv;
		}

		function species() {
			const speciesDiv = document.createElement("div");

			speciesDiv.append(
				`Species: `,
				App.UI.DOM.makeTextBox(animal.species || '', value => {
					animal.setSpecies(value);

					App.UI.DOM.replace(speciesDiv, species);
					App.UI.DOM.replace(addDiv, add);
				}),
			);

			return speciesDiv;
		}

		function type() {
			const typeDiv = document.createElement("div");

			const typeLinks = [];

			if (animal.type === "canine") {
				typeLinks.push(
					App.UI.DOM.disabledLink(`Canine`, [`Already selected.`]),
					App.UI.DOM.link(`Hooved`, () => {
						animal.setType('hooved');

						App.UI.DOM.replace(typeDiv, type);
					}),
					App.UI.DOM.link(`Feline`, () => {
						animal.setType("feline");

						App.UI.DOM.replace(typeDiv, type);
					}),
				);
			} else if (animal.type === "hooved") {
				typeLinks.push(
					App.UI.DOM.link(`Canine`, () => {
						animal.setType("canine");

						App.UI.DOM.replace(typeDiv, type);
					}),
					App.UI.DOM.disabledLink(`Hooved`, [`Already selected.`]),
					App.UI.DOM.link(`Feline`, () => {
						animal.setType("feline");

						App.UI.DOM.replace(typeDiv, type);
					}),
				);
			} else {
				typeLinks.push(
					App.UI.DOM.link(`Canine`, () => {
						animal.setType("canine");

						App.UI.DOM.replace(typeDiv, type);
					}),
					App.UI.DOM.link(`Hooved`, () => {
						animal.setType("hooved");

						App.UI.DOM.replace(typeDiv, type);
					}),
					App.UI.DOM.disabledLink(`Feline`, [`Already selected.`]),
				);
			}

			typeDiv.append(`Type: `, App.UI.DOM.generateLinksStrip(typeLinks));

			return typeDiv;
		}

		function rarity() {
			const rarityDiv = document.createElement("div");

			const rarityLinks = [];

			if (animal.rarity === "domestic") {
				rarityLinks.push(
					App.UI.DOM.disabledLink(`Domestic`, [`Already selected.`]),
					App.UI.DOM.link(`Exotic`, () => {
						animal.setRarity('exotic');

						App.UI.DOM.replace(rarityDiv, rarity);
					}),
				);
			} else {
				rarityLinks.push(
					App.UI.DOM.link(`Domestic`, () => {
						animal.setRarity('domestic');

						App.UI.DOM.replace(rarityDiv, rarity);
					}),
					App.UI.DOM.disabledLink(`Exotic`, [`Already selected.`]),
				);
			}

			rarityDiv.append(`Rarity: `, App.UI.DOM.generateLinksStrip(rarityLinks));

			return rarityDiv;
		}

		function article() {
			const articleDiv = document.createElement("div");

			const articleLinks = [];

			if (animal.articleAn === 'a') {
				articleLinks.push(
					App.UI.DOM.link("Yes", () => {
						animal.articleAn = 'an';

						App.UI.DOM.replace(articleDiv, article);
						App.UI.DOM.replace(dickDiv, dick);
						App.UI.DOM.replace(deadlinessDiv, deadliness);
					}),
					App.UI.DOM.disabledLink("No", [`Already selected.`]),
				);
			} else {
				articleLinks.push(
					App.UI.DOM.disabledLink("Yes", [`Already selected.`]),
					App.UI.DOM.link("No", () => {
						animal.articleAn = 'a';

						App.UI.DOM.replace(articleDiv, article);
						App.UI.DOM.replace(dickDiv, dick);
						App.UI.DOM.replace(deadlinessDiv, deadliness);
					}),
				);
			}

			articleDiv.append(`Is this animal's name preceded by an 'an'? `, App.UI.DOM.generateLinksStrip(articleLinks));

			return articleDiv;
		}

		function dick() {
			dickDiv.append(dickSize(), dickDesc());

			return dickDiv;

			function dickSize() {
				const dickSizeDiv = document.createElement("div");

				dickSizeDiv.append(
					`How large is ${animal.name ? `${animal.articleAn} male ${animal.name}` : `a male`}'s penis? `,
					App.UI.DOM.makeTextBox(animal.dick.size || 2, value => {
						animal.setDick(value, animal.dick.desc || null);

						App.UI.DOM.replace(dickSizeDiv, dickSize);
					}, true),
					App.UI.DOM.makeElement("span", `1 is smallest, and default is 2. `, ['note']),
				);

				return dickSizeDiv;
			}

			function dickDesc() {
				const dickDescDiv = document.createElement("div");

				dickDescDiv.append(
					`What does it look like? `,
					App.UI.DOM.makeTextBox(animal.dick.desc || '', value => {
						animal.setDick(animal.dick.size || 2, value);

						App.UI.DOM.replace(dickDescDiv, dickDesc);
					}),
					App.UI.DOM.makeElement("span", `Default is 'large'. `, ['note']),
				);

				return dickDescDiv;
			}
		}

		function deadliness() {
			deadlinessDiv.append(
				`How deadly is ${animal.name ? `${animal.articleAn} ${animal.name}` : `the animal`}? `,
				App.UI.DOM.makeTextBox(5, value => {
					animal.setDick(value);
				}, true),
				App.UI.DOM.makeElement("span", `Default is 5. `, ['note']),
			);

			return deadlinessDiv;
		}

		function add() {
			const disabledReasons = [];

			let link;

			if (!animal.name) {
				disabledReasons.push(`Animal must have a name.`);
			}

			if (!animal.species) {
				disabledReasons.push(`Animal must have a species.`);
			}

			if (disabledReasons.length > 0) {
				link = App.UI.DOM.disabledLink(`Add`, disabledReasons);
			} else {
				link = App.UI.DOM.link(`Add`, () => {
					App.Data.animals.push(animal);

					App.UI.DOM.replace(addAnimalDiv, addAnimal);
				});
			}

			addDiv.appendChild(link);

			return addDiv;
		}
	}
};

App.Facilities.Farmyard.animals.init = function() {
	if (App.Data.animals.length === 0) {
		class Animal extends App.Entity.Animal {}

		const dog = 'dog';
		const cat = 'cat';
		const canine = 'canine';
		const hooved = 'hooved';
		const feline = 'feline';
		const domestic = 'domestic';
		const exotic = 'exotic';
		const an = 'an';

		/** @type {Animal[]} */
		App.Data.animals = [
			new Animal("beagle", dog, canine, domestic)
				.setDeadliness(2),
			new Animal("bulldog", dog, canine, domestic),
			new Animal("French bulldog", dog, canine, domestic)
				.setDeadliness(2),
			new Animal("German shepherd", dog, canine, domestic),
			new Animal("golden retriever", dog, canine, domestic),
			new Animal("labrador retriever", dog, canine, domestic),
			new Animal("poodle", dog, canine, domestic)
				.setDeadliness(2),
			new Animal("rottweiler", dog, canine, domestic),
			new Animal("Siberian husky", dog, canine, domestic),
			new Animal("Yorkshire terrier", dog, canine, domestic)
				.setDeadliness(2),

			new Animal("dingo", "dingo", canine, exotic),
			new Animal("fox", "fox", canine, exotic),
			new Animal("jackal", "jackal", canine, exotic),
			new Animal("wolf", "wolf", canine, exotic)
				.setDeadliness(4),

			new Animal("bull", "bull", hooved, domestic)
				.setDick(5, 'huge'),
			new Animal("horse", "horse", hooved, domestic)
				.setDick(5, 'huge'),
			new Animal("pig", "pig", hooved, domestic),

			new Animal("zebra", "zebra", hooved, exotic)
				.setDick(5, 'huge'),
			new Animal("elephant", "elephant", hooved, exotic)
				.setArticle(an)
				.setDick(6, 'enormous'),	// not exactly true to life, but more interesting

			new Animal("Abbysinian", cat, feline, domestic)
				.setArticle(an),
			new Animal("Bengal", cat, feline, domestic),
			new Animal("Birman", cat, feline, domestic),
			new Animal("Maine coon", cat, feline, domestic),
			new Animal("Oriental shorthair", cat, feline, domestic)
				.setArticle(an),
			new Animal("Persian", cat, feline, domestic),
			new Animal("Ragdoll", cat, feline, domestic),
			new Animal("Russian blue", cat, feline, domestic),
			new Animal("Siamese", cat, feline, domestic),
			new Animal("Sphynx", cat, feline, domestic),

			new Animal("cougar", "cougar", feline, exotic),
			new Animal("jaguar", "jaguar", feline, exotic),
			new Animal("leopard", "leopard", feline, exotic),
			new Animal("lion", "lion", feline, exotic),
			new Animal("lynx", "lynx", feline, exotic),
			new Animal("puma", "puma", feline, exotic),
			new Animal("tiger", "tiger", feline, exotic),
		];
	}
};

/** @type {App.Entity.Animal[]} */
App.Data.animals = App.Data.animals || [];
