App.Facilities.Pit.pit = function() {
	const frag = new DocumentFragment();

	const introDiv = document.createElement("div");
	const lethalityDiv = document.createElement("div");

	V.nextButton = "Back to Main";
	V.nextLink = "Main";
	V.returnTo = "Pit";
	V.encyclopedia = "Pit";

	frag.append(intro(), audience());

	if (V.pit.slaveFightingBodyguard) {
		frag.appendChild(scheduled());
	} else {
		frag.append(fighters(), lethality());

		App.UI.DOM.appendNewElement("div", frag,
			App.UI.SlaveList.listSJFacilitySlaves(App.Entity.facilities.pit, passage(), false,
				{assign: "Select a slave to fight", remove: "Cancel a slave's fight", transfer: null}),
			"pit-assign");
	}

	frag.appendChild(App.Facilities.rename(App.Entity.facilities.pit, () => {
		App.UI.DOM.replace(introDiv, intro);
	}));

	return frag;

	function intro() {
		introDiv.classList.add("pit-intro");

		const desc = App.UI.DOM.appendNewElement("div", introDiv, `${capFirstChar(V.pit.name)} is clean and ready, `);
		const link = App.UI.DOM.makeElement("div", null, "indent");
		const note = App.UI.DOM.makeElement("div", `${properTitle()}, slaves assigned here can continue their usual duties.`, "note");

		const count = App.Entity.facilities.pit.totalEmployeesCount;

		if (count > 2) {
			desc.append(`with a pool of slaves assigned to fight in the next week's bout. `);
		} else if (count === 1) {
			desc.append(`but only one slave is assigned to the week's bout. `);
		} else if (count > 0) {
			desc.append(`with slaves assigned to the week's bout. `);
		} else {
			desc.append(`but no slaves are assigned to fight. `);
		}

		link.append(App.UI.DOM.passageLink(`Decommission ${V.pit.name}`, "Main", () => {
			V.pit = null;

			App.Arcology.cellUpgrade(V.building, App.Arcology.Cell.Market, "Pit", "Markets");
		}));

		desc.append(link, note);
		introDiv.appendChild(desc);

		return introDiv;
	}

	function audience() {
		const audienceDiv = document.createElement("div");
		const linkSpan = document.createElement("span");

		const links = [];

		if (V.pit.audience === "none") {
			audienceDiv.append(`Fights here are strictly private. `);

			links.push(
				App.UI.DOM.link("Open them for free", () => {
					V.pit.audience = "free";

					App.UI.DOM.replace(audienceDiv, audience);
				}),
				App.UI.DOM.link("Open them and charge admission", () => {
					V.pit.audience = "paid";

					App.UI.DOM.replace(audienceDiv, audience);
				})
			);
		} else if (V.pit.audience === "free") {
			audienceDiv.append(`Fights here are free and open to the public. `);

			links.push(
				App.UI.DOM.link("Close them", () => {
					V.pit.audience = "none";

					App.UI.DOM.replace(audienceDiv, audience);
				}),
				App.UI.DOM.link("Charge admission", () => {
					V.pit.audience = "paid";

					App.UI.DOM.replace(audienceDiv, audience);
				})
			);
		} else {
			audienceDiv.append(`Admission is charged to the fights here. `);

			links.push(
				App.UI.DOM.link("Close them", () => {
					V.pit.audience = "none";

					App.UI.DOM.replace(audienceDiv, audience);
				}),
				App.UI.DOM.link("Stop charging admission", () => {
					V.pit.audience = "free";

					App.UI.DOM.replace(audienceDiv, audience);
				})
			);
		}

		linkSpan.append(App.UI.DOM.generateLinksStrip(links));
		audienceDiv.appendChild(linkSpan);

		return audienceDiv;
	}

	function fighters() {
		const fightersDiv = document.createElement("div");
		const animalDiv = document.createElement("div");
		const linkSpan = document.createElement("span");

		const links = [];

		if (S.Bodyguard || V.active.canine || V.active.hooved || V.active.feline) {
			if (V.pit.bodyguardFights) {
				fightersDiv.append(`Your bodyguard ${S.Bodyguard.slaveName} will fight a slave selected from the pool at random. `);

				links.push(App.UI.DOM.link("Make both slots random", () => {
					V.pit.bodyguardFights = false;
					V.pit.animal = null;

					if (V.pit.fighterIDs.includes(V.BodyguardID)) {
						V.pit.fighterIDs.delete(V.BodyguardID);
					}

					App.UI.DOM.replace(fightersDiv, fighters);
					App.UI.DOM.replace(lethalityDiv, lethality);
				}));

				if (V.active.canine || V.active.hooved || V.active.feline) {
					links.push(App.UI.DOM.link("Have a slave fight an animal", () => {
						V.pit.bodyguardFights = false;
						V.pit.animal = V.active.canine || V.active.hooved || V.active.feline;

						if (V.pit.fighterIDs.includes(V.BodyguardID)) {
							V.pit.fighterIDs.delete(V.BodyguardID);
						}

						App.UI.DOM.replace(fightersDiv, fighters);
						App.UI.DOM.replace(lethalityDiv, lethality);
					}));
				}
			} else {
				if (V.pit.animal) {
					fightersDiv.append(`A random slave will fight an animal. `);

					links.push(
						App.UI.DOM.link("Have them fight another slave", () => {
							V.pit.bodyguardFights = false;
							V.pit.animal = null;

							App.UI.DOM.replace(fightersDiv, fighters);
							App.UI.DOM.replace(lethalityDiv, lethality);
						}));

					if (S.Bodyguard) {
						App.UI.DOM.link("Have them fight your bodyguard", () => {
							V.pit.bodyguardFights = true;
							V.pit.animal = null;

							App.UI.DOM.replace(fightersDiv, fighters);
							App.UI.DOM.replace(lethalityDiv, lethality);
						});
					}

					animalDiv.appendChild(App.Facilities.Pit.animals());
				} else {
					fightersDiv.append(`Two fighters will be selected from the pool at random. `);

					if (S.Bodyguard) {
						links.push(
							App.UI.DOM.link("Guarantee your bodyguard a slot", () => {
								V.pit.bodyguardFights = true;
								V.pit.animal = null;

								App.UI.DOM.replace(fightersDiv, fighters);
								App.UI.DOM.replace(lethalityDiv, lethality);
							})
						);
					}

					if (V.active.canine || V.active.hooved || V.active.feline) {
						links.push(
							App.UI.DOM.link("Have a slave fight an animal", () => {
								V.pit.bodyguardFights = false;
								V.pit.animal = V.active.canine || V.active.hooved || V.active.feline;

								App.UI.DOM.replace(fightersDiv, fighters);
								App.UI.DOM.replace(lethalityDiv, lethality);
							})
						);
					}
				}
			}
		} else {
			fightersDiv.append(`Two fighters will be selected from the pool at random. `);
		}

		linkSpan.append(App.UI.DOM.generateLinksStrip(links));
		fightersDiv.append(linkSpan);

		if (V.pit.animal) {
			fightersDiv.appendChild(animalDiv);
		}

		return fightersDiv;
	}

	function lethality() {
		const linkSpan = document.createElement("span");

		if (V.pit.lethal) {
			if (V.pit.animal) {
				lethalityDiv.append(`The fighter will be armed with a sword and will fight to the death. `);

				linkSpan.append(
					App.UI.DOM.link("Nonlethal", () => {
						V.pit.lethal = false;

						App.UI.DOM.replace(lethalityDiv, lethality);
					})
				);
			} else {
				lethalityDiv.append(`Fighters will be armed with swords, and fights will be to the death. `);

				linkSpan.append(
					App.UI.DOM.link("Nonlethal", () => {
						V.pit.lethal = false;

						App.UI.DOM.replace(lethalityDiv, lethality);
					})
				);
			}
		} else {
			if (V.pit.animal) {
				lethalityDiv.append(`The slave will be restrained and will try to avoid becoming the animal's plaything. `);

				linkSpan.append(
					App.UI.DOM.link("Lethal", () => {
						V.pit.lethal = true;

						App.UI.DOM.replace(lethalityDiv, lethality);
					})
				);
			} else {
				lethalityDiv.append(`Fighters will use their fists and feet, and fights will be to submission. `);

				linkSpan.append(
					App.UI.DOM.link("Lethal", () => {
						V.pit.lethal = true;

						App.UI.DOM.replace(lethalityDiv, lethality);
					})
				);
			}
		}

		lethalityDiv.appendChild(linkSpan);

		if (!V.pit.lethal && !V.pit.animal) {
			lethalityDiv.appendChild(virginities());
		}

		return lethalityDiv;

		function virginities() {
			const virginitiesDiv = document.createElement("div");
			const boldSpan = App.UI.DOM.makeElement("span", null, "bold");
			const linkSpan = document.createElement("span");

			const links = [];

			if (!V.pit.animal) {
				if (V.pit.virginities === "neither") {
					boldSpan.append(`No`);
					virginitiesDiv.append(boldSpan, ` virginities of the loser will be respected. `);

					links.push(
						App.UI.DOM.link("Vaginal", () => {
							V.pit.virginities = "vaginal";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("Anal", () => {
							V.pit.virginities = "anal";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("All", () => {
							V.pit.virginities = "all";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						})
					);
				} else if (V.pit.virginities === "vaginal") {
					boldSpan.append(`Vaginal`);
					virginitiesDiv.append(boldSpan, ` virginity of the loser will be respected. `);

					links.push(
						App.UI.DOM.link("Neither", () => {
							V.pit.virginities = "neither";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("Anal", () => {
							V.pit.virginities = "anal";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("All", () => {
							V.pit.virginities = "all";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						})
					);
				} else if (V.pit.virginities === "anal") {
					boldSpan.append(`Anal`);
					virginitiesDiv.append(boldSpan, ` virginity of the loser will be respected. `);

					links.push(
						App.UI.DOM.link("Neither", () => {
							V.pit.virginities = "neither";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("Vaginal", () => {
							V.pit.virginities = "vaginal";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("All", () => {
							V.pit.virginities = "all";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						})
					);
				} else {
					boldSpan.append(`All`);
					virginitiesDiv.append(boldSpan, ` virginities of the loser will be respected. `);

					links.push(
						App.UI.DOM.link("Neither", () => {
							V.pit.virginities = "neither";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("Vaginal", () => {
							V.pit.virginities = "vaginal";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						}),
						App.UI.DOM.link("Anal", () => {
							V.pit.virginities = "anal";

							App.UI.DOM.replace(virginitiesDiv, virginities);
						})
					);
				}
			}

			linkSpan.append(App.UI.DOM.generateLinksStrip(links));
			virginitiesDiv.appendChild(linkSpan);

			return virginitiesDiv;
		}
	}

	function scheduled() {
		const scheduledDiv = document.createElement("div");
		const linkSpan = document.createElement("span");

		scheduledDiv.append(`You have scheduled ${getSlave(V.pit.slaveFightingBodyguard).slaveName} to fight your bodyguard to the death this week. `, linkSpan);

		linkSpan.append(App.UI.DOM.link("Cancel it", () => {
			V.pit.slaveFightingBodyguard = null;

			App.UI.DOM.replace(scheduledDiv, scheduled);
		}));

		scheduledDiv.appendChild(linkSpan);

		return scheduledDiv;
	}
};

App.Facilities.Pit.init = function() {
	/** @type {FC.Facilities.Pit} */
	V.pit = {
		name: "the Pit",

		animal: null,
		audience: "free",
		bodyguardFights: false,
		fighterIDs: [],
		fought: false,
		lethal: false,
		slaveFightingBodyguard: null,
		virginities: "neither",
	};
};
