/**
 * @param {App.Entity.SlaveState} mother
 * @param {boolean} cheat
 * @returns {DocumentFragment}
 */
globalThis.analyzePregnancies = function(mother, cheat) {
	const el = new DocumentFragment();
	for (let i = 0; i < mother.womb.length; i++) {
		el.append(scanFetus(i));
		App.UI.DOM.appendNewElement("hr", el);
	}
	return el;

	function scanFetus(i) {
		const el = new DocumentFragment();
		const fetus = mother.womb[i];
		const genes = fetus.genetics;
		let option;
		const options = new App.UI.OptionsGroup();
		if (fetus.age >= 2) {
			option = options.addOption(`Ova: ${genes.name}`, "name", genes);
			if (cheat) {
				option.showTextBox();
			}
			option = options.addOption(`Age: ${Math.trunc(fetus.age * 1000) / 1000}`, "age", fetus);
			if (cheat) {
				option.showTextBox();
			}
			if (V.geneticMappingUpgrade >= 1) {
				option = options.addOption(`Gender: ${genes.gender}`, "gender", genes);
				if (cheat) {
					option.addValue("Female", "XX");
					option.addValue("Male", "XY");
				}
				option = options.addOption(`Father name: ${(genes.fatherName) ? genes.fatherName : `name not registered`}; ID: ${genes.father}`, "father", genes);
				if (cheat) {
					option.showTextBox();
				}
				option = options.addOption(`Mother name: ${(genes.motherName) ? genes.motherName : `name not registered`}; ID: ${genes.mother}`, "mother", genes);
				if (cheat) {
					option.showTextBox();
				}
				option = options.addOption(`Nationality: ${genes.nationality}`, "nationality", genes);
				if (cheat) {
					option.showTextBox();
				}
				if (V.seeRace === 1) {
					option = options.addOption(`Race: ${capFirstChar(genes.race)}`, "race", genes);
					if (cheat) {
						option.showTextBox().pulldown().addValueList(Array.from(App.Data.misc.filterRaces, (k => [k[1], k[0]])));
					}
				}
				option = options.addOption(`Skin tone: ${capFirstChar(genes.skin)}`, "skin", genes);
				if (cheat) {
					option.showTextBox().pulldown().addValueList(App.Medicine.Modification.naturalSkins);
				}
				option = options.addOption(`Intelligence index: ${genes.intelligence} out of 100`, "intelligence", genes);
				if (cheat) {
					option.showTextBox();
				}
				option = options.addOption(`Face index: ${genes.face} out of 100`, "face", genes);
				if (cheat) {
					option.showTextBox();
				}
				option = options.addOption(`Eye Color: ${capFirstChar(genes.eyeColor)}`, "eyeColor", genes);
				if (cheat) {
					option.showTextBox().pulldown();
					for (const color of App.Medicine.Modification.eyeColor.map(color => color.value)) {
						option.addValue(capFirstChar(color), color);
					}
				}
				option = options.addOption(`Hair Color: ${capFirstChar(genes.hColor)}`, "hColor", genes);
				if (cheat) {
					option.showTextBox().pulldown();
					for (const color of App.Medicine.Modification.Color.Primary.map(color => color.value)) {
						option.addValue(capFirstChar(color), color);
					}
				}
				option = options.addOption(`Pubic hair: ${capFirstChar(genes.pubicHStyle)}`, "pubicHStyle", genes);
				if (cheat) {
					option.showTextBox().pulldown()
						.addValue("hairless")
						.addValue("hair");
				}
				option = options.addOption(`Armpit hair: ${capFirstChar(genes.underArmHStyle)}`, "underArmHStyle", genes);
				if (cheat) {
					option.showTextBox().pulldown()
						.addValue("hairless")
						.addValue("hair");
				}
				if (genes.markings === "freckles" || genes.markings === "heavily freckled") {
					option = options.addOption(`Markings: ${capFirstChar(genes.markings)}`, "markings", genes);
					if (cheat) {
						option.addValueList([
							["None", "none"],
							["Freckles", "freckles"],
							["Heavily freckled", "heavily freckled"],
							["Beauty mark", "beauty mark"],
							["Birthmark", "birthmark"],
						]);
					}
				}
				if (cheat) {
					const geneQuirks = App.UI.DOM.appendNewElement("div", el, App.UI.DOM.link(
						"Show Genetic Quirks",
						() => jQuery(geneQuirks).empty().append(App.UI.SlaveInteract.geneticQuirks(genes, true))
					));
				} else {
					el.append(fetusAbnormalities());
				}
			} else {
				if (fetus.age > 13) {
					App.UI.DOM.appendNewElement("div", el, `Gender: ${genes.gender}`);
				}
				if (fetus.age > 5) {
					App.UI.DOM.appendNewElement("div", el, `Father ID: ${genes.father}`);
					App.UI.DOM.appendNewElement("div", el, `Father Name: ${genes.fatherName}`);
					App.UI.DOM.appendNewElement("div", el, `Mother ID: ${genes.mother}`);
					App.UI.DOM.appendNewElement("div", el, `Mother Name: ${genes.motherName}`);
				}
			}
			if (V.incubator.capacity > 0 || V.nursery > 0) {
				App.UI.DOM.appendNewElement("div", el, `Reserved: ${fetus.reserve}`);
			}

			if (fetus.age < 4 && (V.arcologies[0].FSRestart === "unset" || V.eugenicsFullControl === 1 || mother.breedingMark === 0 || V.propOutcome === 0 || (fetus.fatherID !== -1 && fetus.fatherID !== -6))) {
				option = terminateOvum();
				if (V.surgeryUpgrade === 1) {
					option.addButton(
						"Transplant ovum",
						() => {
							V.donatrix = mother;
							V.wombIndex = i;
							V.nextLink = passage();
						},
						"Ova Transplant Workaround"
					);
				}
			}
			if (V.incubator.capacity > 0) {
				if (fetus.reserve === "incubator") {
					App.UI.DOM.appendNewElement("div", el, App.UI.DOM.link(
						`Don't keep this child in ${V.incubator.name}`,
						() => {
							fetus.reserve = "";
						},
						[],
						passage()
					));
				} else if ((V.incubator.capacity - V.incubator.tanks.length) - FetusGlobalReserveCount("incubator") > 0) {
					App.UI.DOM.appendNewElement("div", el, App.UI.DOM.link(
						`Keep this child in ${V.incubator.name}`,
						() => {
							fetus.reserve = "incubator";
						},
						[],
						passage()
					));
				} else {
					App.UI.DOM.appendNewElement("div", el, `There is not enough free space to keep this child in ${V.incubator.name}.`);
				}
			}
			if (V.nursery > 0) {
				if (fetus.reserve === "nursery") {
					App.UI.DOM.appendNewElement("div", el, App.UI.DOM.link(
						`Don't keep this child in ${V.nurseryName}`,
						() => {
							fetus.reserve = "";
						},
						[],
						passage()
					));
				} else if ((V.nursery - V.cribs.length) - FetusGlobalReserveCount("nursery") > 0) {
					App.UI.DOM.appendNewElement("div", el, App.UI.DOM.link(
						`Keep this child in ${V.nurseryName}`,
						() => {
							fetus.reserve = "nursery";
						},
						[],
						passage()
					));
				} else {
					App.UI.DOM.appendNewElement("div", el, `There is not enough free space to keep this child in ${V.nurseryName}.`);
				}
			}
		} else {
			App.UI.DOM.appendNewElement("div", el, `Unidentified ova found, no detailed data available.`);
			App.UI.DOM.appendNewElement("div", el, `Age: too early for scan.`);
			option = terminateOvum();

			if (V.surgeryUpgrade === 1) {
				option.addButton(
					`Transplant ovum`,
					() => {
						V.donatrix = mother;
						V.wombIndex = i;
						V.nextLink = "Analyze Pregnancy";
					},
					`Ova Transplant Workaround`
				);
			}
		}
		el.append(options.render());
		return el;

		function fetusAbnormalities() {
			const div = App.UI.DOM.makeElement("div", null);

			const abnormalitySpans = [];
			for (const gene in genes.geneticQuirks) {
				const geneObj = App.Data.geneticQuirks.get(gene);
				const quirkName = (geneObj && geneObj.abbreviation) ? geneObj.abbreviation : gene;
				const quirkColor = (geneObj && geneObj.goodTrait) ? "green" : "red";
				if (genes.geneticQuirks[gene] >= 2 || typeof genes.geneticQuirks[gene] === "string") { // String check is for heterochromia
					abnormalitySpans.push(App.UI.DOM.makeElement("span", quirkName, quirkColor));
				} else if (genes.geneticQuirks[gene] === 1 && V.geneticMappingUpgrade >= 2) {
					abnormalitySpans.push(App.UI.DOM.makeElement("span", quirkName, "yellow"));
				}
			}
			if (abnormalitySpans.length > 0) {
				div.append("Detected abnormalities: ");
				App.Events.addNode(div, abnormalitySpans);
			}
			return div;
		}

		function terminateOvum() {
			return options.addCustomOption(`Surgical options`)
				.addButton(
					`Terminate ovum`,
					() => {
						WombRemoveFetus(mother, i);
						if (mother.preg === 0) {
							mother.pregWeek = -1;
						}
					},
					passage()
				);
		}
	}
};

