/** @param {App.Entity.SlaveState} slave */
App.UI.SlaveInteract.remoteSurgery = function(slave) {
	const el = new DocumentFragment();
	const r = [];
	const {His} = getPronouns(slave);
	updateHealth(slave);

	V.surgeryType = 0;
	V.encyclopedia = "The Remote Surgery";
	/* get all prosthetics that are ready for this slave */
	if (V.adjustProstheticsCompleted > 0) {
		V.adjustProsthetics = V.adjustProsthetics.filter(function(p) {
			if (p.workLeft <= 0 && p.slaveID === V.AS) {
				addProsthetic(slave, p.id);
				V.adjustProstheticsCompleted--;
				return false;
			}
			return true;
		});
	}

	App.UI.DOM.appendNewElement("h1", el, "The Remote Surgery");
	r.push(`${slave.slaveName} is lying strapped down on the table in your`);
	if (V.surgeryUpgrade === 1) {
		r.push(`heavily upgraded and customized`);
	}
	r.push(`remote surgery. The surgical equipment reads`);
	if (slave.health.health < -20) {
		r.push(App.UI.DOM.makeElement("span", `SLAVE UNHEALTHY, SURGERY NOT RECOMMENDED.`, "red"));
	} else if (slave.health.health <= 20) {
		r.push(App.UI.DOM.makeElement("span", `SLAVE HEALTHY, SURGERY SAFE.`, "yellow"));
	} else {
		r.push(App.UI.DOM.makeElement("span", `SLAVE HEALTHY, SURGERY ENCOURAGED.`, "green"));
	}
	if (V.PC.skill.medicine >= 100) {
		r.push(`The remote surgery mechanisms that allow a surgeon to be brought in by telepresence are inactive, and the autosurgery is ready for your control inputs. Surgery on your slaves is a challenge and a pleasure you wouldn't dream of sharing.`);
	}
	App.Events.addNode(el, r, "div", "scene-intro");
	if (slave.indentureRestrictions >= 1) {
		App.UI.DOM.appendNewElement("div", el, `${His} indenture forbids elective surgery`, ["yellow", "note"]);
	}

	const tabBar = new App.UI.Tabs.TabBar("RemoteSurgery");
	const f = new DocumentFragment();
	App.Events.drawEventArt(f, slave);
	tabBar.customNode = f;

	tabBar.addTab("Hair and Face", "hairAndFace", App.UI.surgeryPassageHairAndFace(slave));
	tabBar.addTab("Upper", "upper", App.UI.surgeryPassageUpper(slave));
	tabBar.addTab("Lower", "lower", App.UI.surgeryPassageLower(slave));
	tabBar.addTab("Structural", "structural", App.UI.surgeryPassageStructural(slave));
	tabBar.addTab("Exotic", "exotic", App.UI.surgeryPassageExotic(slave));
	if (V.seeExtreme) {
		tabBar.addTab("Extreme", "extreme", App.UI.surgeryPassageExtreme(slave));
	}
	el.append(tabBar.render());

	return el;
};
