App.UI.fsPassage = function() {
	const arc = V.arcologies[0];
	V.FSReminder = 0;
	const _FSCredits = FutureSocieties.availCredits();
	setup();

	V.nextButton = "Back";
	V.nextLink = "Main";
	V.encyclopedia = "Future Societies";

	const f = new DocumentFragment();

	if (V.cheatMode) {
		App.UI.DOM.appendNewElement("div", f, App.UI.DOM.link(
			"Cheat Edit Future Society",
			() => {
				V.cheater = 1;
			},
			[],
			"MOD_Edit Arcology Cheat"
		), "cheat-menu");
	}

	App.UI.DOM.appendNewElement("h1", f, "Future Societies");

	f.append(overview());
	f.append(FSPerception());
	f.append(unlocks());
	f.append(spending());
	f.append(rename());
	f.append(selectFS());

	App.UI.DOM.appendNewElement("h2", f, "Facility Redecoration");

	f.append(App.UI.facilityRedecoration());
	return f;

	/**
	 * FIRST FS STORING FOR RIVALRY
	 */
	function setup() {
		if (V.rivalryFS === 0) {
			if (arc.FSSubjugationist !== "unset") {
				V.rivalryFS = "Racial Subjugationism";
				V.rivalryFSRace = arc.FSSubjugationistRace;
			}
			if (arc.FSSupremacist !== "unset") {
				V.rivalryFS = "Racial Supremacism";
				V.rivalryFSRace = arc.FSSupremacistRace;
			}
			if (arc.FSGenderRadicalist !== "unset") {
				V.rivalryFS = "Gender Radicalism";
			} else if (arc.FSGenderFundamentalist !== "unset") {
				V.rivalryFS = "Gender Fundamentalism";
			}
			if (arc.FSRepopulationFocus !== "unset") {
				V.rivalryFS = "Repopulation Focus";
			} else if (arc.FSRestart !== "unset") {
				V.rivalryFS = "Eugenics";
			}
			if (arc.FSPaternalist !== "unset") {
				V.rivalryFS = "Paternalism";
			} else if (arc.FSDegradationist !== "unset") {
				V.rivalryFS = "Degradationism";
			}
			if (arc.FSBodyPurist !== "unset") {
				V.rivalryFS = "Body Purism";
			} else if (arc.FSTransformationFetishist !== "unset") {
				V.rivalryFS = "Transformation Fetishism";
			}
			if (arc.FSYouthPreferentialist !== "unset") {
				V.rivalryFS = "Youth Preferentialism";
			} else if (arc.FSMaturityPreferentialist !== "unset") {
				V.rivalryFS = "Maturity Preferentialism";
			}
			if (arc.FSSlimnessEnthusiast !== "unset") {
				V.rivalryFS = "Slimness Enthusiasm";
			} else if (arc.FSAssetExpansionist !== "unset") {
				V.rivalryFS = "Asset Expansionism";
			}
			if (arc.FSPastoralist !== "unset") {
				V.rivalryFS = "Pastoralism";
			} else if (arc.FSCummunism !== "unset") {
				V.rivalryFS = "Cummunism";
			}
			if (arc.FSHedonisticDecadence !== "unset") {
				V.rivalryFS = "Hedonistic Decadence";
			} else if (arc.FSPhysicalIdealist !== "unset") {
				V.rivalryFS = "Physical Idealism";
			}
			if (arc.FSIntellectualDependency !== "unset") {
				V.rivalryFS = "Intellectual Dependency";
			} else if (arc.FSSlaveProfessionalism !== "unset") {
				V.rivalryFS = "Slave Professionalism";
			}
			if (arc.FSPetiteAdmiration !== "unset") {
				V.rivalryFS = "Petite Admiration";
			} else if (arc.FSStatuesqueGlorification !== "unset") {
				V.rivalryFS = "Statuesque Glorification";
			}
			if (arc.FSChattelReligionist !== "unset") {
				V.rivalryFS = "Chattel Religionism";
			} else if (arc.FSNull !== "unset") {
				V.rivalryFS = "Multiculturalism";
			}
			if (arc.FSRomanRevivalist !== "unset") {
				V.rivalryFS = "Roman Revivalism";
			} else if (arc.FSNeoImperialist !== "unset") {
				V.rivalryFS = "Neo-Imperialism";
			} else if (arc.FSAztecRevivalist !== "unset") {
				V.rivalryFS = "Aztec Revivalism";
			} else if (arc.FSEgyptianRevivalist !== "unset") {
				V.rivalryFS = "Egyptian Revivalism";
			} else if (arc.FSEdoRevivalist !== "unset") {
				V.rivalryFS = "Edo Revivalism";
			} else if (arc.FSArabianRevivalist !== "unset") {
				V.rivalryFS = "Arabian Revivalism";
			} else if (arc.FSChineseRevivalist !== "unset") {
				V.rivalryFS = "Chinese Revivalism";
			}
		}
	}

	function overview() {
		const el = new DocumentFragment();
		const r = [];
		if (_FSCredits > 0) {
			r.push(App.UI.DOM.makeElement("span", `${arc.name}'s society is ready to begin accepting a new societal direction.`, "yellow"));
		} else if (V.FSGotRepCredits >= 3) {
			r.push(`Your society is so radically changed that it is starting to take on a life of its own. The major decisions about its direction have been made.`);
		} else {
			r.push(`You must develop your reputation further for ${arc.name}'s society to be ready for a new societal direction.`);
		}
		App.Events.addNode(el, r, "div");
		return el;
	}

	function FSPerception() {
		const el = new DocumentFragment();
		for (const FS of App.Data.FutureSociety.playerFSNames) {
			if (arc[FS] !== "unset") {
				App.UI.DOM.appendNewElement("div", el, FutureSocieties.arcSupport(FS, arc));
			}
		}
		return el;
	}

	function unlocks() {
		const el = new DocumentFragment();
		const r = [];
		r.push(`You have unlocked`);
		r.push(App.UI.DOM.makeElement("span", `${num(V.FSGotRepCredits, true)} of ${num(V.FSCreditCount, true)}`, "note"));
		r.push(`possible societal customizations.`);
		App.Events.addNode(el, r, "div");
		return el;
	}

	function spending() {
		const el = new DocumentFragment();
		let r = [];
		V.FSSpending = Number(V.FSSpending) || 0;
		V.FSSpending = Math.clamp(Math.ceil(V.FSSpending / 1000) * 1000, 0, 10000);
		r.push(`You are spending ¤`);
		r.push(App.UI.DOM.makeTextBox(
			V.FSSpending,
			(v) => { V.FSSpending = v; },
			true
		));
		r.push(`each week to support your societal goals.`);
		App.Events.addNode(el, r, "div");
		if (V.FSSpending > 10000) {
			App.UI.DOM.appendNewElement("div", el, `Spending more than ${cashFormat(10000)} weekly is a waste`, "note");
		}
		return el;
	}

	function rename() {
		const el = document.createElement('span');
		el.id = "mass";
		const linkArray = [];

		if (arc.FSChattelReligionist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Give all your slaves devotional names",
					() => {
						for (const slave of V.slaves) {
							slave.slaveName = App.Data.misc.chattelReligionistSlaveNames.random();
						}
						refresh();
					}
				)
			);
		}

		if (arc.FSPastoralist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Give all your lactating slaves cow names",
					() => {
						for (const slave of V.slaves) {
							if (slave.lactation) {
								slave.slaveName = App.Data.misc.cowSlaveNames.random();
							}
						}
						refresh();
					}
				)
			);
		}

		if (arc.FSIntellectualDependency !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Give all your idiotic slaves stripper names",
					() => {
						for (const slave of V.slaves) {
							if (slave.intelligence < -15) {
								slave.slaveName = App.Data.misc.bimboSlaveNames.random();
							}
						}
						refresh();
					}
				)
			);
		}

		if (arc.FSRomanRevivalist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Rename all your slaves according to Roman custom",
					() => {
						for (const slave of V.slaves) {
							slave.slaveName = App.Data.misc.romanSlaveNames.random();
							slave.slaveSurname = App.Data.misc.romanSlaveSurnames.random();
						}
						refresh();
					}
				)
			);
		} else if (arc.FSAztecRevivalist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Rename all your slaves according to ancient Aztec custom",
					() => {
						for (const slave of V.slaves) {
							slave.slaveName = App.Data.misc.aztecSlaveNames.random();
							slave.slaveSurname = 0;
						}
						refresh();
					}
				)
			);
		} else if (arc.FSEgyptianRevivalist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Rename all your slaves according to ancient Egyptian custom",
					() => {
						for (const slave of V.slaves) {
							slave.slaveName = App.Data.misc.ancientEgyptianSlaveNames.random();
							slave.slaveSurname = 0;
						}
						refresh();
					}
				)
			);
		} else if (arc.FSEdoRevivalist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Rename all your slaves according to feudal Japanese custom",
					() => {
						for (const slave of V.slaves) {
							slave.slaveName = App.Data.misc.edoSlaveNames.random();
							slave.slaveSurname = App.Data.misc.edoSlaveSurnames.random();
						}
						refresh();
					}
				)
			);
		}
		if (arc.FSDegradationist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Rename all your slaves according to Degradationist custom",
					() => {
						for (const slave of V.slaves) {
							DegradingName(slave);
						}
						refresh();
					}
				)
			);
		}

		if (arc.FSPaternalist !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Rename your obedient slaves according to Paternalist custom",
					() => {
						for (const slave of V.slaves) {
							if (slave.devotion > 20 || (slave.devotion >= -20 && slave.trust < -20)) {
								if (!["Miss", "Ms.", "Mrs."].some(title => slave.slaveName.includes(title))) {
									if (slave.relationship > 4) {
										slave.slaveName = ("Mrs. " + slave.slaveName);
									} else if (slave.actualAge > 24) {
										slave.slaveName = ("Ms. " + slave.slaveName);
									} else {
										slave.slaveName = ("Miss " + slave.slaveName);
									}
								}
							}
						}
						refresh("Obedient slaves renamed.");
					}
				)
			);
		}

		if (arc.FSIntellectualDependency !== "unset") {
			linkArray.push(
				App.UI.DOM.link(
					"Give all your slaves simple bimbo names",
					() => {
						for (const slave of V.slaves) {
							slave.slaveName = App.Data.misc.bimboSlaveNames.random();
							slave.slaveSurname = 0;
						}
						refresh();
					}
				)
			);
		}

		if (linkArray.length > 0) {
			App.UI.DOM.appendNewElement("h3", el, "Names");
			el.append(App.UI.DOM.generateLinksStrip(linkArray));
		}

		return el;

		function refresh(text = "Slaves renamed.") {
			jQuery("#mass").empty().append(text);
		}
	}

	function selectFS() {
		const el = new DocumentFragment();
		let r;
		let p;

		/* Race */
		p = document.createElement("p");
		r = [];
		if (arc.FSSupremacist !== "unset") {
			r.push(pursuit());
			r.push(`${arc.FSSupremacistRace} superiority.`);
			r.push(activeFS("FSSupremacist"));
		} else {
			if (_FSCredits > 0) {
				r.push(
					App.UI.DOM.link(
						"Racial Supremacism",
						() => {
							arc.FSSupremacist = 4;
							App.UI.reload();
						}
					)
				);
				r.push(`is a belief in`);
				if (arc.FSSupremacistRace === 0) {
					r.push(`the superiority of a chosen race.`);
				} else {
					r.push(`${arc.FSSupremacistRace} superiority.`);
				}
				r.push(`Select race:`);
				const select = document.createElement("select");
				r.push(select);
				for (const race of App.Utils.getRaceArrayWithoutParamRace(arc.FSSubjugationistRace)) { // Subjugation race cannot be superior, so remove
					const choice = App.UI.DOM.appendNewElement("option", select, capFirstChar(race));
					choice.value = race;
					if (race === arc.FSSupremacistRace) {
						choice.selected = true;
					}
				}

				select.onchange = () => {
					const O = select.options[select.selectedIndex];
					arc.FSSupremacistRace = O.value;
					App.UI.reload();
				};
			} else {
				/* <span class="note"><span style="font-weight:Bold">Racial Supremacism:</span> a belief in the superiority of a chosen race.</span>*/
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSSubjugationist !== "unset") {
			r.push(pursuit());
			r.push(`${arc.FSSubjugationistRace} inferiority.`);
			r.push(activeFS("FSSubjugationist"));
		} else {
			if (_FSCredits > 0) {
				r.push(
					App.UI.DOM.link(
						"Racial Subjugationism",
						() => {
							arc.FSSubjugationist = 4;
							App.UI.reload();
						}
					)
				);
				r.push(`is a belief in`);
				if (arc.FSSubjugationistRace === 0) {
					r.push(`the inferiority of a chosen race.`);
				} else {
					r.push(`${arc.FSSubjugationistRace} inferiority.`);
				}
				r.push(`Select race:`);
				const select = document.createElement("select");
				r.push(select);

				for (const race of App.Utils.getRaceArrayWithoutParamRace(arc.FSSupremacistRace)) { // Superior race cannot be subj, so remove
					const choice = App.UI.DOM.appendNewElement("option", select, capFirstChar(race));
					choice.value = race;
					if (race === arc.FSSubjugationistRace) {
						choice.selected = true;
					}
				}

				select.onchange = () => {
					const O = select.options[select.selectedIndex];
					arc.FSSubjugationistRace = O.value;
					App.UI.reload();
				};
			} else {
				/* <span class="note"><span style="font-weight:Bold">Racial Subjugationism:</span> a belief in the inferiority of a subject race.</span>*/
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Preg vs Eugenics */
		if (V.seePreg !== 0) {
			p = document.createElement("p");
			r = [];
			if (arc.FSRestart === "unset") {
				if (arc.FSRepopulationFocus !== "unset") {
					r.push(pursuit());
					r.push(`the belief that mass breeding will save humanity.`);
					r.push(activeFS("FSRepopulationFocus", ["boughtItem.clothing.maternityLingerie", "boughtItem.clothing.maternityDress", "boughtItem.clothing.belly"]));
				} else {
					if (_FSCredits > 0) {
						r.push(
							App.UI.DOM.link(
								"Repopulation Efforts",
								() => {
									arc.FSRepopulationFocus = 4 + arc.FSRepopulationFocusInterest - arc.FSEugenicsInterest;
									arc.FSRepopulationFocusPregPolicy = 0;
									arc.FSRepopulationFocusMilfPolicy = 0;
									App.UI.reload();
								}
							)
						);
						r.push(`is a focus on mass breeding in order to repopulate the future world.`);
					} else {
						/* <span class="note"><span style="font-weight:Bold">Repopulation Efforts:</span> societal fetishization of pregnancy.</span>*/
					}
				}
			}
			App.Events.addNode(p, r, "div");
			r = [];
			if (arc.FSRepopulationFocus === "unset") {
				if (arc.FSRestart !== "unset") {
					if (arc.FSRestartDecoration !== 100) {
						r.push(pursuit());
						r.push(`Eugenics.`);
						r.push(activeFS("FSRestart"));
					} else {
						r.push(App.UI.DOM.makeElement("span", "You have established", "bold"));
						r.push(`Eugenics.`);
						r.push(activeFS("FSRestart"));
						r.push(`The Societal Elite exist as the highest class, allowing you access to all manner of benefits`);
					}
				} else {
					if (_FSCredits > 0) {
						r.push(
							App.UI.DOM.link(
								"Eugenics",
								() => {
									arc.FSRestart = 4 + arc.FSEugenicsInterest - arc.FSRepopulationFocusInterest;
									arc.FSRepopulationFocusPregPolicy = 0;
									arc.FSRepopulationFocusMilfPolicy = 0;
									App.UI.reload();
								}
							)
						);
						r.push(`is rebuilding society using restrictive breeding programs reserved solely for society's finest.`);
					} else {
						/* <span class="note"><span style="font-weight:Bold">Complete Societal Reconstruction:</span> rebuilding society based off the elite.</span>*/
					}
				}
			}
			App.Events.addNode(p, r, "div");
			el.append(p);
		}

		/* Pro vs Dependant */
		p = document.createElement("p");
		r = [];
		if (arc.FSSlaveProfessionalism === "unset") {
			if (arc.FSIntellectualDependency !== "unset") {
				r.push(pursuit());
				r.push(`intellectual dependency, a belief that slaves should be airheaded, horny and fully dependent on their owners.`);
				r.push(activeFS("FSIntellectualDependency", ["boughtItem.clothing.bimbo"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Intellectual Dependency",
							() => {
								arc.FSIntellectualDependency = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a belief that slaves should be airheaded, horny and fully dependent on their owners.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Intellectual Dependency:</span> a belief that slaves should be airheaded, horny and fully dependent on their owners.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSIntellectualDependency === "unset") {
			if (arc.FSSlaveProfessionalism !== "unset") {
				r.push(pursuit());
				r.push(`slave professionalism, a focus on smart, refined, altogether perfect slaves.`);
				r.push(activeFS("FSSlaveProfessionalism", ["boughtItem.clothing.courtesan"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Slave Professionalism",
							() => {
								arc.FSSlaveProfessionalism = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is increased interest in smart, refined, altogether perfect slaves.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Slave Professionalism:</span> increased interest in smart, refined, altogether perfect slaves.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Gender */
		p = document.createElement("p");
		r = [];
		if (V.seeDicks !== 0 || V.makeDicks === 1) {
			if (arc.FSGenderFundamentalist === "unset") {
				if (arc.FSGenderRadicalist !== "unset") {
					r.push(pursuit());
					r.push(`a radical redefinition of gender that identifies powerful people as male, and everyone else as female.`);
					r.push(activeFS("FSGenderRadicalist"));
				} else {
					if (_FSCredits > 0) {
						r.push(
							App.UI.DOM.link(
								"Gender radicalism",
								() => {
									arc.FSGenderRadicalist = 4;
									App.UI.reload();
								}
							)
						);
						r.push(`is a radical redefinition of gender that identifies powerful people as male, and everyone else as female.`);
					} else {
						/* <span class="note"><span style="font-weight:Bold">Gender radicalism:</span> a radical redefinition of gender that identifies powerful people as male, and everyone else as female.</span>*/
					}
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSGenderRadicalist === "unset") {
			if (arc.FSGenderFundamentalist !== "unset") {
				r.push(pursuit());
				r.push(`gender traditionalism, including a societal preference for feminine slaves ${(V.seePreg !== 0) ? ` and support for slave pregnancy` : ``}.`);
				r.push(activeFS("FSGenderFundamentalist", ["boughtItem.clothing.bunny"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Gender traditionalism",
							() => {
								arc.FSGenderFundamentalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`gender traditionalism, including a societal preference for feminine slaves ${(V.seePreg !== 0) ? ` and support for slave pregnancy` : ``}.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Gender traditionalism:</span> a societal preference for feminine slaves
						if (V.seePreg !== 0) {
							r.push(`and support for slave pregnancy`);
						}
						r.push(`.</span>`);*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Deg vs Paternalist */
		p = document.createElement("p");
		r = [];
		if (arc.FSDegradationist === "unset") {
			if (arc.FSPaternalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of slave improvement, including slaves' health, mental well-being, and education.`);
				r.push(activeFS("FSPaternalist", ["boughtItem.clothing.conservative"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Paternalism",
							() => {
								arc.FSPaternalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of slave improvement, including slaves' health, mental well-being, and education.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Paternalism:</span> a vision of slave improvement, including slaves' health, mental well-being, and education.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSPaternalist === "unset") {
			if (arc.FSDegradationist !== "unset") {
				r.push(pursuit());
				r.push(`slave degradation, a belief that slaves are not human and should not be treated decently.`);
				r.push(activeFS("FSDegradationist", ["boughtItem.clothing.chains"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Degradationism",
							() => {
								arc.FSDegradationist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a belief that slaves are not human and should not be treated decently.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Degradation:</span> a belief that slaves are not human and should not be treated decently.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* TF vs Purist */
		p = document.createElement("p");
		r = [];
		if (arc.FSTransformationFetishist === "unset") {
			if (arc.FSBodyPurist !== "unset") {
				r.push(pursuit());
				r.push(`societal disapproval of implant surgery.`);
				r.push(activeFS("FSBodyPurist"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Body Purism",
							() => {
								arc.FSBodyPurist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is societal disapproval of implant surgery`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Body Purism:</span> societal disapproval of implant surgery.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSBodyPurist === "unset") {
			if (arc.FSTransformationFetishist !== "unset") {
				r.push(pursuit());
				r.push(`societal fetishization of implant surgery.`);
				r.push(activeFS("FSTransformationFetishist"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Transformation Fetishism",
							() => {
								arc.FSTransformationFetishist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is societal fetishization of implant surgery.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Transformation Fetishism:</span> societal fetishization of implant surgery.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Maturity vs Youth */
		p = document.createElement("p");
		r = [];
		if (arc.FSMaturityPreferentialist === "unset") {
			if (arc.FSYouthPreferentialist !== "unset") {
				r.push(pursuit());
				r.push(`an accentuated societal preference for younger slaves.`);
				r.push(activeFS("FSYouthPreferentialist"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Youth Preferentialism",
							() => {
								arc.FSYouthPreferentialist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is increased interest in girls just past their majority.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Youth Preferentialism:</span> increased interest in girls just past their majority.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSYouthPreferentialist === "unset") {
			if (arc.FSMaturityPreferentialist !== "unset") {
				r.push(pursuit());
				r.push(`a societal preference for older women.`);
				r.push(activeFS("FSMaturityPreferentialist"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Maturity Preferentialism",
							() => {
								arc.FSMaturityPreferentialist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is increased interest in mature slaves.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Maturity Preferentialism:</span> increased interest in mature slaves.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Statuesque vs Petite */
		p = document.createElement("p");
		r = [];
		if (arc.FSStatuesqueGlorification === "unset") {
			if (arc.FSPetiteAdmiration !== "unset") {
				r.push(pursuit());
				r.push(`an accentuated societal preference for short slaves.`);
				r.push(activeFS("FSPetiteAdmiration"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Petite Admiration",
							() => {
								arc.FSPetiteAdmiration = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is increased interest in short slaves.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Petite Admiration:</span> increased interest in short slaves.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSPetiteAdmiration === "unset") {
			if (arc.FSStatuesqueGlorification !== "unset") {
				r.push(pursuit());
				r.push(`a societal fixation on tallness.`);
				r.push(activeFS("FSStatuesqueGlorification"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Statuesque Glorification",
							() => {
								arc.FSStatuesqueGlorification = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is societal fixation on tallness.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Statuesque Glorification:</span> societal fixation on tallness.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Expand vs Slim */
		p = document.createElement("p");
		r = [];
		if (arc.FSAssetExpansionist === "unset") {
			if (arc.FSSlimnessEnthusiast !== "unset") {
				r.push(App.UI.DOM.makeElement("span", "You are supporting", "bold"));
				r.push(`enthusiasm for slaves with girlish figures.`);
				r.push(activeFS("FSSlimnessEnthusiast"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Slimness Enthusiasm",
							() => {
								arc.FSSlimnessEnthusiast = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a fashion for slaves with girlish figures.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Slimness Enthusiasm:</span> a fashion for slaves with girlish figures.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSSlimnessEnthusiast === "unset") {
			if (arc.FSAssetExpansionist !== "unset") {
				r.push(pursuit());
				r.push(`societal hunger for huge assets.`);
				r.push(activeFS("FSAssetExpansionist"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Asset Expansionism",
							() => {
								arc.FSAssetExpansionist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is societal hunger for huge assets of whatever origin.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Asset Expansionism:</span> societal hunger for huge assets of whatever origin.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Milking stands alone */
		r = [];
		if (arc.FSPastoralist !== "unset") {
			r.push(pursuit());
			r.push(`societal normalization of slave milking.`);
			r.push(activeFS("FSPastoralist", ["boughtItem.clothing.western"]));
		} else {
			if (_FSCredits > 0) {
				r.push(
					App.UI.DOM.link(
						"Slave Pastoralism",
						() => {
							arc.FSPastoralist = 4;
							App.UI.reload();
						}
					)
				);
				r.push(`is societal acceptance of slave products like milk.`);
			} else {
				/* <span class="note"><span style="font-weight:Bold">Slave Pastoralism:</span> societal acceptance of slave products like milk.</span>*/
			}
		}
		App.Events.addNode(el, r, "p");

		/* Physical Idealist vs Hedonist */
		p = document.createElement("p");
		r = [];
		if (arc.FSHedonisticDecadence === "unset") {
			if (arc.FSPhysicalIdealist !== "unset") {
				r.push(pursuit());
				r.push(`societal reverence for the idealized human form, including height, health and muscle.`);
				r.push(activeFS("FSPhysicalIdealist", ["boughtItem.clothing.oil"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Physical Idealism",
							() => {
								arc.FSPhysicalIdealist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is societal reverence for the idealized human form, including height, health and muscle.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Physical Idealism:</span> societal reverence for the idealized human form, including height, health and muscle.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSPhysicalIdealist === "unset") {
			if (arc.FSHedonisticDecadence !== "unset") {
				r.push(pursuit());
				r.push(`societal normalization of overindulgence and immediate gratification. Be it food, drink, sex, drugs or whatever one's desire may be.`);
				r.push(activeFS("FSHedonisticDecadence"));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Hedonistic Decadence",
							() => {
								arc.FSHedonisticDecadence = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is societal acceptance of overindulgence and immediate gratification. Be it food, drink, sex, drugs or whatever one's desire may be.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">HedonisticDecadence:</span> societal acceptance of over indulgence, particularly of food, drink, sex and drugs.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		/* Chattel religionist vs Multicultural */
		p = document.createElement("p");
		r = [];
		if (arc.FSNull === "unset") {
			if (arc.FSChattelReligionist !== "unset") {
				r.push(pursuit());
				r.push(`a new strain of religion that emphasizes the slaveholding portions of religious history.`);
				r.push(activeFS("FSChattelReligionist", ["boughtItem.clothing.habit"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Chattel Religionism",
							() => {
								arc.FSChattelReligionist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a new strain of religion that emphasizes the slaveholding portions of religious history.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Chattel Religionism:</span> a new strain of religion that emphasizes the slaveholding portions of religious history.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if (arc.FSChattelReligionist === "unset") {
			if (arc.FSNull !== "unset") {
				const freedomArray = [`You are permitting`];
				if (arc.FSNull <= 25) {
					freedomArray.push(`basic`);
				} else if (arc.FSNull <= 50) {
					freedomArray.push(`considerable`);
				} else if (arc.FSNull <= 75) {
					freedomArray.push(`advanced`);
				} else {
					freedomArray.push(`absolute`);
				}
				r.push(App.UI.DOM.makeElement("span", freedomArray.join(" "), "bold"));
				r.push(`cultural freedom in your arcology.`);
			}
			if (V.FSCreditCount === 4) {
				if (arc.FSNull !== "unset") {
					r.push(activeFS("FSChattelReligionist"));
					if (arc.FSNull <= 25) {
						r.push(abandonRel());
					} else {
						r.push(withdrawRel(25));
					}
					if (_FSCredits > 0) {
						if (arc.FSNull < V.FSLockinLevel) {
							r.push(advanceRel(25));
						}
					}
				} else {
					if (_FSCredits > 0) {
						r.push(MulticulturalismRel(25));
					}
				}
			} else if (V.FSCreditCount === 6) {
				if (arc.FSNull !== "unset") {
					if (arc.FSNull <= 20) {
						r.push(abandonRel());
					} else {
						r.push(withdrawRel(17));
					}
					if (_FSCredits > 0) {
						if (arc.FSNull < V.FSLockinLevel) {
							r.push(advanceRel(17));
						}
					}
				} else {
					if (_FSCredits > 0) {
						r.push(MulticulturalismRel(17));
					}
				}
			} else if (V.FSCreditCount === 7) {
				if (arc.FSNull !== "unset") {
					if (arc.FSNull <= 20) {
						r.push(abandonRel());
					} else {
						r.push(withdrawRel(15));
					}
					if (_FSCredits > 0) {
						if (arc.FSNull < V.FSLockinLevel) {
							r.push(advanceRel(15));
						}
					}
				} else {
					if (_FSCredits > 0) {
						r.push(MulticulturalismRel(15));
					}
				}
			} else {
				if (arc.FSNull !== "unset") {
					if (arc.FSNull <= 20) {
						r.push(abandonRel());
					} else {
						r.push(withdrawRel(20));
					}
					if (_FSCredits > 0) {
						if (arc.FSNull < V.FSLockinLevel) {
							r.push(advanceRel(20));
						}
					}
				} else {
					if (_FSCredits > 0) {
						r.push(MulticulturalismRel(20));
					}
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		function withdrawRel(num) {
			return App.UI.DOM.link(
				"Withdraw",
				() => {
					if (arc.FSNull !== "unset") {
						arc.FSNull -= num;
					}
					App.UI.reload();
				}
			);
		}

		function abandonRel() {
			return App.UI.DOM.link(
				"Abandon",
				() => {
					FutureSocieties.remove("FSNull");
					App.UI.reload();
				}
			);
		}

		function advanceRel(num) {
			return App.UI.DOM.link(
				"Advance",
				() => {
					if (arc.FSNull !== "unset") {
						arc.FSNull += num;
					}
					App.UI.reload();
				},
				[],
				"",
				"a further commitment to allow your arcology's citizens cultural freedom"
			);
		}

		function MulticulturalismRel(num) {
			const multicultural = App.UI.DOM.makeElement(
				"span",
				App.UI.DOM.link(
					"Multiculturalism",
					() => {
						arc.FSNull = num;
						App.UI.reload();
					},
					[],
					"",
					"a commitment to allow your arcology's citizens cultural freedom."
				)
			);
			multicultural.append(` is an alternative to societal advancement, and will not advance naturally.`);
			return multicultural;
		}

		/* Revival section */
		p = document.createElement("p");
		r = [];
		if ((arc.FSAztecRevivalist === "unset") && (arc.FSEgyptianRevivalist === "unset") && (arc.FSEdoRevivalist === "unset") && (arc.FSArabianRevivalist === "unset") && (arc.FSChineseRevivalist === "unset") && (arc.FSNeoImperialist === "unset")) {
			if (arc.FSRomanRevivalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of a new Rome.`);
				r.push(activeFS("FSRomanRevivalist", ["boughtItem.clothing.toga"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Roman Revivalism",
							() => {
								arc.FSRomanRevivalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of a new Rome.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Roman Revivalism:</span> a vision of a new Rome.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if ((arc.FSAztecRevivalist === "unset") && (arc.FSEgyptianRevivalist === "unset") && (arc.FSEdoRevivalist === "unset") && (arc.FSArabianRevivalist === "unset") && (arc.FSChineseRevivalist === "unset") && (arc.FSRomanRevivalist === "unset")) {
			if (arc.FSNeoImperialist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of a new Imperial Society.`);
				r.push(activeFS("FSNeoImperialist", ["boughtItem.clothing.imperialarmor", "boughtItem.clothing.imperialsuit"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Neo-Imperialism",
							() => {
								arc.FSNeoImperialist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of a new Imperial society, integrating high technology and old-world culture under the iron fist of your absolute rule.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Neo-Imperialism:</span> a vision of a new Imperial Society, integrating high technology and old-world culture under the iron fist of your absolute rule.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if ((arc.FSRomanRevivalist === "unset") && (arc.FSEgyptianRevivalist === "unset") && (arc.FSEdoRevivalist === "unset") && (arc.FSArabianRevivalist === "unset") && (arc.FSChineseRevivalist === "unset") && (arc.FSNeoImperialist === "unset")) {
			if (arc.FSAztecRevivalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of a new Aztec Empire.`);
				r.push(activeFS("FSAztecRevivalist", ["boughtItem.clothing.huipil"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Aztec Revivalism",
							() => {
								arc.FSAztecRevivalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of a new Aztec Empire.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Aztec Revivalism:</span> a vision of a new Aztec Empire.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if ((arc.FSRomanRevivalist === "unset") && (arc.FSAztecRevivalist === "unset") && (arc.FSEdoRevivalist === "unset") && (arc.FSArabianRevivalist === "unset") && (arc.FSChineseRevivalist === "unset") && (arc.FSNeoImperialist === "unset")) {
			if (arc.FSEgyptianRevivalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of Pharaoh's Egypt.`);
				r.push(activeFS("FSEgyptianRevivalist", ["boughtItem.clothing.egypt"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Egyptian Revivalism",
							() => {
								arc.FSEgyptianRevivalist = 4 + arc.FSEgyptianRevivalistInterest;
								arc.FSEgyptianRevivalistIncestPolicy = 0;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of a Pharaoh's Egypt.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Egyptian Revivalism:</span> a vision of Pharaoh's Egypt.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if ((arc.FSRomanRevivalist === "unset") && (arc.FSAztecRevivalist === "unset") && (arc.FSEgyptianRevivalist === "unset") && (arc.FSArabianRevivalist === "unset") && (arc.FSChineseRevivalist === "unset") && (arc.FSNeoImperialist === "unset")) {
			if (arc.FSEdoRevivalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of Edo Japan.`);
				r.push(activeFS("FSEdoRevivalist", ["boughtItem.clothing.kimono"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Edo Revivalism",
							() => {
								arc.FSEdoRevivalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of Edo Japan.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Edo Revivalism:</span> a vision of Edo Japan.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if ((arc.FSRomanRevivalist === "unset") && (arc.FSAztecRevivalist === "unset") && (arc.FSEgyptianRevivalist === "unset") && (arc.FSEdoRevivalist === "unset") && (arc.FSChineseRevivalist === "unset") && (arc.FSNeoImperialist === "unset")) {
			if (arc.FSArabianRevivalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of the Sultanate of old.`);
				r.push(activeFS("FSArabianRevivalist", ["boughtItem.clothing.harem"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Arabian Revivalism",
							() => {
								arc.FSArabianRevivalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of the Sultanate of old.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Arabian Revivalism:</span> a vision of the Sultanate of old.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		r = [];
		if ((arc.FSRomanRevivalist === "unset") && (arc.FSAztecRevivalist === "unset") && (arc.FSEgyptianRevivalist === "unset") && (arc.FSEdoRevivalist === "unset") && (arc.FSArabianRevivalist === "unset") && (arc.FSNeoImperialist === "unset")) {
			if (arc.FSChineseRevivalist !== "unset") {
				r.push(pursuit());
				r.push(`a vision of ancient China.`);
				r.push(activeFS("FSChineseRevivalist", ["boughtItem.clothing.qipao"]));
			} else {
				if (_FSCredits > 0) {
					r.push(
						App.UI.DOM.link(
							"Chinese Revivalism",
							() => {
								arc.FSChineseRevivalist = 4;
								App.UI.reload();
							}
						)
					);
					r.push(`is a vision of ancient China.`);
				} else {
					/* <span class="note"><span style="font-weight:Bold">Chinese Revivalism:</span> a vision of ancient China.</span>*/
				}
			}
		}
		App.Events.addNode(p, r, "div");
		el.append(p);

		return el;

		function pursuit() {
			return App.UI.DOM.makeElement("span", "You are pursuing", "bold");
		}

		/**
		 *
		 * @param {FC.FutureSociety} FS
		 * @param {Array} [itemArray]
		 */
		function activeFS(FS, itemArray) {
			const el = new DocumentFragment();
			const r = [];

			// Abandon
			if (FS === "FSRestart" && V.eugenicsFullControl !== 1) {
				r.push(`The Societal Elite will not permit you to abandon Eugenics.`);
			} else {
				r.push(
					App.UI.DOM.link(
						"Abandon",
						() => {
							FutureSocieties.remove(FS);
							App.UI.reload();
						}
					)
				);
			}

			// Decoration
			r.push(App.UI.FSChangeDecoration(FS, itemArray));

			// Assistant
			if (V.policies.publicPA === 1) {
				if (App.Data.Assistant.appearanceForFS.get(FS).includes(V.assistant.appearance)) {
					const {hisA} = getPronouns(assistant.pronouns().main).appendSuffix('A');
					r.push(`With ${hisA} ${V.assistant.appearance} appearance,`);
					r.push(
						App.UI.DOM.passageLink(V.assistant.name, "Personal assistant options")
					);
					r.push(`is a good public mascot for this goal.`);
				}
			}

			App.Events.addNode(el, r);
			return el;
		}
	}
};
