App.UI.multiImplant = function() {
	const frag = document.createDocumentFragment();

	let r = [];
	r.push("You head down to your");
	if (V.surgeryUpgrade === 1) {
		r.push("heavily upgraded and customized");
	}
	r.push("remote surgery and start having the slaves with");
	if (V.completedOrgans.length > 0 && V.adjustProstheticsCompleted > 0) {
		r.push("organs or prosthetics");
	} else if (V.completedOrgans.length > 1) {
		r.push("organs");
	} else if (V.adjustProstheticsCompleted > 1) {
		r.push("prosthetics");
	}
	r.push("that are ready be sent down.");

	App.UI.DOM.appendNewElement("p", frag, r.join(" "));

	App.UI.DOM.appendNewElement("h1", frag, "Implant Organs");

	let F = App.Medicine.OrganFarm;
	for (const slave of V.slaves) {
		let sortedOrgans = F.getSortedOrgans(slave);
		if (sortedOrgans.length === 0) {
			continue;
		}

		App.UI.DOM.appendNewElement("h2", frag, slave.slaveName);

		for (let j = 0; j < sortedOrgans.length; j++) {
			App.UI.DOM.appendNewElement("h3", frag, F.Organs.get(sortedOrgans[j]).name);

			let actions = F.Organs.get(sortedOrgans[j]).implantActions;
			let manual = false;
			let success = false;
			let cancel = false;
			for (let k = 0; k < actions.length; k++) {
				if (!actions[k].autoImplant) {
					if (actions[k].canImplant(slave)) {
						manual = true;
					}
					continue;
				}
				if (!actions[k].canImplant(slave)) {
					let error = actions[k].implantError(slave);
					if (error !== "") {
						App.UI.DOM.appendNewElement("div", frag, error, "warning");
					}
				} else if (slave.health.health - actions[k].healthImpact < -75) {
					App.UI.DOM.appendNewElement("div", frag, "Estimated health impact too high, skipping further surgeries.");
					cancel = true;
					break;
				} else {
					App.Medicine.OrganFarm.implant(slave, sortedOrgans[j], k);
					App.UI.DOM.appendNewElement("p", frag, App.UI.SlaveInteract.surgeryDegradation(slave));
					success = true;
				}
			}
			if (cancel) { break; }
			if (!success && manual) {
				App.UI.DOM.appendNewElement("div", frag, `Cannot implant ${F.Organs.get(sortedOrgans[j]).name.toLowerCase()} automatically, try implanting manually in the remote surgery.`, "note");
			}
		}
	}
	return frag;
};
