/**
 * @param {App.Entity.SlaveState} slave
 * @returns {HTMLParagraphElement}
 */
App.UI.SlaveInteract.navigation = function(slave) {
	const p = document.createElement("p");
	p.classList.add("center");

	if (V.cheatMode) {
		App.UI.DOM.appendNewElement("div", p,
			App.UI.DOM.passageLink("Cheat Edit Slave", "Cheat Edit JS", () => {
				V.cheater = 1;
				delete V.tempSlave;
			}),
			"note"
		);
	}

	App.UI.DOM.appendNewElement("span", p, App.UI.Hotkeys.hotkeys("prev-slave"), "hotkey");
	const prevSpan = App.UI.DOM.makeElement("span", App.UI.DOM.passageLink("Prev", "Slave Interact",
		() => { V.AS = App.UI.SlaveInteract.placeInLine(slave)[0]; }), "adjacent-slave");
	prevSpan.id = "prev-slave";
	p.append(" ", prevSpan);

	const centerSpan = document.createElement("span");
	centerSpan.classList.add("interact-name");

	App.UI.DOM.appendNewElement("span", centerSpan, slave.slaveName, "slave-name");
	centerSpan.append(" ", App.UI.favoriteToggle(slave));
	p.append(centerSpan);

	const nextSpan = App.UI.DOM.makeElement("span", App.UI.DOM.passageLink("Next", "Slave Interact",
		() => { V.AS = App.UI.SlaveInteract.placeInLine(slave)[1]; }), "adjacent-slave");
	nextSpan.id = "next-slave";
	p.append(nextSpan, " ");
	App.UI.DOM.appendNewElement("span", p, App.UI.Hotkeys.hotkeys("next-slave"), "hotkey");

	return p;
};
