App.UI.neighborDescription = function(i) {
// :: Neighbor Description [nobr]
	const el = new DocumentFragment();
	let r = [];
	r.push(App.UI.DOM.makeElement("span", V.arcologies[i].name, "bold"));
	if (V.arcologies[i].direction !== 0) {
		r.push(`is located to the ${V.arcologies[i].direction} of your arcology. It is governed by`);
		switch (V.arcologies[i].government) {
			case "elected officials":
				r.push(`elected officials, periodically paralyzing its development.`);
				break;
			case "a committee":
				r.push(`a committee, hindering its development.`);
				break;
			case "an oligarchy":
				r.push(`a small group of leading citizens, making its development very unpredictable.`);
				break;
			case "your trustees":
				r.push(`a small group of leading citizens who are serving as <span class="mediumseagreen">your trustees.</span>`);
				break;
			case "an individual":
				r.push(`<span class="cyan">an individual,</span> making its development vibrant but unpredictable.`);
				break;
			case "your agent":
				r.push(`<span class="deeppink">your agent,</span> who is directing the arcology in your stead.`);
				break;
			case "a corporation":
				r.push(`a corporation, making its development steady and unspectacular.`);
				break;
			default:
				r.push(`direct democracy, making its development dangerously unstable.`);
		}
	} else {
		r.push(`is your arcology.`);
	}
	let _economicUncertainty = App.Utils.economicUncertainty(i);
	if (V.arcologies[i].direction === 0) {
		r.push(`You control <span class="lime">${V.arcologies[i].ownership}%</span> of the arcology, and the largest minority holder controls <span class="orange">${V.arcologies[i].minority}%.</span>`);
	} else if ((V.arcologies[i].government !== "your trustees") && (V.arcologies[i].government !== "your agent")) {
		r.push(`Its leadership has control of approximately <span class="orange">${Math.trunc(V.arcologies[i].ownership*_economicUncertainty)}%</span> of the arcology${(V.arcologies[i].minority > V.arcologies[i].ownership-10) ? `, a dangerously narrow margin over competition with a <span class="tan">${Math.trunc(V.arcologies[i].minority*_economicUncertainty)}%</span> share` : ``}.`);
	}
	if (V.arcologies[i].PCminority > 0) {
		r.push(`You own <span class="lime">${V.arcologies[i].PCminority}%</span> of this arcology${(((V.arcologies[i].government === "your trustees") || (V.arcologies[i].government === "your agent")) && V.arcologies[i].minority > V.arcologies[i].PCminority-10) ? `, a dangerously narrow margin over competition with a <span class="red">${Math.trunc(V.arcologies[i].minority*_economicUncertainty)}%</span> share` : ``}.`);
	}
	r.push(`The arcology has an estimated GSP of <span class="yellowgreen">${cashFormat(Math.trunc(0.1*V.arcologies[i].prosperity*_economicUncertainty))}m,</span>`);
	if (Math.abs(V.arcologies[i].prosperity - V.averageProsperity) < 5) {
		r.push(`average among`);
	} else if (V.arcologies[i].prosperity > V.averageProsperity) {
		r.push(`ahead of`);
	} else {
		r.push(`behind`);
	}
	r.push(`its neighbors.`);

	let desc = "";
	const _neighborDescription = [];
	if (V.arcologies[i].FSSubjugationist !== "unset") {
		if (V.arcologies[i].FSSubjugationist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSSubjugationist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Racial Subjugationism,</span> and is `;
		if (V.arcologies[i].FSSubjugationist > 95) {
			desc += `the home of an advanced project to create a subservient race of ${V.arcologies[i].FSSubjugationistRace} slaves.`;
		} else if (V.arcologies[i].FSSubjugationist > 40) {
			desc += `working to refine ${V.arcologies[i].FSSubjugationistRace} slavery.`;
		} else {
			desc += `an excellent dumping ground for low quality ${V.arcologies[i].FSSubjugationistRace} slaves.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSSupremacist !== "unset") {
		if (V.arcologies[i].FSSubjugationist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSSubjugationist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Racial Supremacism,</span> and is `;
		if (V.arcologies[i].FSSubjugationist > 95) {
			desc += `a global magnet for ${V.arcologies[i].FSSupremacistRace} nationalists.`;
		} else if (V.arcologies[i].FSSubjugationist > 40) {
			desc += `becoming increasingly free of ${V.arcologies[i].FSSupremacistRace} slaves.`;
		} else {
			desc += `the site of a furious debate over existing ${V.arcologies[i].FSSupremacistRace} slaves.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSRepopulationFocus !== "unset") {
		if (V.arcologies[i].FSRepopulationFocus > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSRepopulationFocus > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Repopulation,</span> and is `;
		if (V.arcologies[i].FSRepopulationFocus > 95) {
			desc += `notorious for the size and number of pregnancies among its population.`;
		} else if (V.arcologies[i].FSRepopulationFocus > 40) {
			desc += `known to be a good place to find slavegirls heavy with children.`;
		} else {
			desc += `actively importing fertile slave girls.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSRestart !== "unset") {
		if (V.arcologies[i].FSRestart > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSRestart > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Eugenics,</span> and is `;
		if (V.arcologies[i].FSRestart > 95) {
			desc += `notorious for the number of powerful civilians inhabiting it.`;
		} else if (V.arcologies[i].FSRestart > 40) {
			desc += `known to be a good place to make connections.`;
		} else {
			desc += `actively importing sterilization supplies.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSGenderRadicalist !== "unset") {
		if (V.arcologies[i].FSGenderRadicalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSGenderRadicalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Gender Radicalism,</span> and is `;
		if (V.arcologies[i].FSGenderRadicalist > 95) {
			desc += `notorious for the openness with which its citizens fuck its slavegirls in the ass until they cum.`;
		} else if (V.arcologies[i].FSGenderRadicalist > 40) {
			desc += `known to be a good place to find slavegirls who cum when buttfucked.`;
		} else {
			desc += `actively importing a wider variety of slave girls.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSGenderFundamentalist !== "unset") {
		if (V.arcologies[i].FSGenderFundamentalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSGenderFundamentalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Gender Fundamentalism,</span> and is `;
		if (V.arcologies[i].FSGenderFundamentalist > 95) {
			desc += `famous for its slave schools, crowded with a future generation of world class slaves.`;
		} else if (V.arcologies[i].FSGenderFundamentalist > 40) {
			desc += `remarkable for its crowds of hugely pregnant slave women.`;
		} else {
			desc += `importing increasing numbers of fertile slaves.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSPaternalist !== "unset") {
		if (V.arcologies[i].FSPaternalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSPaternalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Paternalism,</span> and is `;
		if (V.arcologies[i].FSPaternalist > 95) {
			desc += `the home of an educated, enlightened caste of slaves more productive than some arcologies' citizens.`;
		} else if (V.arcologies[i].FSPaternalist > 40) {
			desc += `becoming known for its unusually cheerful atmosphere.`;
		} else {
			desc += `starting to demand abused slaves whose lives can be turned around.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSDegradationist !== "unset") {
		if (V.arcologies[i].FSDegradationist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSDegradationist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Degradationism,</span> and is `;
		if (V.arcologies[i].FSDegradationist > 95) {
			desc += `renowned and feared by slaves worldwide, as a place of blood and steel from which few ever leave.`;
		} else if (V.arcologies[i].FSDegradationist > 40) {
			desc += `becoming dreaded by slaves, since the few it exports are full of unbelievably awful stories.`;
		} else {
			desc += `importing a rapidly increasing number of slaves, for some reason.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSIntellectualDependency !== "unset") {
		if (V.arcologies[i].FSIntellectualDependency > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSIntellectualDependency > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Intellectual Dependency,</span> and is `;
		if (V.arcologies[i].FSIntellectualDependency > 95) {
			desc += `both terrifying and alluring to slaves worldwide, as a place where none leave with any semblance of intelligence but always flaunt the enjoyment they've had.`;
		} else if (V.arcologies[i].FSIntellectualDependency > 40) {
			desc += `becoming known for its unusually simple-minded chattel.`;
		} else {
			desc += `importing large quantities of aphrodisiacs and psychosuppressants.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSSlaveProfessionalism !== "unset") {
		if (V.arcologies[i].FSSlaveProfessionalism > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSSlaveProfessionalism > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Slave Professionalism,</span> and is `;
		if (V.arcologies[i].FSSlaveProfessionalism > 95) {
			desc += `renowned as a source of some of the world's finest courtesans.`;
		} else if (V.arcologies[i].FSSlaveProfessionalism > 40) {
			desc += `becoming revered as an intellectual paradise.`;
		} else {
			desc += `seeking out high-class slave trainers.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSBodyPurist !== "unset") {
		if (V.arcologies[i].FSBodyPurist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSBodyPurist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Body Purism,</span> and is `;
		if (V.arcologies[i].FSBodyPurist > 95) {
			desc += `a world leader in the drug industry due to its pharmaceutical research breakthroughs.`;
		} else if (V.arcologies[i].FSBodyPurist > 40) {
			desc += `pouring an ever increasing amount of money into drug research.`;
		} else {
			desc += `setting up research programs to develop better slave drugs.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSTransformationFetishist !== "unset") {
		if (V.arcologies[i].FSTransformationFetishist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSTransformationFetishist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Transformation Fetishism,</span> and is `;
		if (V.arcologies[i].FSTransformationFetishist > 95) {
			desc += `renowned as the source of some of the world's most unbelievable surgical transformations.`;
		} else if (V.arcologies[i].FSTransformationFetishist > 40) {
			desc += `rapidly moving from mere breast expansion to more esoteric surgical fetishism.`;
		} else {
			desc += `receiving daily shipments of silicone and surgical necessities.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSYouthPreferentialist !== "unset") {
		if (V.arcologies[i].FSYouthPreferentialist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSYouthPreferentialist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Youth Preferentialism,</span> and is `;
		if (V.arcologies[i].FSYouthPreferentialist > 95) {
			desc += `famous for the intense celebratory attention slaves receive there once reaching their majorities.`;
		} else if (V.arcologies[i].FSYouthPreferentialist > 40) {
			desc += `moving virginity and the taking of virginity ever higher in the public estimation.`;
		} else {
			desc += `starting to get a reputation as an excellent place to get a good price for a virgin.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSMaturityPreferentialist !== "unset") {
		if (V.arcologies[i].FSMaturityPreferentialist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSMaturityPreferentialist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Maturity Preferentialism,</span> and is `;
		if (V.arcologies[i].FSMaturityPreferentialist > 95) {
			desc += `world famous among mature slaves, who see it as a paradise in which MILFs are the most valuable girls around.`;
		} else if (V.arcologies[i].FSMaturityPreferentialist > 40) {
			desc += `striking for the variety of well-preserved beauties that can be seen there.`;
		} else {
			desc += `displaying an increasing demand for enslaved housewives and professional women.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSPetiteAdmiration !== "unset") {
		if (V.arcologies[i].FSPetiteAdmiration > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSPetiteAdmiration > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Petite Admiration,</span> and is `;
		if (V.arcologies[i].FSPetiteAdmiration > 95) {
			desc += `known as a place where even the shortest person can feel tall.`;
		} else if (V.arcologies[i].FSPetiteAdmiration > 40) {
			desc += `investing large sums of money into petite clothing lines.`;
		} else {
			desc += `starting to accumulate an unusually large number of short slaves.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSStatuesqueGlorification !== "unset") {
		if (V.arcologies[i].FSStatuesqueGlorification > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSStatuesqueGlorification > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Statuesque Glorification,</span> and is `;
		if (V.arcologies[i].FSStatuesqueGlorification > 95) {
			desc += `world famous among tall slaves, who see it as a paradise in which they are valued above all.`;
		} else if (V.arcologies[i].FSStatuesqueGlorification > 40) {
			desc += `going out of its way to import only the tallest of slaves.`;
		} else {
			desc += `starting to drive out its shorter citizenry.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSSlimnessEnthusiast !== "unset") {
		if (V.arcologies[i].FSSlimnessEnthusiast > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSSlimnessEnthusiast > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Slimness Enthusiasm,</span> and is `;
		if (V.arcologies[i].FSSlimnessEnthusiast > 95) {
			desc += `very well known for the wonderful variety of nubile bodies that can be seen there.`;
		} else if (V.arcologies[i].FSSlimnessEnthusiast > 40) {
			desc += `becoming known as an arcology that slims slaves down rather than turning them into piles of tits and ass.`;
		} else {
			desc += `starting to display unusual fashions regarding breasts and butts.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSAssetExpansionist !== "unset") {
		if (V.arcologies[i].FSAssetExpansionist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSAssetExpansionist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Asset Expansionism,</span> and is `;
		if (V.arcologies[i].FSAssetExpansionist > 95) {
			desc += `widely considered an interior design masterpiece for its adaptations to slaves with fifty kilos of tits.`;
		} else if (V.arcologies[i].FSAssetExpansionist > 40) {
			desc += `a popular tourist destination just for the view, which features some truly spectacular bare boobs.`;
		} else {
			desc += `demanding fatter slaves, since its citizens are learning they absorb growth hormones better.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSPastoralist !== "unset") {
		if (V.arcologies[i].FSPastoralist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSPastoralist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Pastoralist,</span> and is `;
		if (V.arcologies[i].FSPastoralist > 95) {
			desc += `a world-renowned producer of cowgirl dairy products of all kinds.`;
		} else if (V.arcologies[i].FSPastoralist > 40) {
			desc += `devoting more and more of its slaves to work as cowgirls, or to the service and upkeep of cowgirls.`;
		} else {
			desc += `displaying an increasing public appetite for dairy, and yet imports almost no true cow's milk.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSCummunism !== "unset") {
		if (V.arcologies[i].FSCummunism > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSCummunism > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Cummunism,</span> and is `;
		if (V.arcologies[i].FSCummunism > 95) {
			desc += `a world-renowned producer of cum-based products of all kinds.`;
		} else if (V.arcologies[i].FSCummunism > 40) {
			desc += `devoting more and more of its slaves to work as cumtanks, or to the service, upkeep and milking of ballgirls.`;
		} else {
			desc += `displaying an increasing public appetite for cum, and has begun importing more and more specialized milkers.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSPhysicalIdealist !== "unset") {
		if (V.arcologies[i].FSPhysicalIdealist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSPhysicalIdealist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Physical Idealism,</span> and is `;
		if (V.arcologies[i].FSPhysicalIdealist > 95) {
			desc += `a constant standout at international athletic competitions, where both its citizens and slaves do very well.`;
		} else if (V.arcologies[i].FSPhysicalIdealist > 40) {
			desc += `quite a sight, since its citizens and slaves all lift. Constantly.`;
		} else {
			desc += `the site of a musclegirl fetish community.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSHedonisticDecadence !== "unset") {
		if (V.arcologies[i].FSHedonisticDecadence > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSHedonisticDecadence > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Hedonistic Decadence,</span> and is `;
		if (V.arcologies[i].FSHedonisticDecadence > 95) {
			desc += `very well known as a place where every imaginable desire and fantasy can be fulfilled.`;
		} else if (V.arcologies[i].FSHedonisticDecadence > 40) {
			desc += `importing huge amounts of food and alcohol`;
		} else {
			desc += `the site of a large number of lazy individuals.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSIncestFetishist !== "unset") {
		if (V.arcologies[i].FSIncestFetishist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSIncestFetishist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Incest Fetishism,</span> and is `;
		if (V.arcologies[i].FSIncestFetishist > 95) {
			desc += `highly recommended as a place to stop by if you like threesomes with twins or familial gangbangs.`;
		} else if (V.arcologies[i].FSIncestFetishist > 40) {
			desc += `attracting a substantial number of families.`;
		} else {
			desc += `devoting more and more of its resources into genealogy.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSChattelReligionist !== "unset") {
		if (V.arcologies[i].FSChattelReligionist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSChattelReligionist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Chattel Religionism,</span> and is `;
		if (V.arcologies[i].FSChattelReligionist > 95) {
			desc += `a significant force in the global development of Chattel Religionist dogma.`;
		} else if (V.arcologies[i].FSChattelReligionist > 40) {
			desc += `a popular destination for devout old world citizens engaging in sex tourism.`;
		} else {
			desc += `in the throes of public dissension over its religious laws.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSRomanRevivalist !== "unset") {
		if (V.arcologies[i].FSRomanRevivalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSRomanRevivalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Roman Revivalism,</span> and is `;
		if (V.arcologies[i].FSRomanRevivalist > 95) {
			desc += `hugely famous for its broadcasts of gladiatorial combat, popular even in the old world.`;
		} else if (V.arcologies[i].FSRomanRevivalist > 40) {
			desc += `almost obnoxiously aspirational, with citizens competing to serve the state best.`;
		} else {
			desc += `working its way through sword and sandals fashion towards proper historicity.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSNeoImperialist !== "unset") {
		if (V.arcologies[i].FSNeoImperialist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSNeoImperialist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Neo-Imperialism,</span> and is `;
		if (V.arcologies[i].FSNeoImperialist > 95) {
			desc += `utterly hierarchical, with techno-nobles holding near complete control over the very lives of the masses and powerful Knights in heavy powered plate keeping them firmly in line.`;
		} else if (V.arcologies[i].FSNeoImperialist > 40) {
			desc += `increasingly syncretic, integrating the highest technology with total, unrepentant serfdom under tight-fisted techno-nobles and a rising class of elite Knights serving as the sword of the nobility.`;
		} else {
			desc += `creating an extremely strict hierarchical system, with an elite caste of techno-nobility cementing itself through a series of complicated, emergent feudal dynamics.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSAztecRevivalist !== "unset") {
		if (V.arcologies[i].FSAztecRevivalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSAztecRevivalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Aztec Revivalism,</span> and is `;
		if (V.arcologies[i].FSAztecRevivalist > 95) {
			desc += `world famous for its incredible architecture and highly qualified leading caste and military.`;
		} else if (V.arcologies[i].FSAztecRevivalist > 40) {
			desc += `constructing great pyramids and statues with equally weighty costs.`;
		} else {
			desc += `struggling to embrace the amount of blood sacrifice and prayer involved.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSEgyptianRevivalist !== "unset") {
		if (V.arcologies[i].FSEgyptianRevivalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSEgyptianRevivalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Egyptian Revivalism,</span> and is `;
		if (V.arcologies[i].FSEgyptianRevivalist > 95) {
			desc += `a world famous tourist destination for the traditional festival in its plaza, which never stops.`;
		} else if (V.arcologies[i].FSEgyptianRevivalist > 40) {
			desc += `very much under renovation, as vast blocks of stone are imported around the clock.`;
		} else {
			desc += `struggling with the fashion implications of so much white linen everywhere.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSEdoRevivalist !== "unset") {
		if (V.arcologies[i].FSEdoRevivalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSEdoRevivalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Edo Revivalism,</span> and is `;
		if (V.arcologies[i].FSEdoRevivalist > 95) {
			desc += `visibly trailing cherry blossoms, blown off its balconies by the wind.`;
		} else if (V.arcologies[i].FSEdoRevivalist > 40) {
			desc += `becoming a notable cultural center, even in the old world.`;
		} else {
			desc += `the object of considerable debate among socially awkward teenagers worldwide.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSArabianRevivalist !== "unset") {
		if (V.arcologies[i].FSArabianRevivalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSArabianRevivalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Arabian Revivalism,</span> and is `;
		if (V.arcologies[i].FSArabianRevivalist > 95) {
			desc += `a famous center of Arabian romanticism, since it has the wisdom not to be historically perfect.`;
		} else if (V.arcologies[i].FSArabianRevivalist > 40) {
			desc += `working through which parts of Arabian romanticism to adopt and which to discard.`;
		} else {
			desc += `eagerly reveling in the most romantic parts of superficial Arabian romanticism.`;
		}
		_neighborDescription.push(desc);
	}
	if (V.arcologies[i].FSChineseRevivalist !== "unset") {
		if (V.arcologies[i].FSChineseRevivalist > 80) {
			desc = "committed to ";
		} else if (V.arcologies[i].FSChineseRevivalist > 20) {
			desc = "pursuing ";
		} else {
			desc = "just establishing ";
		}
		desc += `<span class="gold">Chinese Revivalism,</span> and is `;
		if (V.arcologies[i].FSChineseRevivalist > 95) {
			desc += `now confidently mature about its possession of the Mandate of Heaven.`;
		} else if (V.arcologies[i].FSChineseRevivalist > 40) {
			desc += `often aggressive about its status as the middle kingdom to the point that it betrays uncertainty.`;
		} else {
			desc += `moving towards a stage of refinement that will allow it to present itself properly.`;
		}
		_neighborDescription.push(desc);
	}

	if (_neighborDescription.length > 0) {
		if (_neighborDescription.length > 2) {
			r.push(`Its culture is complex. First, it is ${_neighborDescription[0]}`);
			for (let j = 1; j < _neighborDescription.length; j++) {
				if (j < _neighborDescription.length-1) {
					r.push(`It is`);
				} else {
					r.push(`Finally, the arcology is`);
				}
				r.push(`${_neighborDescription[j]}`);
			}
		} else if (_neighborDescription.length === 2) {
			r.push(`Its culture is developing along two lines. First, it is ${_neighborDescription[0]} Second, it is ${_neighborDescription[1]}`);
		} else {
			r.push(`Its culture is diverging from the old world: it is ${_neighborDescription[0]}`);
		}
	}
	App.Events.addNode(el, r, "div");
	return el;
};
